program Calc_eig  !
  ! RETURNS SECOND SMALLEST EIGENVECTOR FOR A SPARSE MATRIX USING ARPACK  
  ! Jesse Lomask 9/15/2004

  use sep
  use paint_mod
  ! use random_mod
  ! use sorting_mod
  ! use lint2
  ! use warp_mod


  implicit none


  character                         :: bmat*1, which*2

  integer                           ::nt,nx,it,ix,ir,ncv_val
  integer                           ::nev,ndv,ishfts,maxitr,mode,maxn,maxncv
  integer                           ::lworkl,info,ido,ncv,n,ldv,nonzero,ierr
  integer                           ::j,nconv,inonzero,d_vec_count,sparse_index
  integer                           ::maxnev,five_percent,non_zero_mask
  integer                           ::average_int,ave_cnt,total_sparse
  !  integer, dimension(:)    ::iparam(11),ipntr(11)
  ! integer, dimension(:),pointer    ::iparam,ipntr
  integer, dimension(:),allocatable    ::iparam,ipntr
  logical                           ::rvec
  logical,dimension(:),allocatable  ::select_lg

  real                              ::tol,zero,sigma,snrm2,dt,dx,ot,ox
  real,dimension(:),allocatable        ::workl,workd,resid,ax,resid_ar,outvec,outvec2
  real,dimension(:),allocatable       ::d_vec_exp
  real, dimension(:,:),allocatable    ::v, d_ar,look_up_tab,outvec_2d
  real, allocatable, dimension(:,:) ::DDminusWD


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n1",total_sparse)
  call from_history("nt",nt)
  call from_history("nx",nx)
  call from_history("ot",ot)
  call from_history("ox",ox)
  call from_history("dt",dt)
  call from_history("dx",dx)


  call from_history("non_zero_mask",non_zero_mask)
  call from_history("ncv_val",ncv_val,20)

  write(0,*) 'nt',nt,'nx',nx,'ncv_val',ncv_val
  write(0,*) 'total_sparse',total_sparse,'non_zero_mask',non_zero_mask

  ! ALLOCATE INPUT DATA AND MASK
  allocate(DDminusWD(total_sparse,3),look_up_tab(non_zero_mask,3),d_vec_exp(non_zero_mask)) 
  !allocate(iparam_base(11),ipntr_base(11))
  allocate(iparam(11),ipntr(11))
!!$nullify(iparam)
!!$iparam=0.
!!$ipntr=0.
  ! READ IN SPARSE MATRIX
  call sep_read(DDminusWD)

  ! READ IN LOOK-UP TABLE TO CONVERT THE EIGENVECTOR TO IMAGE
  call sreed("look_up", look_up_tab, 4*non_zero_mask*3) 
  call sreed("d_vec_exp", d_vec_exp, 4*non_zero_mask*3) 

  ! SET PARAMETERS FOR ARPACK
  maxn=non_zero_mask
  maxncv=100
  ! maxncv=1000 
  n=non_zero_mask  
  nev =2
  ncv =ncv_val 
  ncv= min(max(2*nev+1,20),n)
  !ncv=1000 ! delete!

  write(0,*) 'ncv',ncv
  maxnev=10 

  ! ALLOCATE FOR ARPACK
  allocate(v(maxn,maxncv),workl(maxncv*(maxncv*8)),workd(3*maxn))
  allocate(d_ar(maxncv,2),resid_ar(maxn),ax(maxn))
  allocate(outvec(non_zero_mask))
  d_ar=0.

  if ( n .gt. maxn ) then
     write(0,*)  ' ERROR with _SDRV1: N is greater than MAXN '
     go to 9000
  else if ( nev .gt. maxnev ) then
     write(0,*)  ' ERROR with _SDRV1: NEV is greater than MAXNEV '
     go to 9000
  else if ( ncv .gt. maxncv ) then
     write(0,*)  ' ERROR with _SDRV1: NCV is greater than MAXNCV '
     go to 9000
  end if


  write(0,*) 'starting eigenvalue computations'

  ldv=maxn
  bmat = 'I'
  which = 'SA'
  lworkl = ncv*(ncv+8)
  tol = zero 
  write(0,*) 'tol',zero
  info=1

  info=0   ! initialize with random numbers
  ido = 0

  write(0,*) 'info',info

  ishfts = 1
  maxitr = 300 
  maxitr=max(300,ceiling(real(2*n/max(ncv,1)) ))

  mode   = 1

  iparam(1) = ishfts 
  iparam(3) = maxitr 
  iparam(7) = mode 
  !  resid_ar=0

  write(0,*) 'n',n

  write(0,*) 'ido ', ido
  write(0,*)  'bmat ', bmat
  write(0,*)  'n ', n
  write(0,*) 'which ', which
  write(0,*) 'nev ', nev
  write(0,*) 'tol ', tol
  !       write(0,*)  'resid_ar ', resid_ar
  write(0,*)  'ncv ', ncv
  !        write(0,*)  'v ', v
  write(0,*)  'ldv ', ldv   
  write(0,*)  'iparam ', iparam
!!$  !  write(0,*)  'ipntr ', ipntr
  !       write(0,*) 'workd ', workd
  !      write(0,*)  'workl ', workl
  write(0,*)  'lworkl ', lworkl
  write(0,*)  'info ', info


!!$ 

  it=0
10 continue
  it=it+1
  write(0,*) 'iteration',it
  ! write(0,*) 'iparam',iparam
  ! write(0,*) 'ipntr',ipntr

  call ssaupd ( ido, bmat, n, which, nev, tol, resid_ar,ncv, v, ldv, iparam, ipntr, workd, workl,lworkl, info )
  write(0,*)  'info ', info
  write(0,*)  'ido ', ido
!!$if (it<200) then
!!$ info=0;ido=1 !DELETE ME
!!$else
!!$ info=0;ido=99
!!$end if 


if (it==500) ido=99  !info=99.

  if (ido .eq. -1 .or. ido .eq. 1) then

     call sparse_mat_mult2(DDminusWD, workd(ipntr(1):ipntr(1)+non_zero_mask-1), workd(ipntr(2):ipntr(2)+non_zero_mask-1),non_zero_mask)

     go to 10
  end if

  if ( info .lt. 0.) then
     write(0,*)  ' '
     write(0,*)  ' Error with _saupd, info = ', info
     write(0,*) ' Check documentation in _saupd '
     write(0,*)  ' '
  else 
     write(0,*) 'rvec=true'
     rvec = .true.
     allocate(select_lg(maxncv))


     call sseupd ( rvec, 'All', select_lg, d_ar, v, ldv, sigma,bmat, n, which, nev, tol, resid, ncv, v, ldv,iparam, ipntr, workd, workl, lworkl, ierr )

     !if ( it==200) then
     if ( ierr .ne. 0) then

        write(0,*)  ' '
        write(0,*)  ' Error with _seupd, info = ', ierr
        write(0,*)  ' Check the documentation of _seupd. '
        write(0,*)  ' '

     else

        nconv =  iparam(5)
        write(0,*) 'nconv', nconv
        do 20 j=1, nconv

           call sparse_mat_mult2(DDminusWD,v(1:non_zero_mask,j),ax,non_zero_mask)

           call saxpy(n, -d_ar(j,1), v(1,j), 1, ax, 1)
           d_ar(j,2) = snrm2(n, ax, 1)
           d_ar(j,2) = d_ar(j,2) / abs(d_ar(j,1))

20         continue

           call smout(6, nconv, 2, d_ar, maxncv, -6, 'Ritz values and relative residuals')

        end if


        if ( info .eq. 1) then
           write(0,*) ' '
           write(0,*) ' Maximum number of iterations reached.'
           write(0,*) ' '
        else if ( info .eq. 3) then
           write(0,*) ' ' 
           write(0,*) ' No shifts could be applied during implicit',\
           ' Arnoldi update, try increasing NCV.'
           write(0,*) ' '
        end if

        write(0,*) ' '
        write(0,*) ' _SDRV1 '
        write(0,*) ' ====== '
        write(0,*) ' '
        write(0,*) ' Size of the matrix is ', n
        write(0,*) ' The number of Ritz values requested is ', nev
        write(0,*) ' The number of Arnoldi vectors generated',\
        ' (NCV) is ', ncv
        write(0,*) ' What portion of the spectrum: ', which
        write(0,*) ' The number of converged Ritz values is ', \
        nconv 
        write(0,*)  ' The number of Implicit Arnoldi update',\
        ' iterations taken is ', iparam(3)
        write(0,*) ' The number of OP*x is ', iparam(9)
        write(0,*) ' The convergence criterion is ', tol
        write(0,*) ' '


     end if !!!!!uncertain


     write(0,*) 'size of v/max/min/sum/ave',size(v),maxval(v),minval(v),sum(v),sum(v)/size(v)

9000 continue


     write(0,*) 'nt,nx',nt,nx,non_zero_mask

     ! EXTRACT 2ND SMALLEST EIGENVECTOR
     outvec=v(1:non_zero_mask,2)

!!$     do it=1,size(d_ar(1,1:)) 
!!$        write(0,*) 'it',it
!!$        write(0,*) 'd_ar',d_ar(1,it)
!!$        write(0,*) 'v',v(1:,it)
!!$     end do

     ! CALCULATE D^.5*EIG
     allocate(outvec2(non_zero_mask))
     do ix=1,non_zero_mask
        outvec2(ix)=outvec(ix)*d_vec_exp(ix)
     end do
     !   write(0,*) 'outvec_2d',outvec2

     ! RESHAPE EIGENVECTOR INTO IMAGE
     allocate(outvec_2d(nt,nx))
     do ir=1,non_zero_mask
        outvec_2d(nint(look_up_tab(ir,2)),nint(look_up_tab(ir,3)))=outvec2(ir)
     end do

     ! RITE OUT EIGENVECTOR
     call to_history( "n1", nt);  call to_history( "n2", nx);  call to_history( "n3", 1)
     call to_history( "d1", dt) ;  call to_history( "d2", dx) ;  call to_history( "d3", 1)
     call to_history( "o1", ot);  call to_history( "o2", ox);  call to_history( "o3", 0.)
     call to_history("esize",4);
     call srite("out",outvec_2d,4*nt*nx)

     ! DEALLOCATE
     deallocate(outvec_2d,outvec,outvec2)

   end program Calc_eig

