program Calc_eig_3d  !
  ! RETURNS SECOND SMALLEST EIGENVECTOR FOR A SPARSE MATRIX USING ARPACK  
  ! Jesse Lomask 9/15/2004

  use sep
  use paint_mod3d
  ! use random_mod
  ! use sorting_mod
  ! use lint2
  ! use warp_mod


  implicit none


  character                         :: bmat*1, which*2

  integer                           ::nt,nx,ny,it,ix,ir,ncv_val,mem_alloc
  integer                           ::nev,ndv,ishfts,maxitr,mode,maxn,maxncv
  integer                           ::lworkl,info,ido,ncv,n_len,ldv,nonzero,ierr
  integer                           ::j,nconv,inonzero,d_vec_count,sparse_index
  integer                           ::maxnev,five_percent,non_zero_mask
  integer                           ::average_int,ave_cnt,total_sparse,max_iter

  integer, dimension(:)             ::iparam(11),ipntr(11)

  logical                           ::rvec
  logical,dimension(:),allocatable  ::select_lg

  real                              ::tol,zero,sigma,snrm2
  real                              ::ot,ox,oy,dt,dx,dy
  real,dimension(:) ,allocatable    ::workl,workd,resid,ax,resid_ar,outvec,outvec2
  real,dimension(:)  ,allocatable   ::d_vec_exp,d_diag
  real, dimension(:,:),allocatable  ::v, d_ar,look_up_tab
  real, dimension(:,:,:),allocatable  ::outvec_3d
  !   real, pointer, dimension(:,:)	    ::DDminusWD


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n2",total_sparse)
  call from_history("nt",nt)
  call from_history("nx",nx)
  call from_history("ny",ny)
  call from_history("ot",ot)
  call from_history("ox",ox)
  call from_history("oy",oy)
  call from_history("dt",dt)
  call from_history("dx",dx)
  call from_history("dy",dy)
  call from_history("non_zero_mask",non_zero_mask)
  call from_history("ncv_val",ncv_val,20)
  call from_history("mem_alloc",mem_alloc,175000000)
  call from_history("max_iter",max_iter,200)

  write(0,*) 'nt',nt,'nx',nx,'ny',ny,'ncv_val',ncv_val
  write(0,*) 'total_sparse',total_sparse,'non_zero_mask',non_zero_mask

  ! ALLOCATE INPUT DATA AND MASK
  ! allocate(DDminusWD(total_sparse,3)
  allocate(look_up_tab(non_zero_mask,4),d_vec_exp(non_zero_mask),d_diag(non_zero_mask)) 
  ! READ IN SPARSE MATRIX
  ! call sep_read(DDminusWD)
  write(0,*) 'here1'
  ! READ IN LOOK-UP TABLE TO CONVERT THE EIGENVECTOR TO IMAGE
  call sreed("look_up3d.H", look_up_tab, 4*non_zero_mask*4) 
  call sreed("d_vec_exp3d.H", d_vec_exp, 4*non_zero_mask*3) 
  call sreed("d_diag.H"     ,d_diag     ,4*non_zero_mask*3)

  ! SET PARAMETERS FOR ARPACK
  maxn=non_zero_mask
  maxncv=100 
  n_len=non_zero_mask  
  nev =2
  ncv =ncv_val 
  ncv= min(max(2*nev+1,20),n_len)
  !ncv=5
  write(0,*) 'ncv',ncv
  maxnev=10 

  ! ALLOCATE FOR ARPACK
  allocate(v(maxn,maxncv),workl(maxncv*(maxncv*8)),workd(3*maxn))
  allocate(d_ar(maxncv,2),resid_ar(maxn),ax(maxn))
  allocate(outvec(non_zero_mask))
  d_ar=0.

  if ( n_len .gt. maxn ) then
     write(0,*)  ' ERROR with _SDRV1: N is greater than MAXN '
     go to 9000
  else if ( nev .gt. maxnev ) then
     write(0,*)  ' ERROR with _SDRV1: NEV is greater than MAXNEV '
     go to 9000
  else if ( ncv .gt. maxncv ) then
     write(0,*)  ' ERROR with _SDRV1: NCV is greater than MAXNCV '
     go to 9000
  end if


  write(0,*) 'starting eigenvalue computations'

  ldv=maxn
  bmat = 'I'
  which = 'SA'
  lworkl = ncv*(ncv+8)
  tol = zero 
  write(0,*) 'tol',zero
  info=1

  info=0   ! initialize with random numbers
  ido = 0

  write(0,*) 'info',info

  ishfts = 1
  maxitr = 300
  maxitr=max(300,ceiling(real(2*n_len/max(ncv,1)) ))

  mode   = 1

  iparam(1) = ishfts 
  iparam(3) = maxitr 
  iparam(7) = mode 
  !  resid_ar=0

  write(0,*) 'n',n_len

  write(0,*) 'ido ', ido
  write(0,*)  'bmat ', bmat
  write(0,*)  'n ', n_len
  write(0,*) 'which ', which
  write(0,*) 'nev ', nev
  write(0,*) 'tol ', tol
  !       write(0,*)  'resid_ar ', resid_ar
  write(0,*)  'ncv ', ncv
  !        write(0,*)  'v ', v
  write(0,*)  'ldv ', ldv   
  write(0,*)  'iparam ', iparam
!!$  !  write(0,*)  'ipntr ', ipntr
  !       write(0,*) 'workd ', workd
  !      write(0,*)  'workl ', workl
  write(0,*)  'lworkl ', lworkl
  write(0,*)  'info ', info
call sparse_mat_init()


!!$

  it=0
10 continue
  it=it+1
  write(0,*) 'iteration',it
  call ssaupd ( ido, bmat, n_len, which, nev, tol, resid_ar,ncv, v, ldv, iparam, ipntr, workd, workl,lworkl, info )

  write(0,*)  'info ', info
  write(0,*)  'ido ', ido 
  if (it>max_iter) ido=99
  if (ido .eq. -1 .or. ido .eq. 1) then

     !  call sparse_mat_mult2(DDminusWD, workd(ipntr(1):ipntr(1)+non_zero_mask-1), workd(ipntr(2):ipntr(2)+non_zero_mask-1),non_zero_mask)

     call sparse_mat_mult3(workd(ipntr(1):ipntr(1)+non_zero_mask-1), workd(ipntr(2):ipntr(2)+non_zero_mask-1),mem_alloc,d_diag,d_vec_exp,non_zero_mask,total_sparse)
     go to 10
  end if

  if ( info .lt. 0 ) then
     write(0,*)  ' '
     write(0,*)  ' Error with _saupd, info = ', info
     write(0,*) ' Check documentation in _saupd '
     write(0,*)  ' '
  else 
     write(0,*) 'rvec=true'
     rvec = .true.
     allocate(select_lg(maxncv))


     call sseupd ( rvec, 'All', select_lg, d_ar, v, ldv, sigma,bmat, n_len, which, nev, tol, resid, ncv, v, ldv,iparam, ipntr, workd, workl, lworkl, ierr )
     if ( ierr .ne. 0) then

        write(0,*)  ' '
        write(0,*)  ' Error with _seupd, info = ', ierr
        write(0,*)  ' Check the documentation of _seupd. '
        write(0,*)  ' '

     else

        nconv =  iparam(5)
        write(0,*) 'nconv', nconv
        do 20 j=1, nconv

           !        call sparse_mat_mult2(DDminusWD,v(1:non_zero_mask,j),ax,non_zero_mask)
           call sparse_mat_mult3(v(1:non_zero_mask,j),ax,mem_alloc,d_diag,d_vec_exp,non_zero_mask,total_sparse)
           call saxpy(n_len, -d_ar(j,1), v(1,j), 1, ax, 1)
           d_ar(j,2) = snrm2(n_len, ax, 1)
           d_ar(j,2) = d_ar(j,2) / abs(d_ar(j,1))

20         continue

           call smout(6, nconv, 2, d_ar, maxncv, -6, 'Ritz values and relative residuals')

        end if


        if ( info .eq. 1) then
           write(0,*) ' '
           write(0,*) ' Maximum number of iterations reached.'
           write(0,*) ' '
        else if ( info .eq. 3) then
           write(0,*) ' ' 
           write(0,*) ' No shifts could be applied during implicit',\
           ' Arnoldi update, try increasing NCV.'
           write(0,*) ' '
        end if

        write(0,*) ' '
        write(0,*) ' _SDRV1 '
        write(0,*) ' ====== '
        write(0,*) ' '
        write(0,*) ' Size of the matrix is ', n_len
        write(0,*) ' The number of Ritz values requested is ', nev
        write(0,*) ' The number of Arnoldi vectors generated',\
        ' (NCV) is ', ncv
        write(0,*) ' What portion of the spectrum: ', which
        write(0,*) ' The number of converged Ritz values is ', \
        nconv 
        write(0,*)  ' The number of Implicit Arnoldi update',\
        ' iterations taken is ', iparam(3)
        write(0,*) ' The number of OP*x is ', iparam(9)
        write(0,*) ' The convergence criterion is ', tol
        write(0,*) ' '


     end if !!!!!uncertain


     write(0,*) 'size of v/max/min/sum/ave',size(v),maxval(v),minval(v),sum(v),sum(v)/size(v)

9000 continue


     write(0,*) 'nt,nx',nt,nx,non_zero_mask

     ! EXTRACT 2ND SMALLEST EIGENVECTOR

     outvec=v(1:non_zero_mask,2)

!!$     do it=1,size(d_ar(1,1:)) 
!!$        write(0,*) 'it',it
!!$        write(0,*) 'd_ar',d_ar(1,it)
!!$        write(0,*) 'v',v(1:,it)
!!$     end do

     ! CALCULATE D^.5*EIG
     allocate(outvec2(non_zero_mask))
     do ix=1,non_zero_mask
        outvec2(ix)=outvec(ix)*d_vec_exp(ix)
     end do


     ! RESHAPE EIGENVECTOR INTO IMAGE
     ny=max(1,ny)
     allocate(outvec_3d(nt,nx,ny))
     outvec_3d=0.
     write(0,*) 'nt,nx,ny',nt,nx,ny
!!$     write(0,*) 'maxval(look_up_tab(ir,2))',maxval(look_up_tab(1:,2))
!!$   write(0,*) 'maxval(look_up_tab(ir,3))',maxval(look_up_tab(1:,3))
!!$   write(0,*) 'maxval(look_up_tab(ir,4))',maxval(look_up_tab(1:,4))

     do ir=1,non_zero_mask
        outvec_3d(nint(look_up_tab(ir,2)),nint(look_up_tab(ir,3)),max(1,nint(look_up_tab(ir,4))))=outvec2(ir)
     end do
     !write(0,*) outvec_3d
     ! RITE OUT EIGENVECTOR
     call to_history( "n1", nt);  call to_history( "n2", nx);  call to_history( "n3", ny)
     call to_history( "d1", dt) ;  call to_history( "d2", dx) ;  call to_history( "d3", dy)
     call to_history( "o1", ot);  call to_history( "o2", ox);  call to_history( "o3", oy)
     call to_history("esize",4);
     call srite("out",outvec_3d,4*nt*nx*ny)

     ! DEALLOCATE
!     deallocate(outvec_3d,outvec,outvec2)

   end program Calc_eig_3d

