program Calc_eig_3d  !
  ! RETURNS SECOND SMALLEST EIGENVECTOR FOR A SPARSE MATRIX USING ARPACK  
  ! Jesse Lomask 9/15/2004

  use sep
  use paint_mod3d_mpi
  ! use random_mod
  ! use sorting_mod
  ! use lint2
  ! use warp_mod


  implicit none


  character                         :: bmat*1, which*2

  integer                           ::nt,nx,ny,it,ix,ir,ncv_val,mem_alloc
  integer                           ::nev,ndv,ishfts,maxitr,mode,maxn,maxncv
  integer                           ::lworkl,info,ido,ncv,n_len,ldv,nonzero,ierr
  integer                           ::j,nconv,inonzero,d_vec_count,sparse_index
  integer                           ::maxnev,five_percent,non_zero_mask
  integer                           ::average_int,ave_cnt,total_sparse,max_iter

  integer, dimension(:)             ::iparam(11),ipntr(11)
  integer :: iloop

  logical                           ::rvec
  logical,dimension(:),allocatable  ::select_lg

  real                              ::tol,zero,sigma,snrm2
  real                              ::ot,ox,oy,dt,dx,dy
  real,dimension(:) ,allocatable    ::workl,workd,resid,ax,resid_ar,outvec,outvec2,invec
  real,dimension(:)  ,allocatable   ::d_vec_exp,d_diag
  real, dimension(:,:),allocatable  ::v, d_ar,look_up_tab
  real, dimension(:,:,:),allocatable  ::outvec_3d
  !   real, pointer, dimension(:,:)	    ::DDminusWD
  integer :: impi,nmpi ,stat
  integer status(MPI_STATUS_SIZE) 

  !----------------------------------------------------------------
  call MPI_INIT(stat)
  call set_no_putch()
  call sep_init()
  !----------------------------------------------------------------
  !! init params for MPI
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nmpi,ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, impi,ierr)
  if(impi==0) then
     call MPI_SEP_SEND_ARGS(nmpi,10,0)
  else
     call MPI_SEP_RECEIVE_ARGS()
  end if




  call sparse_mat_init()
  if(impi==0) then
  ! INPUT PARAMETERS
  call from_aux("intag","n2",total_sparse)
  call from_aux("intag","nt",nt)
  call from_aux("intag","nx",nx)
  call from_aux("intag","ny",ny)
  call from_aux("intag","ot",ot)
  call from_aux("intag","ox",ox)
  call from_aux("intag","oy",oy)
  call from_aux("intag","dt",dt)
  call from_aux("intag","dx",dx)
  call from_aux("intag","dy",dy)
  call from_aux("intag","non_zero_mask",non_zero_mask)
  call from_aux("intag","ncv_val",ncv_val,20)
  call from_aux("intag","mem_alloc",mem_alloc,175000000)
  call from_aux("intag","max_iter",max_iter,200)

  call MPI_SEND( non_zero_mask, 1, MPI_INTEGER, impi+1,1001, MPI_COMM_WORLD, ierr )
  call MPI_SEND( total_sparse, 1, MPI_INTEGER, impi+1,1002, MPI_COMM_WORLD, ierr )
    write(0,*) 'nt',nt,'nx',nx,'ny',ny,'ncv_val',ncv_val
    write(0,*) 'total_sparse',total_sparse,'non_zero_mask',non_zero_mask

    allocate(look_up_tab(non_zero_mask,4),d_vec_exp(non_zero_mask),d_diag(non_zero_mask)) 
    ! READ IN LOOK-UP TABLE TO CONVERT THE EIGENVECTOR TO IMAGE
    call sreed("look_up3d.H", look_up_tab, 4*non_zero_mask*4) 
    call sreed("d_vec_exp3d.H", d_vec_exp, 4*non_zero_mask*3) 
    call sreed("d_diag.H"     ,d_diag     ,4*non_zero_mask*3)

    ! SET PARAMETERS FOR ARPACK
    maxn=non_zero_mask
    maxncv=100 
    n_len=non_zero_mask  
    nev =2
    ncv =ncv_val 
    ncv= min(max(2*nev+1,20),n_len)
    !ncv=5
    write(0,*) 'ncv',ncv
    maxnev=10 

    ! ALLOCATE FOR ARPACK
    allocate(v(maxn,maxncv),workl(maxncv*(maxncv*8)),workd(3*maxn))
    allocate(d_ar(maxncv,2),resid_ar(maxn),ax(maxn))
    allocate(outvec(non_zero_mask))
    d_ar=0.

    if ( n_len .gt. maxn ) then
       write(0,*)  ' ERROR with _SDRV1: N is greater than MAXN '
       go to 9000
    else if ( nev .gt. maxnev ) then
       write(0,*)  ' ERROR with _SDRV1: NEV is greater than MAXNEV '
       go to 9000
    else if ( ncv .gt. maxncv ) then
       write(0,*)  ' ERROR with _SDRV1: NCV is greater than MAXNCV '
       go to 9000
    end if


    write(0,*) 'starting eigenvalue computations'

    ldv=maxn
    bmat = 'I'
    which = 'SA'
    lworkl = ncv*(ncv+8)
    tol = zero 
    write(0,*) 'tol',zero
    info=1

    info=0   ! initialize with random numbers
    ido = 0

    write(0,*) 'info',info
  
    ishfts = 1
    maxitr = 300
    maxitr=max(300,ceiling(real(2*n_len/max(ncv,1)) ))

    mode   = 1

    iparam(1) = ishfts 
    iparam(3) = maxitr 
    iparam(7) = mode 
    !  resid_ar=0

    write(0,*) 'n',n_len

    write(0,*) 'ido ', ido
    write(0,*)  'bmat ', bmat
    write(0,*)  'n ', n_len
    write(0,*) 'which ', which
    write(0,*) 'nev ', nev
    write(0,*) 'tol ', tol
    !       write(0,*)  'resid_ar ', resid_ar
      write(0,*)  'ncv ', ncv
    !        write(0,*)  'v ', v
    write(0,*)  'ldv ', ldv   
    write(0,*)  'iparam ', iparam
    write(0,*)  'lworkl ', lworkl
    write(0,*)  'info ', info


!!$

    it=0
  10 continue
    it=it+1
    write(0,*) 'iteration',it
    call ssaupd ( ido, bmat, n_len, which, nev, tol, resid_ar,ncv, v, ldv, iparam, ipntr, workd, workl,lworkl, info )

    write(0,*)  'info ', info
    write(0,*)  'ido ', ido 
    if (it>max_iter) ido=99
    if (ido .eq. -1 .or. ido .eq. 1) then
       call MPI_SEND( 0, 1, MPI_INTEGER, impi+1,32, MPI_COMM_WORLD, ierr )

       !  call sparse_mat_mult2(DDminusWD, workd(ipntr(1):ipntr(1)+non_zero_mask-1), workd(ipntr(2):ipntr(2)+non_zero_mask-1),non_zero_mask)

       call sparse_mat_mult3(workd(ipntr(1):ipntr(1)+non_zero_mask-1), workd(ipntr(2):ipntr(2)+non_zero_mask-1),mem_alloc,d_diag,d_vec_exp,non_zero_mask,total_sparse)
     go to 10
   else
       call MPI_SEND( 1, 1, MPI_INTEGER, impi+1,32, MPI_COMM_WORLD, ierr )
  end if

  if ( info .lt. 0 ) then
     write(0,*)  ' '
     write(0,*)  ' Error with _saupd, info = ', info
     write(0,*) ' Check documentation in _saupd '
     write(0,*)  ' '
  else 
     write(0,*) 'rvec=true'
     rvec = .true.
     allocate(select_lg(maxncv))


     call sseupd ( rvec, 'All', select_lg, d_ar, v, ldv, sigma,bmat, n_len, which, nev, tol, resid, ncv, v, ldv,iparam, ipntr, workd, workl, lworkl, ierr )
     if ( ierr .ne. 0) then

        write(0,*)  ' '
        write(0,*)  ' Error with _seupd, info = ', ierr
        write(0,*)  ' Check the documentation of _seupd. '
        write(0,*)  ' '

     else

        nconv =  iparam(5)
        write(0,*) 'nconv', nconv
        do 20 j=1, nconv

           !        call sparse_mat_mult2(DDminusWD,v(1:non_zero_mask,j),ax,non_zero_mask)
           call sparse_mat_mult3(v(1:non_zero_mask,j),ax,mem_alloc,d_diag,d_vec_exp,non_zero_mask,total_sparse)
           call saxpy(n_len, -d_ar(j,1), v(1,j), 1, ax, 1)
           d_ar(j,2) = snrm2(n_len, ax, 1)
           d_ar(j,2) = d_ar(j,2) / abs(d_ar(j,1))

20         continue

           call smout(6, nconv, 2, d_ar, maxncv, -6, 'Ritz values and relative residuals')

        end if


        if ( info .eq. 1) then
           write(0,*) ' '
           write(0,*) ' Maximum number of iterations reached.'
           write(0,*) ' '
        else if ( info .eq. 3) then
           write(0,*) ' ' 
           write(0,*) ' No shifts could be applied during implicit',\
           ' Arnoldi update, try increasing NCV.'
           write(0,*) ' '
        end if

        write(0,*) ' '
        write(0,*) ' _SDRV1 '
        write(0,*) ' ====== '
        write(0,*) ' '
        write(0,*) ' Size of the matrix is ', n_len
        write(0,*) ' The number of Ritz values requested is ', nev
        write(0,*) ' The number of Arnoldi vectors generated',\
        ' (NCV) is ', ncv
        write(0,*) ' What portion of the spectrum: ', which
        write(0,*) ' The number of converged Ritz values is ', \
        nconv 
        write(0,*)  ' The number of Implicit Arnoldi update',\
        ' iterations taken is ', iparam(3)
        write(0,*) ' The number of OP*x is ', iparam(9)
        write(0,*) ' The convergence criterion is ', tol
        write(0,*) ' '


     end if !!!!!uncertain


     write(0,*) 'size of v/max/min/sum/ave',size(v),maxval(v),minval(v),sum(v),sum(v)/size(v)

9000 continue


     write(0,*) 'nt,nx',nt,nx,non_zero_mask

     ! EXTRACT 2ND SMALLEST EIGENVECTOR

     outvec=v(1:non_zero_mask,2)

!!$     do it=1,size(d_ar(1,1:)) 
!!$        write(0,*) 'it',it
!!$        write(0,*) 'd_ar',d_ar(1,it)
!!$        write(0,*) 'v',v(1:,it)
!!$     end do

     ! CALCULATE D^.5*EIG
     allocate(outvec2(non_zero_mask))
     do ix=1,non_zero_mask
        outvec2(ix)=outvec(ix)*d_vec_exp(ix)
     end do


     ! RESHAPE EIGENVECTOR INTO IMAGE
     ny=max(1,ny)
     allocate(outvec_3d(nt,nx,ny))
     outvec_3d=0.
     write(0,*) 'nt,nx,ny',nt,nx,ny
!!$     write(0,*) 'maxval(look_up_tab(ir,2))',maxval(look_up_tab(1:,2))
!!$   write(0,*) 'maxval(look_up_tab(ir,3))',maxval(look_up_tab(1:,3))
!!$   write(0,*) 'maxval(look_up_tab(ir,4))',maxval(look_up_tab(1:,4))

     do ir=1,non_zero_mask
        outvec_3d(nint(look_up_tab(ir,2)),nint(look_up_tab(ir,3)),max(1,nint(look_up_tab(ir,4))))=outvec2(ir)
     end do
     !write(0,*) outvec_3d
     ! RITE OUT EIGENVECTOR
     call to_history( "n1", nt,"outtag");  call to_history( "n2", nx,"outtag");  call to_history( "n3", ny,"outtag")
     call to_history( "d1", dt,"outtag") ;  call to_history( "d2", dx,"outtag") ;  call to_history( "d3", dy,"outtag")
     call to_history( "o1", ot,"outtag");  call to_history( "o2", ox,"outtag");  call to_history( "o3", oy,"outtag")
     call to_history("esize",4);
     call srite("outtag",outvec_3d,4*nt*nx*ny)

     ! DEALLOCATE
!     deallocate(outvec_3d,outvec,outvec2)

   else
    call MPI_RECV( total_sparse,1 , MPI_INTEGER, impi-1,1001, MPI_COMM_WORLD,status, ierr )
    call MPI_RECV( total_sparse,1 , MPI_INTEGER, impi-1,1002, MPI_COMM_WORLD,status, ierr )
    allocate(invec(non_zero_mask))
    allocate(outvec(non_zero_mask))
    iloop=0
    do while(iloop==0) 
      call MPI_RECV( iloop,1 , MPI_INTEGER, impi-1,31, MPI_COMM_WORLD,status, ierr )
      if(impi/=nmpi-1) then
         call MPI_SEND( iloop, 1, MPI_INTEGER, impi+1,32, MPI_COMM_WORLD, ierr )
       end if
      if(iloop==0) call do_diag(total_sparse,invec,outvec)
    end do
    deallocate(invec,outvec)
   end if
   call MPI_FINALIZE(stat)
   end program Calc_eig_3d

