module paint_mod3d
!!! pass the function calc_cut an image, eigenvector, a cut threshold, and a weight matrix 
!!! and it will return the normalized cut value 
  use lint2
  use sep
  use warp_mod
  use sorting_mod
  logical, private , save :: first

contains

  subroutine sparse_mat_init()

     first=.true.


  end subroutine

  subroutine sparse_mat_mult3(in_vec,out_vec,mem_alloc,d_diag,d_vec_exp,non_zero_mask,total_sparse)
    integer               ::non_zero_mask,it,max_sparse,counter
    integer               ::total_sparse_read,mem_alloc,total_sparse
    real, dimension(:,:),allocatable  ::sparse_mat
    integer, dimension(:,:),allocatable  ::iloc
    real, dimension(:),allocatable  ::val
    real,dimension(:)     ::in_vec,out_vec,d_diag,d_vec_exp
    integer :: nm,nbuf

    ! GO TO BEGINING OF SPARSE MATRIX FILE

    if(first) then
      call auxinout("iloc")
      call auxinout("val")
      total_sparse_read=0
      nm=mem_alloc/2
      allocate(sparse_mat(3,nm),iloc(2,nm),val(nm))
      do while (total_sparse_read<total_sparse)
        nbuf = min(total_sparse-total_sparse_read,nm)
        total_sparse_read=total_sparse_read+nbuf 
        call sreed("in",sparse_mat,nbuf*12)
        do i=1,nbuf
          iloc(1:2,i)=nint(sparse_mat(1:2,i))
          val(i)=sparse_mat(3,i)
        end do
        call srite("iloc",iloc,nbuf*8)
        call srite("val",val,nbuf*4)
      end do
      first=.false.
      deallocate(iloc,val,sparse_mat)
   end if

   call sseek("val",0,0)
   call sseek("iloc",0,0)
!   call sseek("in",0,0)
   total_sparse_read=0

    allocate(iloc(2,mem_alloc),val(mem_alloc))
!     allocate(sparse_mat(3,mem_alloc))

    counter=1
    out_vec=0.
    write(0,*) 'calculation'
    read: do while (total_sparse_read<total_sparse)
       write(0,*) 'reading in another chunk within Calc_eig_3d',counter
       ! READ INPUT DATA AGAIN
!       call sreed("in",sparse_mat,size(sparse_mat)*4)
       call sreed("val",val,size(val)*4)
       call sreed("iloc",iloc,size(iloc)*4)

write(0,*) "FINISHED THE READ"
       !call sreed("sparse2", sparse_mat, 4*nt*total_sparse*ny) !temp fix
       ! call sep_read(sparse_mat,"sparse2") !temp fix

       ! SET MAX NUMBER OF SPARSE MATRIX VALUES
       max_sparse=min(total_sparse-total_sparse_read,mem_alloc)

write(0,*) "DOING THE LOOP",max_sparse
       ! 1)COMPUTE OFF DIAGONAL
       do it=1,max_sparse
          if (iloc(1,it)/=iloc(2,it)) then
             out_vec(iloc(1,it))=out_vec(iloc(1,it))+&
                  in_vec(iloc(2,it))*val(it)
             out_vec(iloc(2,it))=out_vec(iloc(2,it))+&
                  in_vec(iloc(1,it))*val(it)
          end if
!          if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
!             out_vec(nint(sparse_mat(1,it)))=&
!out_vec(nint(sparse_mat(1,it)))+&
!                  in_vec(nint(sparse_mat(2,it)))*sparse_mat(3,it)
!             out_vec(nint(sparse_mat(2,it)))=out_vec(nint(sparse_mat(2,it)))+&
!                  in_vec(nint(sparse_mat(1,it)))*sparse_mat(3,it)
!          end if
       end do
  
       total_sparse_read=total_sparse_read+max_sparse


       counter=counter+1 
    end do read
    ! 2)COMPUTE DIAGONAL
    do it=1,non_zero_mask
       out_vec(it)=out_vec(it)+in_vec(it)*d_diag(it)
    end do

    deallocate(iloc,val)
!    deallocate(sparse_mat)
  end subroutine sparse_mat_mult3

  subroutine sparse_mat_mult3_incore(in_vec,out_vec,mem_alloc,d_diag,d_vec_exp,non_zero_mask,total_sparse,sparse_mat)
    integer               ::non_zero_mask,it,max_sparse,counter
    integer               ::total_sparse_read,mem_alloc,total_sparse
    real, dimension(:,:)  ::sparse_mat
    real,dimension(:)     ::in_vec,out_vec,d_diag,d_vec_exp

    ! GO TO BEGINING OF SPARSE MATRIX FILE
 !   call sseek("in",0,0) 
   ! total_sparse_read=0

    !  allocate(sparse_mat(3,mem_alloc))
    counter=1
    out_vec=0.
!!$    write(0,*) 'calculation'
    ! read: do while (total_sparse_read<total_sparse)
    write(0,*) 'reading in another chunk within Calc_eig_3d',counter
    ! READ INPUT DATA AGAIN
    !   call sep_read(sparse_mat)

    !call sreed("sparse2", sparse_mat, 4*nt*total_sparse*ny) !temp fix
    ! call sep_read(sparse_mat,"sparse2") !temp fix

    ! SET MAX NUMBER OF SPARSE MATRIX VALUES
 !   max_sparse=min(total_sparse-total_sparse_read,mem_alloc)
 max_sparse=total_sparse
    ! 1)COMPUTE OFF DIAGONAL
    do it=1,max_sparse
       if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
          out_vec(nint(sparse_mat(1,it)))=out_vec(nint(sparse_mat(1,it)))+&
               in_vec(nint(sparse_mat(2,it)))*sparse_mat(3,it)
          out_vec(nint(sparse_mat(2,it)))=out_vec(nint(sparse_mat(2,it)))+&
               in_vec(nint(sparse_mat(1,it)))*sparse_mat(3,it)
       end if
    end do
    !     call srite("out",off_diag(1:,1:max_sparse),4*max_sparse*3)
    ! write(0,*) 'off',off_diag
    ! write(0,*) 'total_sparse_read',total_sparse_read
!!$       do it=1,max_sparse
!!$          write(0,*) sparse_mat(1:3,it)
!!$       enddo

    total_sparse_read=total_sparse_read+max_sparse
!!$       write(0,*) 'total_sparse_read',total_sparse_read,total_sparse

    counter=counter+1 
    ! end do read
!!$write(0,*) 'd_diag',d_diag
    ! 2)COMPUTE DIAGONAL
    do it=1,non_zero_mask
       out_vec(it)=out_vec(it)+in_vec(it)*d_diag(it)
    end do

    !   deallocate(sparse_mat)
  end subroutine sparse_mat_mult3_incore

end module paint_mod3d
