program Autopick_for_tau
  !Input fatten_bound and it will track the inner and outer boundaries  Jesse Lomask 10/04/05
  !Store the x, y, norm, distance
  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d
  use pick_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft,ref_2
  integer                               ::radius,irx,irt
  integer                               ::diag_count, adj_count, ix_diag, it_diag, ix_new, it_new
  integer                               ::ix_old, it_old,pick_count,which_bound
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist
  real, pointer, dimension(:,:)	        ::horizon_out,mask_out
  real, pointer, dimension(:,:,:)	::data, norm_d,mask_in,inner_bnd,outer_bnd
  real                                  ::mask_val1,mask_val2,ref_time_upper,ref_time_lower
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("which_bound",which_bound,0)
  call from_param("ref_2",ref_2,1)
  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),mask_out(nt,nx),horizon_out(nt*nx,2))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  mask_in=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx) 

  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  mask_out=0.
  !  cutoff=.00065




  ix=ref_2
  do it=2,nt-1
     ! FIND BOTH BOUNDARIES AN ASSIGN THE TIME TO EACH
     if (data(it,ix,1)==1. .and. data(it-1,ix,1)==0.) then
        ref_time_upper=it


     elseif (data(it,ix,1)==1. .and. data(it+1,ix,1)==0.) then
        ref_time_lower=it  
     end if


  end do


  find_taus: do ix=1,nx
     do it=2,nt-1
        ! FIND BOTH BOUNDARIES AN ASSIGN THE TIME TO EACH
        if (data(it,ix,1)==1. .and. data(it-1,ix,1)==0.) then
           mask_out(ref_time_upper,ix)=it-ref_time_upper
        elseif (data(it,ix,1)==1. .and. data(it+1,ix,1)==0.) then
           mask_out(ref_time_lower,ix)=it-ref_time_lower
        end if
     end do
  end do find_taus


  write(0,*) 'ref_time_upper',ref_time_upper
 write(0,*) 'ref_time_lower',ref_time_lower


  call sep_write (mask_out)
  call to_history ("n1",   nt)
  call to_history ("n2",   nx)
  call to_history ("n3",   ny)    
  call to_history ("esize",4)
  call to_history ("d1",d1)
  call to_history ("d2",d2)
  call to_history ("d3",d3)
  call to_history ("o1",o1)
  call to_history ("o2",o2)
  call to_history ("o2",o3)


end program Autopick_for_tau

