program Compute_norm_vec  
  ! Find norm everywhere along a boundary   Jesse Lomask 9/21/04

  use sep

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::tx_vec_x,tx_vec_t,ty_vec_y,ty_vec_t,srch_index
  integer                               ::srch_box_size,srch_dist,which_bound
  real                                  ::o1,o2,o3,d1,d2,d3
  integer, pointer, dimension(:,:)	        ::template
  real, pointer, dimension(:,:)	::boundary,boundary_out,boundary_out_temp



  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);
 call from_param("which_bound",which_bound,0)


  ! ALLOCATE INPUT DATA AND MASK
  allocate(boundary(nt,2),boundary_out(nt,6),boundary_out_temp(nt,6))

  ! READ INPUT DATA
  call sep_read(boundary)
  boundary_out=0.
  boundary_out(1:,1:2)=boundary(1:,1:)


  do it=1, nt-1
     boundary_out(it,3)=(boundary(it+1,1)-boundary(it,1))
     boundary_out(it,4)=(boundary(it+1,2)-boundary(it,2))

     ! normalize
     boundary_out(it,3:4)=boundary_out(it,3:4)/((boundary_out(it,3)**2+boundary_out(it,4)**2)**.5)
     ! DELTA T IS STORED IN THE X POSITION TO TAKE THE NORM
     boundary_out(it,6)=-1*(boundary_out(it,3))
     ! DELTA X IS STORED IN THE T POSITION
     boundary_out(it,5)=boundary_out(it,4)
     write(0,*) boundary_out(it,1:)
  end do
  boundary_out(nt,4)= boundary_out(nt-1,4)
  boundary_out(nt,3)= boundary_out(nt-1,3)

  boundary_out_temp=boundary_out
  !boundary_out=0. 
  write(0,*) 'smooothing'

  ! SMOOTH THE NORMS
  do it=2, nt-1

     boundary_out(it,4)=sum(boundary_out_temp(it-1:it+1,4))/3
     boundary_out(it,3)=sum(boundary_out_temp(it-1:it+1,3))/3

     boundary_out(it,6)=sum(boundary_out_temp(it-1:it+1,6))/3
     boundary_out(it,5)=sum(boundary_out_temp(it-1:it+1,5))/3

     ! re-normalize
     boundary_out(it,3:4)=boundary_out(it,3:4)/((boundary_out(it,3)**2+boundary_out(it,4)**2)**.5)
     boundary_out(it,5:6)=boundary_out(it,5:6)/((boundary_out(it,5)**2+boundary_out(it,6)**2)**.5)

     !   write(0,*) boundary_out(it,1:)
  end do

  ! SET THE BOUNDARIES
  boundary_out(1,3)= boundary_out(2,3)
  boundary_out(1,4)= boundary_out(2,4)
  boundary_out(1,5)= boundary_out(2,5)
  boundary_out(1,6)= boundary_out(2,6)

  boundary_out(nt,3)= boundary_out(nt-1,3)
  boundary_out(nt,4)= boundary_out(nt-1,4)
  boundary_out(nt,5)= boundary_out(nt-1,5)
  boundary_out(nt,6)= boundary_out(nt-1,6) 

!if (which_bound==2) boundary_out(1:,5:6)=-1*boundary_out(1:,5:6)


  do it=1, nt
!!$     ! normalize
!!$     boundary_out(it,3:4)=boundary_out(it,3:4)/((boundary_out(it,3)**2+boundary_out(it,4)**2)**.5)
     write(0,*) boundary_out(it,1:)
  end do
!!$boundary_out(1:,3)=1.
!!$boundary_out(1:,4)=0.
  call to_history("n1",nt); call to_history("n2",6) 
  call to_history("n3",1)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("esize",4)
  call sep_write(boundary_out)
  !  deallocate(norm_vec)



end program Compute_norm_vec

