program Compute_norm  
  ! Find norm everywhere along a boundary   Jesse Lomask 9/21/04

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::tx_vec_x,tx_vec_t,ty_vec_y,ty_vec_t,srch_index
  integer                               ::srch_box_size,srch_dist
  real                                  ::o1,o2,o3,d1,d2,d3
  integer, pointer, dimension(:,:)	        ::template
  real, pointer, dimension(:,:,:)	::boundary,mask_in
  real, pointer, dimension(:,:,:,:)	::norm_vec
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);


  srch_dist=10
  srch_box_size=srch_dist*2+1
  ! ALLOCATE INPUT DATA AND MASK
  allocate(boundary(nt,nx,ny),mask_in(nt,nx,ny),norm_vec(nt,nx,ny,4),template(2*(srch_box_size)+2*(srch_box_size-2) ,2))

  ! READ INPUT DATA
  call sep_read(boundary)

  ! READ IN INPUT MASK
  call sreed("mask_in", mask_in, 4*nt*nx*ny)
  norm_vec=0. 

  ! MAKE 2D SAMPLING TEMPLATE
  srch_index=0
  do ix=-srch_dist,srch_dist
     do it=-srch_dist,srch_dist
        if (max(abs(it),abs(ix))==srch_dist) then
           srch_index=srch_index+1
           template(srch_index,1)=it!-srch_dist-1
           template(srch_index,2)=ix!-srch_dist-1
           write(0,*) template(srch_index,1:)
        end if
     end do
  end do


  write(0,*) 'calculating norm'

  do iy=1,ny
     do ix=1,nx
        do it=1,nt
           if (boundary(it,ix,iy)==1.) then
              !  write(0,*) boundary(it,ix,iy)
              ! SCAN THE TX PLANE FOR A POINT
              ty_vec_y=999
              tx_vec_x=999
              tx_vec_t=999
              ty_vec_t=999
              tx_loop: do ip=1,srch_index
                 if (boundary(max(1,min(nt,it+template(ip,1))),&
                 max(1,min(nx,ix+template(ip,2))),iy)==1.) then
                    tx_vec_x=template(ip,2)
                    tx_vec_t=template(ip,1)
                    !         write(0,*) tx_vec_x,tx_vec_t
                    exit tx_loop
                 end if
                 tx_vec_x=0;tx_vec_t=0
              end do tx_loop
              ! SCAN THE TY PLANE FOR ANOTHER POINT
              ty_loop: do ip=1,srch_index
                 if (boundary(max(1,min(nt,it+template(ip,1))),&
                 ix,max(1,min(ny,iy+template(ip,2))))==1.) then
                    ty_vec_y=template(ip,2)
                    ty_vec_t=template(ip,1)
                    exit ty_loop
                 end if
                 ty_vec_y=0;ty_vec_t=0
              end do ty_loop
              ! TAKE CROSS PRODUCT
              norm_vec(it,ix,iy,1)= tx_vec_x*ty_vec_y
              norm_vec(it,ix,iy,2)=-tx_vec_t*ty_vec_y
              norm_vec(it,ix,iy,3)=-tx_vec_x*ty_vec_t

              norm_vec(it,ix,iy,1:)=norm_vec(it,ix,iy,1:)/((norm_vec(it,ix,iy,1)**2+norm_vec(it,ix,iy,2)**2&
              +norm_vec(it,ix,iy,3)**2)**.5)
              !       write(0,*) norm_vec(it,ix,iy,1:)
              if (mask_in(max(1,min(nt,it+3.*norm_vec(it,ix,iy,1))),max(1,min(nx,ix+3.*norm_vec(it,ix,iy,2))),&
              max(1,min(ny,iy+3.*norm_vec(it,ix,iy,3))))/=1.) then
                 norm_vec(it,ix,iy,1:)=-1.* norm_vec(it,ix,iy,1:)
              end if
              norm_vec(it,ix,iy,4)=1.

              if (ty_vec_y==999.or.tx_vec_x==999.or.tx_vec_t==999.or.ty_vec_t==999) then
                 write(0,*) 'could not find some'
                 stop
              end if

           end if

        end do
     end do
     write(0,*) 'finding norm iy',iy,'out of',ny
  end do



  call to_history("n1",nt); call to_history("n2",nx) 
  call to_history("n3",ny); call to_history("n4",4)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3); call to_history("d4",1.)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3); call to_history("o4",0.);
  call to_history("esize",4)
  call sep_write(norm_vec)
  deallocate(norm_vec)



end program Compute_norm

