program DDminusWD
  ! Calculates D^-.5(D-W)D^.5 for the upper triangle sparse storage of a symmetric matrix stored out of core   Jesse Lomask 9/22/04

  use sep

  implicit none
  integer				::n1, n2, n3,counter,ir
  integer				::nt, nx, ny,total_sparse_read
  integer				::it,non_zero_mask,ncv_val
  integer                               ::mem_alloc,max_sparse
  real,dimension(:),allocatable 	::d_vec,d_vec_exp,d_diag,off_diag_1d
  real, pointer, dimension(:,:)	        ::sparse_mat,off_diag

  real, dimension(:,:),allocatable  ::look_up_tab,outvec

  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n1",n1); call from_history("n2",n2);
  call from_history("n3",n3) 
  call from_history("nt",nt); call from_history("nx",nx);
  call from_history("ny",ny)  
  call from_history("non_zero_mask",non_zero_mask) ! number of points in the unmasked image
  call from_param("ncv_val",ncv_val,20) ! number of reynolds vectors
  call from_param("mem_alloc",mem_alloc,175000000) ! memory max

  ! ALLOCATE INPUT DATA AND MASK
  allocate(sparse_mat(3,mem_alloc),d_vec(non_zero_mask),d_vec_exp(non_zero_mask))
  d_vec=1.



  total_sparse_read=0
  counter=1
  firstread: do while (total_sparse_read<n2)
     write(0,*) 'reading in another chunk in DDminusWD',counter
     ! READ INPUT DATA
     call sep_read(sparse_mat)
!!$write(0,*) sparse_mat(1:2*n2,1)
!!$stop
!!$write(0,*) 'next pass'
!!$     do it=1,n2
!!$        write(0,*) sparse_mat(1:,it)
!!$     enddo
!!$     stop
     ! SET MAX NUMBER OF SPARSE MATRIX VALUES
     max_sparse=min(n2-total_sparse_read,mem_alloc)
     write(0,*) 'nextpass'
!!$     do it=1,max_sparse
!!$        write(0,*) sparse_mat(1:,it)
!!$     enddo
     ! COMPUTE d_vec---->sum of all rows of the weight matrix
     do it=1,max_sparse
        if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
           d_vec(nint(sparse_mat(1,it)))=d_vec(nint(sparse_mat(1,it)))+sparse_mat(3,it)
           d_vec(nint(sparse_mat(2,it)))=d_vec(nint(sparse_mat(2,it)))+sparse_mat(3,it) !remove if sparse_mat is symmetric
        end if
     end do

     total_sparse_read=total_sparse_read+max_sparse
     counter=counter+1
  end do firstread

!write(0,*) 'd_vec',d_vec

  ! COMPUTE d_vec_exp---->d_vec^-.5
  d_vec_exp=d_vec**-.5

  ! REINIT INPUT DATA
  ! call sep_init(SOURCE)


  !call sep_close
  counter=1
  !call sep_init(SOURCE)
  call sseek("in",0,0)
  total_sparse_read=0

  allocate(off_diag(3,mem_alloc),d_diag(non_zero_mask),off_diag_1d(mem_alloc*3))
  !write(0,*) 'calculation'
  secondread: do while (total_sparse_read<n2)
     write(0,*) 'reading in another chunk in secondread in DDminusWD',counter
     ! READ INPUT DATA AGAIN
     call sep_read(sparse_mat)
     !call sreed("sparse2", sparse_mat, 4*nt*n2*ny) !temp fix
     ! call sep_read(sparse_mat,"sparse2") !temp fix

     ! SET MAX NUMBER OF SPARSE MATRIX VALUES
     max_sparse=min(n2-total_sparse_read,mem_alloc)


     ! COMPUTE D^-.5(D-W)*D^-.5 
     ! 1)COMPUTE DIAGONAL
     d_diag=d_vec_exp*(d_vec-1.)*d_vec_exp

     ! 2)COMPUTE OFF DIAGONAL
     do it=1,max_sparse
        off_diag(3,it)=d_vec_exp(nint(sparse_mat(1,it)))*(-1*sparse_mat(3,it))*&
        d_vec_exp(nint(sparse_mat(2,it)))
        off_diag(1:2,it)=sparse_mat(1:2,it)
     end do
     !     call srite("out",off_diag(1:,1:max_sparse),4*max_sparse*3)
     ! write(0,*) 'off',off_diag
     ! write(0,*) 'total_sparse_read',total_sparse_read
!!$     do it=1,max_sparse
!!$        write(0,*) off_diag(1:3,it)
!!$     enddo

     ! RESHAPE TO 1D
     do it=1, max_sparse
        off_diag_1d(1+(it-1)*3:3+(it-1)*3)=off_diag(1:3,it)
     end do


     call sep_write(off_diag_1d(1:max_sparse*3))

     total_sparse_read=total_sparse_read+max_sparse
     counter=counter+1
  end do secondread
!!$write(0,*) 'diag',d_diag

  ! RITE OUT THE SPARSE MATRIX
  !call srite("out",off_diag,4*nt*3)
  call to_history( "n1", 3);call to_history( "n2", n2 );  call to_history( "n3", n3 )
  call to_history( "d1", 1.);call to_history( "d2", 1.);  call to_history( "d3", 1.)
  call to_history( "o1", 0.);call to_history( "o2", 0.);  call to_history( "o3", 0.)
  call to_history("esize",4);
  ! RITE TO THE HISTORY FILE THE SIZE OF THE IMAGE WITHIN THE MASK AND OTHER PARAMETERS
  call to_history("nt",nt); call to_history("nx",nx); call to_history("ny",ny)
  call to_history("non_zero_mask",non_zero_mask);
  call to_history("ncv_val",ncv_val); call to_history("mem_alloc",mem_alloc)
  deallocate(off_diag)

!!$
!!$allocate(look_up_tab(non_zero_mask,3)) ! DELETE!!!!!
!!$
!!$ call sreed("GoM_win2.amp.plook_up.H", look_up_tab, 4*non_zero_mask*3) ! DELETE!!!!!
!!$
!!$     ! RESHAPE EIGENVECTOR INTO IMAGE)
!!$     allocate(outvec(nt,nx))! DELETE!!!!!
!!$     write(0,*) 'nt,nx,ny',nt,nx,ny! DELETE!!!!!
!!$     do ir=1,non_zero_mask! DELETE!!!!!
!!$        outvec(nint(look_up_tab(ir,2)),nint(look_up_tab(ir,3)))=d_vec_exp(ir)! DELETE!!!!!
!!$     end do! DELETE!!!!!
!!$
!!$ call to_history("n1",nt,"d_mat"); call to_history("n2",nx,"d_mat") ! DELETE!!!!!
!!$  call to_history("n3",1,"d_mat")! DELETE!!!!!
!!$ call sep_write(outvec,"d_mat")! DELETE!!!!!


  call to_history("n1",non_zero_mask,"d_diag"); call to_history("n2",1,"d_diag") 
  call to_history("n3",1.,"d_diag")
  call to_history("d1",1.,"d_diag"); call to_history("d2",1,"d_diag")
  call to_history("d3",1.,"d_diag")
  call to_history("o1",0.,"d_diag"); call to_history("o2",0.,"d_diag")
  call to_history("o3",0.,"d_diag")
  call to_history("esize",4,"d_diag")
  call sep_write(d_diag,"d_diag")
  deallocate(d_diag)

  call to_history("n1",non_zero_mask,"d_vec_exp"); call to_history("n2",1,"d_vec_exp") 
  call to_history("n3",1.,"d_vec_exp")
  call to_history("d1",1.,"d_vec_exp"); call to_history("d2",1,"d_vec_exp")
  call to_history("d3",1.,"d_vec_exp")
  call to_history("o1",0.,"d_vec_exp"); call to_history("o2",0.,"d_vec_exp")
  call to_history("o3",0.,"d_vec_exp")
  call to_history("esize",4,"d_vec_exp")
  call sep_write(d_vec_exp,"d_vec_exp")
  deallocate(d_vec_exp)

end program DDminusWD

