program DDminusWD
  ! Calculates D^-.5(D-W)D^.5 for the upper triangle sparse storage of a symmetric matrix stored out of core   Jesse Lomask 9/22/04

  use sep

  implicit none
  integer				::n1, n2, n3,counter,ir,ir_new,it_count, iq,rm_cnt
  integer				::nt, nx, ny,total_sparse_read
  integer				::it,non_zero_mask,ncv_val,off_index
  integer                               ::mem_alloc,max_sparse
  real,dimension(:),allocatable 	::d_vec,d_vec_exp,d_diag,off_diag_1d,d_vec_new,rm_vec
  real, pointer, dimension(:,:)	        ::sparse_mat,off_diag,sparse_mat_new

  real, dimension(:,:),allocatable  ::look_up_tab,outvec,look_up_tab_new
  real, dimension(:,:,:),allocatable  ::mask_out
  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n1",n1); call from_history("n2",n2);
  call from_history("n3",n3) 
  call from_history("nt",nt); call from_history("nx",nx);
  call from_history("ny",ny)  
  call from_history("non_zero_mask",non_zero_mask) ! number of points in the unmasked image
  call from_param("ncv_val",ncv_val,20) ! number of reynolds vectors
  call from_param("mem_alloc",mem_alloc,175000000) ! memory max

  ! ALLOCATE INPUT DATA AND MASK
  allocate(sparse_mat(3,mem_alloc),d_vec(non_zero_mask),look_up_tab(non_zero_mask,4))
  d_vec=1.

  call sreed("look_up", look_up_tab,4*non_zero_mask*4)

  !write(0,*) 'non_zero_mask',non_zero_mask
  total_sparse_read=0
  counter=1
  firstread: do while (total_sparse_read<n2)
     write(0,*) 'reading in another chunk in DDminusWD',counter
     ! READ INPUT DATA
     call sep_read(sparse_mat)
!!$write(0,*) sparse_mat(1:2*n2,1)
!!$stop
!!$write(0,*) 'next pass'
!!$     do it=1,n2bp+w
!!$        write(0,*) sparse_mat(1:,it)
!!$     enddo
!!$     stop
     ! SET MAX NUMBER OF SPARSE MATRIX VALUES
     max_sparse=min(n2-total_sparse_read,mem_alloc)
     write(0,*) 'nextpass',max_sparse
!!$     do it=1,max_sparse
!!$        write(0,*) sparse_mat(1:,it)
!!$     enddo
     ! COMPUTE d_vec---->sum of all rows of the weight matrix
     do it=1,max_sparse
        if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
           d_vec(nint(sparse_mat(1,it)))=d_vec(nint(sparse_mat(1,it)))+sparse_mat(3,it)
           d_vec(nint(sparse_mat(2,it)))=d_vec(nint(sparse_mat(2,it)))+sparse_mat(3,it) !remove if sparse_mat is symmetric
        end if
     end do

     total_sparse_read=total_sparse_read+max_sparse
     counter=counter+1
  end do firstread


  ! IF ANY TERMS OF D_VEC ARE <2
  allocate(sparse_mat_new(3,max_sparse),look_up_tab_new(max_sparse,4),d_vec_new(non_zero_mask),rm_vec(non_zero_mask),mask_out(nt,nx,ny))

  write(0,*) 'maxval(look_up_tab(ir,2))',maxval(look_up_tab(1:,2))
  write(0,*) 'maxval(look_up_tab(ir,3))',maxval(look_up_tab(1:,3))
  write(0,*) 'maxval(look_up_tab(ir,4))',maxval(look_up_tab(1:,4))

 write(0,*) 'minval(look_up_tab(ir,2))',minval(look_up_tab(1:,2))
  write(0,*) 'minval(look_up_tab(ir,3))',minval(look_up_tab(1:,3))
  write(0,*) 'minval(look_up_tab(ir,4))',minval(look_up_tab(1:,4))
  it_count=0
  rm_cnt=0
  ir_new=n2
  write(0,*) '1'
  sparse_mat_new(1:3,1:max_sparse)=sparse_mat(1:3,1:max_sparse)
  look_up_tab_new=0.
  mask_out=0.
  write(0,*) '2'
  do it=1,non_zero_mask
     if (d_vec(it)<=2) then
!!$   if (it==5) then
        write(0,*) 'd_vec==1',it
        ! REMOVE IT FROM THE LOOK_UP_TAB

        ! REMOVE IT FROM THE SPARSE MATRIX
        ir_new=0
        do ir=1,max_sparse
           if (nint(sparse_mat(1,ir))==nint(look_up_tab(it,1)).or.(nint(sparse_mat(2,ir))==nint(look_up_tab(it,1)))) then


              rm_cnt=rm_cnt+1
              rm_vec(rm_cnt)=nint(look_up_tab(it,1))


           else
              ir_new=ir_new+1
              sparse_mat_new(1:,ir_new)=sparse_mat(1:,ir)

           end if
        end do
     else
        it_count=it_count+1
        d_vec_new(it_count)=d_vec(it)
        look_up_tab_new(it_count,1:)=look_up_tab(it,1:)
    !   mask_out(nint(look_up_tab(it,2)),nint(look_up_tab(it,3)),nint(look_up_tab(it,4)))=1.

     end if
!!$     write(0,*) 'it',it 
  end do


  deallocate(sparse_mat,look_up_tab,d_vec)
  write(0,*) 'it_count',it_count,'non_zero_mask',non_zero_mask
  write(0,*) 'ir_new',ir_new,'max_sparse',max_sparse

  max_sparse=ir_new
  n2=max_sparse
  non_zero_mask=it_count
  allocate(sparse_mat(3,max_sparse),d_vec(non_zero_mask),d_vec_exp(non_zero_mask),look_up_tab(non_zero_mask,4))
  sparse_mat(1:,1:max_sparse)=sparse_mat_new(1:,1:max_sparse)
  d_vec=d_vec_new(1:non_zero_mask)
  look_up_tab(1:non_zero_mask,1:)=look_up_tab_new(1:non_zero_mask,1:)


  write(0,*) 'rm_cnt',rm_cnt,rm_vec(1:rm_cnt)
  write(0,*) 'max', maxval(sparse_mat(1,1:))
  write(0,*) 'max', maxval(sparse_mat(2,1:))
  do ir=1,rm_cnt
     do iq=1,max_sparse
        !       write(0,*) 'iq',iq
        if  (nint(sparse_mat(1,iq))>nint(rm_vec(ir))) then
           sparse_mat(1,iq)=sparse_mat(1,iq)-1
        end if
        if  (nint(sparse_mat(2,iq))>nint(rm_vec(ir))) then
           sparse_mat(2,iq)=sparse_mat(2,iq)-1
        end if
     end do
  end do

  write(0,*) 'max', maxval(sparse_mat(1,1:))
  write(0,*) 'max', maxval(sparse_mat(2,1:))






  !write(0,*) 'd_vec',d_vec

  ! COMPUTE d_vec_exp---->d_vec^-.5

  d_vec_exp=d_vec**-.5

  ! REINIT INPUT DATA
  ! call sep_init(SOURCE)


  !call sep_close
  counter=1
  !call sep_init(SOURCE)
  !call sseek("in",0,0)
  total_sparse_read=0

  allocate(off_diag(3,mem_alloc),d_diag(non_zero_mask),off_diag_1d(mem_alloc*3))
  !write(0,*) 'calculation'
  secondread: do while (total_sparse_read<n2)
     write(0,*) 'reading in another chunk in secondread in DDminusWD',counter
     ! READ INPUT DATA AGAIN
     !  call sep_read(sparse_mat(1:,1:n2))
     !call sreed("sparse2", sparse_mat, 4*nt*n2*ny) !temp fix
     ! call sep_read(sparse_mat,"sparse2") !temp fix

     ! SET MAX NUMBER OF SPARSE MATRIX VALUES
 !    max_sparse=min(n2-total_sparse_read,mem_alloc)
     write(0,*) 'max_sparse',max_sparse,n2,non_zero_mask,size(d_vec_exp),size(d_vec)


     ! COMPUTE D^-.5(D-W)*D^-.5 
     ! 1)COMPUTE DIAGONAL

     d_diag=d_vec_exp*(d_vec-1.)*d_vec_exp
     off_diag(1,1:non_zero_mask)=(/1:non_zero_mask/)
     off_diag(2,1:non_zero_mask)=(/1:non_zero_mask/)
     off_diag(3,1:non_zero_mask)=d_diag
     off_index=non_zero_mask
     ! 2)COMPUTE OFF DIAGONAL
     !write(0,*) maxval(sparse_mat(2,1:))
     !stop
     ! COMPUTE D^-.5(D-W)*D^-.5 
     write(0,*) ' COMPUTE D^-.5(D-W)*D^-.5'
     do it=1,max_sparse
        if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
           off_index=off_index+1
           !        write(0,*) off_index,it,nint(sparse_mat(1,it)),nint(sparse_mat(2,it))
           off_diag(3,off_index)=d_vec_exp(nint(sparse_mat(1,it)))*(-1*sparse_mat(3,it))*&
                d_vec_exp(nint(sparse_mat(2,it)))
           off_diag(1:2,off_index)=sparse_mat(1:2,it)
           !        else
           !off_diag(3,nint(sparse_mat(1,it)))=d_diag(nint(sparse_mat(1,it)))

        end if
     end do

     write(0,*) ' COMPUTED D^-.5(D-W)*D^-.5'
!!$deallocate(sparse_mat)
!!$allocate(sparse_mat(3,off_index))
!!$sparse_mat=off_diag(1:,1:off_index)
!!$deallocate(off_diag)
!!$max_sparse=off_index

     !     call srite("out",off_diag(1:,1:max_sparse),4*max_sparse*3)
     ! write(0,*) 'off',off_diag
     ! write(0,*) 'total_sparse_read',total_sparse_read
!!$     do it=1,max_sparse
!!$        write(0,*) off_diag(1:3,it)
!!$     enddo

     ! RESHAPE TO 1D
     do it=1, max_sparse
        off_diag_1d(1+(it-1)*3:3+(it-1)*3)=off_diag(1:3,it)
     end do


     call sep_write(off_diag_1d(1:max_sparse*3))

     total_sparse_read=total_sparse_read+max_sparse
     counter=counter+1 
  end do secondread
!!$write(0,*) 'diag',d_diag

  write(0,*) 'aboout to rite out'

  ! RITE OUT THE SPARSE MATRIX
  !call srite("out",off_diag,4*nt*3)
  call to_history( "n1", 3);call to_history( "n2",max_sparse );  call to_history( "n3", 1. )
  call to_history( "d1", 1.);call to_history( "d2", 1.);  call to_history( "d3", 1.)
  call to_history( "o1", 0.);call to_history( "o2", 0.);  call to_history( "o3", 0.)
  call to_history("esize",4);
  ! RITE OUT THE HISTORY FILE THE SIZE OF THE IMAGE WITHIN THE MASK AND OTHER PARAMETERS
  call to_history("nt",nt); call to_history("nx",nx); call to_history("ny",ny)
  call to_history("non_zero_mask",non_zero_mask);
  call to_history("ncv_val",ncv_val); call to_history("mem_alloc",mem_alloc)
  deallocate(sparse_mat)

  write(0,*) 'aboout to rite out 2'

!!$
!!$allocate(look_up_tab(non_zero_mask,3)) ! DELETE!!!!!
!!$
!!$ call sreed("GoM_win2.amp.plook_up.H", look_up_tab, 4*non_zero_mask*3) ! DELETE!!!!!
!!$
!!$     ! RESHAPE EIGENVECTOR INTO IMAGE)
!!$     allocate(outvec(nt,nx))! DELETE!!!!!
!!$     write(0,*) 'nt,nx,ny',nt,nx,ny! DELETE!!!!!
!!$     do ir=1,non_zero_mask! DELETE!!!!!
!!$        outvec(nint(look_up_tab(ir,2)),nint(look_up_tab(ir,3)))=d_vec_exp(ir)! DELETE!!!!!
!!$     end do! DELETE!!!!!
!!$
!!$ call to_history("n1",nt,"d_mat"); call to_history("n2",nx,"d_mat") ! DELETE!!!!!
!!$  call to_history("n3",1,"d_mat")! DELETE!!!!!
!!$ call sep_write(outvec,"d_mat")! DELETE!!!!!


  call to_history("n1",non_zero_mask,"d_diag"); call to_history("n2",1,"d_diag") 
  call to_history("n3",1.,"d_diag")
  call to_history("d1",1.,"d_diag"); call to_history("d2",1,"d_diag")
  call to_history("d3",1.,"d_diag")
  call to_history("o1",0.,"d_diag"); call to_history("o2",0.,"d_diag")
  call to_history("o3",0.,"d_diag")
  call to_history("esize",4,"d_diag")
  call sep_write(d_diag,"d_diag")
  deallocate(d_diag)

  call to_history("n1",non_zero_mask,"d_vec_exp"); call to_history("n2",1,"d_vec_exp") 
  call to_history("n3",1.,"d_vec_exp")
  call to_history("d1",1.,"d_vec_exp"); call to_history("d2",1,"d_vec_exp")
  call to_history("d3",1.,"d_vec_exp")
  call to_history("o1",0.,"d_vec_exp"); call to_history("o2",0.,"d_vec_exp")
  call to_history("o3",0.,"d_vec_exp")
  call to_history("esize",4,"d_vec_exp")
  call sep_write(d_vec_exp,"d_vec_exp")
  deallocate(d_vec_exp)

  write(0,*) 'aboout to rite out 3',non_zero_mask
!!$

  write(0,*) 'maxval(look_up_tab(ir,2))',maxval(look_up_tab(1:,2))
   write(0,*) 'maxval(look_up_tab(ir,3))',maxval(look_up_tab(1:,3))
   write(0,*) 'maxval(look_up_tab(ir,4))',maxval(look_up_tab(1:,4))
!stop


  call to_history("n1",non_zero_mask,"look_up2"); call to_history("n2",4,"look_up2") 
  call to_history("n3",1.,"look_up2")
  call to_history("d1",1.,"look_up2"); call to_history("d2",1,"look_up2")
  call to_history("d3",1.,"look_up2")
  call to_history("o1",0.,"look_up2"); call to_history("o2",0.,"look_up2")
  call to_history("o3",0.,"look_up2")
  call to_history("esize",4,"look_up2")
  call sep_write(look_up_tab,"look_up2")

  call to_history("n1",nt,"mask_out"); call to_history("n2",nx,"mask_out") 
  call to_history("n3",ny,"mask_out")
  call to_history("d1",1.,"mask_out"); call to_history("d2",1,"mask_out")
  call to_history("d3",1.,"mask_out")
  call to_history("o1",0.,"mask_out"); call to_history("o2",0.,"mask_out")
  call to_history("o3",0.,"mask_out")
  call to_history("esize",4,"mask_out")
  call sep_write(mask_out,"mask_out")

  !  deallocate(look_up_tab)


  write(0,*) 'aboout to rite out 4'
end program DDminusWD

