program DDminusWD_pyth
  ! Calculates D^-.5(D-W)D^.5 for the upper triangle sparse storage of a symmetric matrix stored out of core   Jesse Lomask 9/22/04

  use sep

  implicit none
  integer				::n1, n2, n3,counter
  integer				::nt, nx, ny,total_sparse_read,ix,iy
  integer				::it,non_zero_mask,ncv_val,max_iter
  integer                               ::mem_alloc,max_sparse,off_index
  real                                  ::ot,ox,oy,dt,dx,dy
  real,dimension(:),allocatable 	::d_vec,d_vec_exp,d_diag,off_diag_1d
  real, pointer, dimension(:,:)	        ::sparse_mat,off_diag
  real,dimension(:,:,:),allocatable 	::mask_in
  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n1",n1); call from_history("n2",n2);
  call from_history("n3",n3) 
  call from_aux("mask_in","n1",nt)
  call from_aux("mask_in","n2",nx)
  call from_aux("mask_in","n3",ny)
  call from_aux("mask_in","d1",dt)
  call from_aux("mask_in","d2",dx)
  call from_aux("mask_in","d3",dy)
  call from_aux("mask_in","o1",ot)
  call from_aux("mask_in","o2",ox)
  call from_aux("mask_in","o3",oy)
  write(0,*) nt,nx,ny,dt,dx,dy,ot,ox,oy
!!$dy=.46875 ;oy=0.
!!$   call from_history("nt",nt)
!!$  call from_history("nx",nx)
!!$  call from_history("ny",ny)
!!$  call from_history("dt",dt)
!!$  call from_history("dx",dx)
!!$  call from_history("dy",dy)
!!$  call from_history("ot",ot)
!!$  call from_history("ox",ox)
!!$  call from_history("oy",oy)

  non_zero_mask=0
  allocate(mask_in(nt,nx,ny))
  call sreed("mask_in", mask_in, 4*nt*nx*ny) 



  do it=1,nt
     do ix=1,nx
        do iy=1,ny
           if (mask_in(it,ix,iy)==1.) non_zero_mask=non_zero_mask+1
        end do
     end do
  end do
  deallocate(mask_in)
  write(0,*) 'non_zero_mask',non_zero_mask,nt,nx,ny

!!$  call from_aux("GoM_win2.amp.pweight.H","non_zero_mask",non_zero_mask) ! number of points in the unmasked image
  call from_param("ncv_val",ncv_val,20) ! number of reynolds vectors
  call from_param("mem_alloc",mem_alloc,175000000) ! memory max
!   mem_alloc=mem_alloc*2.
  call from_param("max_iter",max_iter,200) ! number of reynolds vectors
  ! ALLOCATE INPUT DATA AND MASK
  allocate(sparse_mat(3,mem_alloc),d_vec(non_zero_mask),d_vec_exp(non_zero_mask))
  d_vec=1.



  total_sparse_read=0
  counter=1
  firstread: do while (total_sparse_read<n2)
     write(0,*) 'reading in another chunk in DDminusWD',counter,mem_alloc
     ! READ INPUT DATA
     call sep_read(sparse_mat)
!!$write(0,*) sparse_mat(1:2*n2,1)
!!$stop
!!$write(0,*) 'next pass'
!!$     do it=1,n2
!!$        write(0,*) sparse_mat(1:,it)
!!$     enddo
!!$     stop
     ! SET MAX NUMBER OF SPARSE MATRIX VALUES
     max_sparse=min(n2-total_sparse_read,mem_alloc)
     write(0,*) 'nextpass',max_sparse,non_zero_mask
!!$     do it=1,max_sparse
!!$        write(0,*) sparse_mat(1:,it)
!!$     enddo
     ! COMPUTE d_vec---->sum of all rows of the weight matrix
     !     write(0,*) 'size d_vec',size(d_vec)
     do it=1,max_sparse
        !  write(0,*)  it,non_zero_mask,nint(sparse_mat(1,it)),nint(sparse_mat(2,it)),size(d_vec)
        if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
           d_vec(nint(sparse_mat(1,it)))=d_vec(nint(sparse_mat(1,it)))+sparse_mat(3,it)
           d_vec(nint(sparse_mat(2,it)))=d_vec(nint(sparse_mat(2,it)))+sparse_mat(3,it)
           !  write(0,*) it,non_zero_mask,nint(sparse_mat(1,it)),nint(sparse_mat(2,it))
        end if
     end do
     !write(0,*) 'herea'
     total_sparse_read=total_sparse_read+max_sparse
     counter=counter+1
     !write(0,*) 'here'
  end do firstread

!!$  call to_history("n1",non_zero_mask,"d_vec"); call to_history("n2",1,"d_vec") 
!!$  call to_history("n3",1,"d_vec")
!!$  call to_history("d1",1.,"d_vec"); call to_history("d2",1,"d_vec")
!!$  call to_history("d3",1.,"d_vec")
!!$  call to_history("o1",0.,"d_vec"); call to_history("o2",0.,"d_vec")
!!$  call to_history("o3",0.,"d_vec")
!!$  call to_history("nt",nt,"d_vec"); call to_history("nx",nx,"d_vec"); call to_history("ny",ny,"d_vec")
!!$  call to_history("dt",dt,"d_vec"); call to_history("dx",dx,"d_vec"); call to_history("dy",dy,"d_vec")
!!$  call to_history("ot",ot,"d_vec"); call to_history("ox",ox,"d_vec"); call to_history("oy",oy,"d_vec")
!!$  call to_history("non_zero_mask",non_zero_mask,"d_vec");
!!$
!!$
!!$  call to_history("esize",4,"d_vec")
!!$  call sep_write(d_vec,"d_vec")



  write(0,*) 'about to compute vectors'

  ! COMPUTE d_vec_exp---->d_vec^-.5
  d_vec_exp=d_vec**-.5

  ! REINIT INPUT DATA
  ! call sep_init(SOURCE)


  !call sep_close
  counter=1
  !call sep_init(SOURCE)
  call sseek("in",0,0)
  total_sparse_read=0
  write(0,*) 'about to allocate some more'
  write(0,*) 'mem_alloc',mem_alloc
  allocate(off_diag(3,mem_alloc),d_diag(non_zero_mask),off_diag_1d(mem_alloc*3))


  write(0,*) 'calculation'

  d_diag=d_vec_exp*(d_vec-1.)*d_vec_exp
  off_diag(1,1:non_zero_mask)=(/1:non_zero_mask/)
  off_diag(2,1:non_zero_mask)=(/1:non_zero_mask/)
  off_diag(3,1:non_zero_mask)=d_diag
  off_index=non_zero_mask


  do it=1, non_zero_mask
     off_diag_1d(1+(it-1)*3:3+(it-1)*3)=off_diag(1:3,it)
  end do
  call sep_write(off_diag_1d(1:non_zero_mask*3))



  ! SET MAX NUMBER OF SPARSE MATRIX VALUES
  ! max_sparse=min(n2-total_sparse_read,mem_alloc)-off_index

  secondread: do while (total_sparse_read<n2)

     write(0,*) 'reading in another chunk in secondread in DDminusWD',counter
     ! READ INPUT DATA AGAIN
     call sep_read(sparse_mat)
     write(0,*) 'read in data'
     !call sreed("sparse2", sparse_mat, 4*nt*n2*ny) !temp fix
     ! call sep_read(sparse_mat,"sparse2") !temp fix

     !


     ! COMPUTE D^-.5(D-W)*D^-.5 
     ! 1)COMPUTE DIAGONAL

     !     d_diag=d_vec_exp*(d_vec-1.)*d_vec_exp

!!$     d_diag=d_vec_exp*(d_vec-1.)*d_vec_exp
!!$     off_diag(1,1:non_zero_mask)=(/1:non_zero_mask/)
!!$     off_diag(2,1:non_zero_mask)=(/1:non_zero_mask/)
!!$     off_diag(3,1:non_zero_mask)=d_diag
!!$     off_index=non_zero_mask

     ! SET MAX NUMBER OF SPARSE MATRIX VALUES    

     !   max_sparse=min(n2-total_sparse_read,mem_alloc)-off_index

!!$     if (counter>1) then
!!$        off_index=0
!!$        write(0,*) 'another pass within second loop count:',counter
!!$     end if
     max_sparse=min(n2-total_sparse_read,mem_alloc)

     write(0,*) 'set off diag',non_zero_mask,max_sparse

     ! 2)COMPUTE OFF DIAGONAL
     !   do it=1,max_sparse
     off_index=0
     do it=1,max_sparse
        if (nint(sparse_mat(1,it))/=nint(sparse_mat(2,it))) then
           off_index=off_index+1
           off_diag(3,off_index)=d_vec_exp(nint(sparse_mat(1,it)))*(-1*sparse_mat(3,it))*&
                d_vec_exp(nint(sparse_mat(2,it)))
           off_diag(1:2,off_index)=sparse_mat(1:2,it)
!!$        off_diag(3,it)=d_vec_exp(nint(sparse_mat(1,it)))*(-1*sparse_mat(3,it))*&
!!$             d_vec_exp(nint(sparse_mat(2,it)))
!!$        off_diag(1:2,it)=sparse_mat(1:2,it)
        end if
     end do
     !     call srite("out",off_diag(1:,1:max_sparse),4*max_sparse*3)
     ! write(0,*) 'off',off_diag
     ! write(0,*) 'total_sparse_read',total_sparse_read
!!$     do it=1,max_sparse
!!$        write(0,*) off_diag(1:3,it)
!!$     enddo

     ! RESHAPE TO 1D
     !   do it=1, max_sparse
     do it=1, off_index
        off_diag_1d(1+(it-1)*3:3+(it-1)*3)=off_diag(1:3,it)
     end do


     !  call sep_write(off_diag_1d(1:max_sparse*3))
     call sep_write(off_diag_1d(1:off_index*3))
     total_sparse_read=total_sparse_read+max_sparse
     counter=counter+1
  end do secondread
!!$write(0,*) 'diag',d_diag

  ! RITE OUT THE SPARSE MATRIX
  !call srite("out",off_diag,4*nt*3)
  call to_history( "n1", 3);call to_history( "n2", n2 );  call to_history( "n3", 1 )
  call to_history( "d1", 1.);call to_history( "d2", 1.);  call to_history( "d3", 1.)
  call to_history( "o1", 0.);call to_history( "o2", 0.);  call to_history( "o3", 0.)
  call to_history("esize",4);
  ! RITE TO THE HISTORY FILE THE SIZE OF THE IMAGE WITHIN THE MASK AND OTHER PARAMETERS
  call to_history("nt",nt); call to_history("nx",nx); call to_history("ny",ny)
  call to_history("dt",dt); call to_history("dx",dx); call to_history("dy",dy)
  call to_history("ot",ot); call to_history("ox",ox); call to_history("oy",oy)
  call to_history("non_zero_mask",non_zero_mask); call to_history("max_iter",max_iter)
  call to_history("ncv_val",ncv_val); call to_history("mem_alloc",mem_alloc)
  deallocate(off_diag)

  call to_history("n1",non_zero_mask,"d_diag"); call to_history("n2",1,"d_diag") 
  call to_history("n3",1.,"d_diag")
  call to_history("d1",1.,"d_diag"); call to_history("d2",1,"d_diag")
  call to_history("d3",1.,"d_diag")
  call to_history("o1",0.,"d_diag"); call to_history("o2",0.,"d_diag")
  call to_history("o3",0.,"d_diag")
  call to_history("esize",4,"d_diag")
  call sep_write(d_diag,"d_diag")
  deallocate(d_diag)

  call to_history("n1",non_zero_mask,"d_vec_exp"); call to_history("n2",1,"d_vec_exp") 
  call to_history("n3",1.,"d_vec_exp")
  call to_history("d1",1.,"d_vec_exp"); call to_history("d2",1,"d_vec_exp")
  call to_history("d3",1.,"d_vec_exp")
  call to_history("o1",0.,"d_vec_exp"); call to_history("o2",0.,"d_vec_exp")
  call to_history("o3",0.,"d_vec_exp")
  call to_history("esize",4,"d_vec_exp")
  call sep_write(d_vec_exp,"d_vec_exp")
  deallocate(d_vec_exp)





end program DDminusWD_pyth

