program Fatten_boundary 
  !Track the boundary from an 2D eigenvector   Jesse Lomask 10/04/05
  !Store the x, y values of anypoint that is in one group and touches another
  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::radius,irx,irt
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist

  real, pointer, dimension(:,:,:)	::data, norm_d,mask_in,mask_out,inner_bnd,outer_bnd,basic_mask
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("radius",radius,10)
  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),mask_out(nt,nx,ny),basic_mask(nt,nx,ny))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  mask_in=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx) 

  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  mask_out=0.
  !  cutoff=.00065

  ! CREATE CIRCLE TEMPLATE
  ! white out circle
!!$do irx=1,2*radius
!!$   do irt=1,2*radius
!!$      dist=
  do ix=1,nx
     do it=1,nt
        if (data(it,ix,1)>=cutoff) mask_out(it,ix,1)=2.
     end do
  end do


  do ix=2,nx-1
     do it=2,nt-1
        if (data(it,ix,1)<cutoff.and.mask_in(it,ix,1)==1..and.&
        (data(it-1,ix,1)>=cutoff.or.data(it+1,ix,1)>=cutoff.or.&
        data(it,ix-1,1)>=cutoff.or.data(it,ix+1,1)>=cutoff.or.&
        data(it-1,ix-1,1)>=cutoff.or.data(it+1,ix+1,1)>=cutoff.or.&
        data(it+1,ix-1,1)>=cutoff.or.data(it-1,ix+1,1)>=cutoff&        
        )) then
!!$if (it==nt/2.and.ix==nx/2) then
           ! white out circle
           do irx=-radius,radius
              do irt=-radius,radius
                 dist=((real(irx))**2+(real(irt))**2)**.5

                 if (dist<=real(radius).and.ix+irx>=1.and.ix+irx<=nx.and.it+irt>=1.and.it+irt<=nt) then
                    mask_out(it+irt,ix+irx,1)=1.       
                 end if
              end do
           end do


        end if
     end do
  end do
!!$     write(0,*) 'initializing mask iy',iy,'out of',ny
!!$  end do

basic_mask=0.
where (mask_out==1.) basic_mask=1.


  call to_history("n1",nt); call to_history("n2",nx) 
  call to_history("n3",ny)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("esize",4)
  call sep_write(mask_out)

 call to_history("n1",nt,"basic_mask"); call to_history("n2",nx,"basic_mask") 
  call to_history("n3",ny,"basic_mask")
  call to_history("d1",d1,"basic_mask"); call to_history("d2",d2,"basic_mask")
  call to_history("d3",d3,"basic_mask")
  call to_history("o1",o1,"basic_mask"); call to_history("o2",o2,"basic_mask")
  call to_history("o3",o3,"basic_mask")
  call to_history("esize",4,"basic_mask")
  call sep_write(basic_mask,"basic_mask")

  deallocate(mask_out)






end program Fatten_boundary

