program Make_bounds
  ! CREATE BOUNDS:  out_bnd_pyth - 3D cube that index each point of the 
  !                                outer bound
  !                 out_bnd_track_pyth - 2D list that contains the norms 
  !                                      and their locations as
  !                        index  t x y  norm_t norm_x norm_y  
  !              
  ! Jesse Lomask 12/05/05

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d
  use pick_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::radius,irx,irt,inner_index,outer_index
  integer                               ::diag_count, adj_count, ix_diag, it_diag, ix_new, it_new
  integer                               ::ix_old, it_old,pick_count,which_bound
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist
  real, pointer, dimension(:,:)	        ::horizon_out
  real, dimension(:,:), allocatable     ::out_track,in_track,temp2d
  real, pointer, dimension(:,:,:)	::mask_out
  real, pointer, dimension(:,:,:)	::data, norm_d,in_bnd,out_bnd
  real, dimension(:,:,:,:),allocatable  ::norm_in
  real                                  ::mask_val1,mask_val2
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("which_bound",which_bound,0)
  ! ALLOCATE INPUT DATA AND MASK
write(0,*) 'allocating memory' 
 allocate(data(nt,nx,ny),norm_in(nt,nx,ny,3))
write(0,*) '2'
  allocate(out_bnd(nt,nx,ny),in_bnd(nt,nx,ny),out_track(10*nx*ny,6),in_track(10*nx*ny,6))
write(0,*) 'allocated memory' 

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
 
  !if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx*ny) 
  if (exist_file("norm_in")) call sreed("norm_in", norm_in, 4*nt*nx*ny*3) 
  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  
  !  cutoff=.00065
  pick_count=0

  outer_index=0
  inner_index=0

  ! SCAN OVER CUBE
  do iy=1,ny
     do ix=1,nx
        do it=1,nt
           ! SCAN FOR SEED POINT, A BOUND HAS ONE OF ITS FOUR ADJACENT SIDES TOUCHING OUTSIDE OF THE BOUNDARY
           if (data(it,ix,iy)==1) then
              outer_index=outer_index+1
              out_bnd(it,ix,iy)=outer_index
              out_track(outer_index,1)=it
              out_track(outer_index,2)=ix
              out_track(outer_index,3)=iy
              out_track(outer_index,4)=norm_in(it,ix,iy,1)
              out_track(outer_index,5)=norm_in(it,ix,iy,2)
              out_track(outer_index,6)=norm_in(it,ix,iy,3)
           else if  (data(it,ix,iy)==2) then
              inner_index=inner_index+1
              in_bnd(it,ix,iy)=inner_index
              in_track(inner_index,1)=it
              in_track(inner_index,2)=ix
              in_track(inner_index,3)=iy
              in_track(inner_index,4)=norm_in(it,ix,iy,1)
              in_track(inner_index,5)=norm_in(it,ix,iy,2)
              in_track(inner_index,6)=norm_in(it,ix,iy,3)
           end if
        end do
     end do
  end do

  allocate(temp2d(outer_index,6))
  temp2d=out_track(1:outer_index,1:)
  deallocate(out_track)
  allocate(out_track(outer_index,6))
  out_track=temp2d

  deallocate(temp2d)
  allocate(temp2d(inner_index,6))
  temp2d=in_track(1:inner_index,1:)
  deallocate(in_track)
  allocate(in_track(inner_index,6))
  in_track=temp2d




!!$  call to_history("n1",pick_count); call to_history("n2",2) 
!!$  call to_history("n3",1)
!!$  call to_history("d1",1); call to_history("d2",1 )
!!$  call to_history("d3",1 )
!!$  call to_history("o1",0.); call to_history("o2",0.)
!!$  call to_history("o3",0.)
!!$  call to_history("esize",4)
!!$  call sep_write(horizon_out(1:pick_count,1:))

  call to_history("n1",nt,"out_bnd") ; call to_history("n2",nx,"out_bnd") 
  call to_history("n3",ny,"out_bnd")
  call to_history("d1",d1,"out_bnd"); call to_history("d2",d2,"out_bnd")
  call to_history("d3",d3,"out_bnd")
  call to_history("o1",o1,"out_bnd"); call to_history("o2",o2,"out_bnd")
  call to_history("o3",o3,"out_bnd")
  call to_history("esize",4,"out_bnd")
  call sep_write(out_bnd,"out_bnd")

  call to_history("n1",nt,"in_bnd") ; call to_history("n2",nx,"in_bnd") 
  call to_history("n3",ny,"in_bnd")
  call to_history("d1",d1,"in_bnd"); call to_history("d2",d2,"in_bnd")
  call to_history("d3",d3,"in_bnd")
  call to_history("o1",o1,"in_bnd"); call to_history("o2",o2,"in_bnd")
  call to_history("o3",o3,"in_bnd")
  call to_history("esize",4,"in_bnd")
  call sep_write(in_bnd,"in_bnd")


  call to_history("n1",outer_index,"out_track") ; call to_history("n2",6,"out_track") 
  call to_history("n3",1,"out_track")
  call to_history("d1",1,"out_track"); call to_history("d2",1,"out_track")
  call to_history("d3",1,"out_track")
  call to_history("o1",0.,"out_track"); call to_history("o2",0.,"out_track")
  call to_history("o3",0.,"out_track")
  call to_history("esize",4,"out_track")
  call sep_write(out_track,"out_track")


  call to_history("n1",inner_index,"in_track") ; call to_history("n2",6,"in_track") 
  call to_history("n3",1,"in_track")
  call to_history("d1",1,"in_track"); call to_history("d2",1,"in_track")
  call to_history("d3",1,"in_track")
  call to_history("o1",0.,"in_track"); call to_history("o2",0.,"in_track")
  call to_history("o3",0.,"in_track")
  call to_history("esize",4,"in_track")
  call sep_write(in_track,"in_track")


end program Make_bounds

