program Make_loop_up
  ! Main program for parallel segmentation

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod
  use sample_mod_3d
  use psegment3d_mod

  implicit none

  integer				::nt, nx, ny, wt_mat_sz
  integer				::it,ix,iy,ir,iq,iz,max_dist,dense_dist
  integer                               ::irow,row1,col1,row2,col2,val_cnt,n_new_val,rand_jump_int
  integer                               ::box_size,big_box_size,fill
  integer                               ::row2_raw,col2_raw,delta_row2,delta_col2
  integer                               ::row1_grid,col1_grid,row2_grid,col2_grid
  integer                               ::irow_mat,icol_mat,sample_num,nodes
  integer                               ::drow,row1_back,col1_back,row2_back,col2_back
  integer                               ::sparse_mat_index,col_in_row,sparse_index
  integer                               ::box_x,box_t,stat1,dcol,index_new
  integer                               ::total_sparse,row_count,last_index,smpl_cnt
  integer                               ::newsize,ncv_val,mem_alloc
  integer                               ::ignore_wrapping, sparse_mat_index1, sparse_mat_index2
  integer                               ::ub_n1,lb_n1,max_wt_num
  !  integer,allocatable, dimension(:,:)               ::sample_template,sample_template2
  real                                  ::maxdat,mindat,rangedat,amp_thresh,zero_tol
  real                                  ::rand_jump,dist,iz_rl, wt,pi_var,sample_scale
  real                                  ::subsam_increment,dt,dx,ot,ox,dy,oy,attr_coef
  real,dimension(:),allocatable		::dd,norm_d_1d
  real,dimension(:),allocatable		::topbnd,botbnd
  real,dimension(:),allocatable	        ::val_list,d_vec,d_vec_exp
  real,dimension(:),allocatable	        ::sparse_mat_1d
  real, pointer, dimension(:,:,:)	::data, norm_d,xy
  real, pointer, dimension(:,:)	        ::sparse_mat_node1,sparse_mat_node2
  !  real, pointer, dimension(:,:)	        ::DminusW,DminusWD,DDminusWD
  real, dimension(:,:,:),allocatable      ::look_up_image
  real, dimension(:,:),allocatable      ::sparse_mat_sort,look_up_tab
  real, dimension(:,:,:),allocatable      ::mask_in
  real, dimension(:,:,:),allocatable      ::tester,upper_bnd,lower_bnd
  real, dimension(:,:),allocatable      ::upper_bnd_tracker,lower_bnd_tracker 
  real, dimension(:,:),allocatable      ::sparse_mat,sparse_mat2
  real, dimension(:,:,:),allocatable      ::first_attribute

  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);

  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dy);
  call from_history("o1",ot); call from_history("o2",ox); call from_history("o3",oy);



  ! ALLOCATE INPUT DATA AND MASK
  allocate(mask_in(nt,nx,ny))

  ! READ INPUT DATA

  mask_in=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx*ny) 


  ! COUNT NONZERO VALUES IN MASK
  wt_mat_sz=0
  do it=1,nt
     do ix=1,nx
        do iy=1,ny
           if (mask_in(it,ix,iy)==1.)  wt_mat_sz=wt_mat_sz+1 ! counting nonzero value
        end do
     end do
  end do
  write(0,*) 'weight_mat_sz',wt_mat_sz

  ! MAKE A LOOK UP TABLE TO TRANSFORM DATA TO WEIGHT
  allocate(look_up_tab(wt_mat_sz,4))

  ir=0

  do iy=1,ny
     do ix=1,nx

        do it=1,nt
           if (mask_in(it,ix,iy)==1.) then
              ir=ir+1 ! counting nonzero value
              look_up_tab(ir,1)=ir  ! wt row (or column as they are the same)
              look_up_tab(ir,2)=it !row_count  ! data row
              look_up_tab(ir,3)=ix  ! data column
              look_up_tab(ir,4)=iy  ! data column2

           end if
        end do
     end do
  end do






  call to_history("n1",wt_mat_sz); call to_history("n2",3) 
  call to_history("n3",1.)
  call to_history("d1",1.); call to_history("d2",1)
  call to_history("d3",1.)
  call to_history("o1",0.); call to_history("o2",0)
  call to_history("o3",0.)
  call to_history("esize",4)
  call sep_write(look_up_tab)
  deallocate(look_up_tab)


end program Make_loop_up

