program Pick_bound  
  !Pick the boundary from an eigenvector   Jesse Lomask 9/21/04

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff

  real, pointer, dimension(:,:,:)	::data, norm_d,mask_in,mask_out,inner_bnd,outer_bnd
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)

  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),mask_out(nt,nx,ny))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  call sreed("mask_in", mask_in, 4*nt*nx*ny) 

  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  mask_out=0.
  !  cutoff=.00065
  do iy=2,ny-1
     do ix=2,nx-1
        do it=2,nt-1
           if (data(it,ix,iy)<cutoff.and.mask_in(it,ix,iy)==1..and.&
                ((data(it-1,ix,iy)>=cutoff.and.mask_in(it-1,ix,iy)==1.).or. &
                (data(it+1,ix,iy)>=cutoff.and.mask_in(it+1,ix,iy)==1.).or.&
                (data(it,ix-1,iy)>=cutoff.and.mask_in(it,ix-1,iy)==1.).or.&
                (data(it,ix+1,iy)>=cutoff.and.mask_in(it,ix+1,iy)==1.).or.&
                (data(it,ix,iy-1)>=cutoff.and.mask_in(it,ix,iy-1)==1.).or.&
                (data(it,ix,iy+1)>=cutoff.and.mask_in(it,ix,iy+1)==1.) & 
                )) then
              ! DASH IF EVEN
    !          if (real(it)/2.-floor(real(it)/2.)<.000001.and.real(ix)/2.-floor(real(ix)/2.)<.000001.and.real(iy)/2.-floor(real(iy)/2.)<.000001) then
   if (mask_out(max(1,it-3),ix,iy)/=1..and. &
       mask_out(min(nt,it+3),ix,iy)/=1..and.&
       mask_out(it,max(1,ix-3),iy)/=1..and.&
       mask_out(it,min(nx,ix+3),iy)/=1..and.&
       mask_out(it,ix,max(1,iy-3))/=1..and.&
       mask_out(it,ix,min(ny,iy+3))/=1.) then
                ! mask_out(it,ix,iy)=1. 
        mask_out(it-1:it+1,ix-1:ix+1,iy-1:iy+1)=1. 
              end if
           end if
        end do
     end do
!!$     write(0,*) 'initializing mask iy',iy,'out of',ny
  end do



  call to_history("n1",nt); call to_history("n2",nx) 
  call to_history("n3",ny)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("esize",4)
  call sep_write(mask_out)
  deallocate(mask_out)






end program Pick_bound

