program Psegment_main3d_python
  ! Main program for parallel segmentation

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod
  use sample_mod_3d
  use psegment3d_mod

  implicit none

  integer				::nt, nx, ny, wt_mat_sz,i
  integer				::it,ix,iy,ir,iq,iz,max_dist,dense_dist
  integer                               ::irow,row1,col1,row2,col2,val_cnt,n_new_val,rand_jump_int
  integer                               ::box_size,big_box_size,fill
  integer                               ::row2_raw,col2_raw,delta_row2,delta_col2
  integer                               ::row1_grid,col1_grid,row2_grid,col2_grid
  integer                               ::irow_mat,icol_mat,sample_num,nodes
  integer                               ::drow,row1_back,col1_back,row2_back,col2_back
  integer                               ::sparse_mat_index,col_in_row,sparse_index
  integer                               ::box_x,box_t,stat1,dcol,index_new
  integer                               ::total_sparse,row_count,smpl_cnt
  integer                               ::newsize,ncv_val,mem_alloc
  integer                               ::ignore_wrapping, sparse_mat_index1, sparse_mat_index2
  integer                               ::ub_n1,lb_n1,max_wt_num,first_index,last_index
  !  integer,allocatable, dimension(:,:)               ::sample_template,sample_template2
  real                                  ::maxdat,mindat,rangedat,amp_thresh,zero_tol
  real                                  ::rand_jump,dist,iz_rl, wt,pi_var,sample_scale
  real                                  ::subsam_increment,dt,dx,ot,ox,dy,oy,attr_coef
  real,dimension(:),allocatable		::dd,norm_d_1d
  real,dimension(:),allocatable		::topbnd,botbnd
  real,dimension(:),allocatable	        ::val_list,d_vec,d_vec_exp
  real,dimension(:),allocatable	        ::sparse_mat_1d
  real, pointer, dimension(:,:,:)	::data, norm_d,xy
  real, pointer, dimension(:,:)	        ::sparse_mat_node1,sparse_mat_node2
  !  real, pointer, dimension(:,:)	        ::DminusW,DminusWD,DDminusWD
  real, dimension(:,:,:),allocatable      ::look_up_image
  real, dimension(:,:),allocatable      ::sparse_mat_sort,look_up_tab
  real, dimension(:,:,:),allocatable      ::mask_in
  real, dimension(:,:,:),allocatable      ::tester,upper_bnd,lower_bnd
  real, dimension(:,:),allocatable      ::upper_bnd_tracker,lower_bnd_tracker 
  real, dimension(:,:),allocatable      ::sparse_mat,sparse_mat2
  real, dimension(:,:,:),allocatable      ::first_attribute

  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)
  call sep_begin_prog()

  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);

  call from_history("d1",dt); call from_history("d2",dx); call from_history("d3",dy);
  call from_history("o1",ot); call from_history("o2",ox); call from_history("o3",oy);

  call from_param("max_dist",max_dist,21)
  call from_param("dense_dist",dense_dist,20)
  call from_param("amp_thresh",amp_thresh,.93)
  call from_param("zero_tol",zero_tol,.0001)
  call from_param("ncv_val",ncv_val,20)
  call from_param("mem_alloc",mem_alloc,175000000)
  call from_param("sample_scale",sample_scale,4.)
  call from_param("subsam_increment",subsam_increment,1.)
  call from_param("ignore_wrapping",ignore_wrapping,0)
  call from_param("attr_coef",attr_coef,100000.)

  ub_n1=0 ; lb_n1=0
  if (exist_file("upper_bnd_vec")) call from_aux("upper_bnd_vec","n1",ub_n1) ! UPPER BOUNDARY N1
  if (exist_file("lower_bnd_vec")) call from_aux("lower_bnd_vec","n1",lb_n1) ! LOWER BOUNDARY N1



  write(0,*) 'ub_n1',ub_n1,'lb_n1',lb_n1
  write(0,*) 'nt',nt,'nx',nx,'ny',ny

  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),norm_d(nt,nx,ny),norm_d_1d(nt*nx*ny),upper_bnd(nt,nx,ny),upper_bnd_tracker(ub_n1,6),lower_bnd(nt,nx,ny),lower_bnd_tracker(lb_n1,6),first_attribute(nt,nx,ny))

  write(0,*) 'after allocations'

  ! READ INPUT DATA
  call sep_read(data)
  write(0,*) 'successfully read in data'

  ! INVERT AND NORMALIZE THE DATA
  data=data*-1.
  maxdat=maxval(data)
  mindat=minval(data)
  write(0,*) 'took min and max',maxdat,mindat
  rangedat=maxdat-mindat
  write(0,*) 'calculate range',rangedat

  ! norm_d=(data-mindat)/rangedat
  ! had to add this althought it shouldn't be necessary
  i=0

  do iy=1,ny
     do ix=1,nx
        do it=1,nt

           i=i+1
           norm_d(it,ix,iy)=(data(it,ix,iy)-mindat)/rangedat
           norm_d_1d(i)=norm_d(it,ix,iy)
        end do
     end do
  end do
  write(0,*) 'about to deallocate data'
  deallocate(data)
  write(0,*) "WHERE DO I DIE 1"

  i=0
  !  norm_d_1d=reshape(norm_d,(/nt*nx*ny/))
  write(0,*) "WHERE DO I DIE 2"

  ! READ IN INPUT MASK

  mask_in=1. ;upper_bnd=1.;lower_bnd=1. ;first_attribute=1.
  write(0,*) 'about to read in mask_in'
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx*ny) 
  write(0,*) 'successfully read in mask_in'
  upper_bnd_tracker=0. ; lower_bnd_tracker=0. ; upper_bnd=0. ; lower_bnd=0.; first_attribute=0.
  ! READ IN UPPER AND LOWER BOUNDARIES:   t, x , norm_t , norm x
  if (exist_file("upper_bnd_vec")) call sreed("upper_bnd_vec", upper_bnd_tracker,4*ub_n1*6)
  write(0,*) 'successfully read in 1'
  if (exist_file("lower_bnd_vec")) call sreed("lower_bnd_vec", lower_bnd_tracker,4*lb_n1*6)
  write(0,*) 'successfully read in 2'
  if (exist_file("upper_bnd")) call sreed("upper_bnd", upper_bnd,4*nt*nx*ny)
  write(0,*) 'successfully read in 3'
  if (exist_file("lower_bnd")) call sreed("lower_bnd", lower_bnd,4*nt*nx*ny)

  write(0,*) 'about to read in first attribute'
  if (exist_file("first_attribute")) call sreed("first_attribute", first_attribute,4*nt*nx*ny)
  write(0,*) 'successfully read in first attribute'
  ! COUNT NONZERO VALUES IN MASK
  wt_mat_sz=0
  do it=1,nt
     do ix=1,nx
        do iy=1,ny
           if (mask_in(it,ix,iy)==1.)  wt_mat_sz=wt_mat_sz+1 ! counting nonzero value
        end do
     end do
  end do
  write(0,*) 'weight_mat_sz',wt_mat_sz

  ! MAKE A LOOK UP TABLE TO TRANSFORM DATA TO WEIGHT
  allocate(look_up_tab(wt_mat_sz,4),look_up_image(nt,nx,ny))
  look_up_image=0.
  ir=0
  do iy=1,ny
     do ix=1,nx
        do it=1,nt
           if (mask_in(it,ix,iy)==1.) then
              ir=ir+1 ! counting nonzero value
              look_up_tab(ir,1)=ir  ! wt row (or column as they are the same)
              look_up_tab(ir,2)=it !row_count  ! data row
              look_up_tab(ir,3)=ix  ! data column
              look_up_tab(ir,4)=iy  ! data column2
              look_up_image(it,ix,iy)=ir
           end if
        end do
     end do
  end do







  ! ALLOCATE SPARSE MATRIX ...MAKE VERY SMALL, IT IS A POINTER AND WILL BE EXPANDED IN A SUBROUTINE
  allocate(sparse_mat_node1(3,3),sparse_mat_node2(3,3))

  ! ALLOCATE NEW POINT TRACKER AND GRID
  pi_var=acos(-1.)
  max_wt_num=(max_dist*2+1)**3 !max number of weights for each node
  write(0,*) 'max number of random samples',nint(sample_scale*(3.*pi_var*real(max_dist))) 

  allocate(d_vec(wt_mat_sz),d_vec_exp(wt_mat_sz))



  ! LOOP OVER EACH ROW OF THE WEIGHT MATRIX
  sparse_mat_index=0 ! index of sparse matrix
  col_in_row=0       ! keep track of number of column in each row

  call from_param("first_index",first_index,1)
  call from_param("last_index",last_index,wt_mat_sz)


  write(0,*) 'first node'
  call find_weight_mat3d(first_index,last_index,nt,nx,ny,mem_alloc/2,sample_scale,wt_mat_sz,max_dist,max_wt_num,amp_thresh,zero_tol,norm_d,norm_d_1d,sparse_mat_node1,sparse_mat_index1,col_in_row,look_up_image,look_up_tab,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)

  !  write(0,*) 'second node'
  !  call find_weight_mat3d(wt_mat_sz/2+1,wt_mat_sz,nt,nx,ny,mem_alloc/2,sample_scale,wt_mat_sz,max_dist,max_wt_num,amp_thresh,zero_tol,norm_d,norm_d_1d,sparse_mat_node2,sparse_mat_index2,col_in_row,look_up_image,look_up_tab,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)


!!$  write(0,*) 'about to combine matricies'
!!$  ! COMBINE THE SPARSE MATRICIES
!!$  total_sparse=sparse_mat_index1+sparse_mat_index2
!!$  allocate(sparse_mat(total_sparse,3))
!!$  sparse_mat(1:sparse_mat_index1,1:)=sparse_mat_node1
!!$  deallocate(sparse_mat_node1)
!!$  sparse_mat(sparse_mat_index1+1:total_sparse,1:)=sparse_mat_node2
!!$  deallocate(sparse_mat_node2)
!!$
!!$  write(0,*) 'total_sparse',total_sparse
!!$
!!$  ! SORT THE SPARSE MATRIX
!!$  write(0,*) 'sorting'
!!$  allocate(sparse_mat_sort(3,total_sparse))
!!$  do it=1,3
!!$     sparse_mat_sort(it,1:)=sparse_mat(1:,it)
!!$  end do
!!$  call quick_sort(sparse_mat_sort,1,3,total_sparse)
!!$  !write(0,*) 'max/min', maxval(sparse_mat_sort(2,1:)), minval(sparse_mat_sort(2,1:))
!!$  !write(0,*) 'max/min', maxval(sparse_mat_sort(1,1:)), minval(sparse_mat_sort(1,1:))
!!$  !write(0,*) 'max/min', maxval(sparse_mat_sort(3,1:)), minval(sparse_mat_sort(3,1:))
!!$
!!$  last_index=1
!!$  do it=2,total_sparse
!!$     if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
!!$        call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
!!$        last_index=it
!!$     end if
!!$  end do
!!$  do it=1,3
!!$     sparse_mat(1:,it)=sparse_mat_sort(it,1:)
!!$  end do
!!$  deallocate(sparse_mat_sort)
!!$  write(0,*) 'sorted'
!!$
!!$
!!$  ! REMOVE REPEATING VALUES
!!$  allocate(sparse_mat2(total_sparse,3))
!!$  index_new=1
!!$  sparse_mat2=0.
!!$  sparse_mat2(1,1:)=sparse_mat(1,1:)
!!$  do sparse_index=2,total_sparse
!!$     if (sparse_mat(sparse_index,1)/=sparse_mat(sparse_index-1,1).or.sparse_mat(sparse_index,2)/=sparse_mat(sparse_index-1,2)) then
!!$        index_new=index_new+1
!!$        sparse_mat2(index_new,1:)=sparse_mat(sparse_index,1:)
!!$     end if
!!$  end do
!!$  write(0,*) 'removed repeaters'
!!$  deallocate(sparse_mat)
!!$  write(0,*) 'total_sparse_before repeater removal', total_sparse
!!$  total_sparse=index_new
!!$  write(0,*) 'total_sparse_after repeater removal', total_sparse
!!$  allocate(sparse_mat(total_sparse,3))
!!$  sparse_mat=sparse_mat2(1:total_sparse,1:)
!!$  deallocate(sparse_mat2)




!!$  ! MAKE SYMMETRIC
!!$  write(0,*) 'make symmetric'
!!$  index_new=0
!!$  newsize=2*total_sparse-maxval(sparse_mat(1:,1))
!!$  write(0,*) 'newsize',newsize
!!$  allocate(sparse_mat2(newsize,3))
!!$  do it=1,total_sparse
!!$     if (sparse_mat(it,1)==sparse_mat(it,2)) then
!!$        index_new=index_new+1
!!$        sparse_mat2(index_new,1:)=sparse_mat(it,1:)
!!$     else
!!$        index_new=index_new+1
!!$        sparse_mat2(index_new,1:)=sparse_mat(it,1:)
!!$        index_new=index_new+1
!!$        sparse_mat2(index_new,1)=sparse_mat(it,2)
!!$        sparse_mat2(index_new,2)=sparse_mat(it,1)
!!$        sparse_mat2(index_new,3)=sparse_mat(it,3)
!!$     end if
!!$  end do
!!$  deallocate(sparse_mat)
!!$  total_sparse=index_new  !newsize
!!$  allocate(sparse_mat(total_sparse,3))
!!$  sparse_mat=sparse_mat2
!!$  deallocate(sparse_mat2)
!!$
!!$  ! RE-SORT THE NOW SYMMETRIC SPARSE MATRIX
!!$  allocate(sparse_mat_sort(3,total_sparse))
!!$  do it=1,3
!!$     sparse_mat_sort(it,1:)=sparse_mat(1:,it)
!!$  end do
!!$  call quick_sort(sparse_mat_sort,1,3,total_sparse)
!!$
!!$
!!$  write(0,*) 'resorting1'
!!$
!!$
!!$  write(0,*) 'resorting2'
!!$  last_index=1
!!$  do it=2,total_sparse
!!$     if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
!!$        call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
!!$        last_index=it
!!$     end if
!!$  end do
!!$  do it=1,3
!!$     sparse_mat(1:,it)=sparse_mat_sort(it,1:)
!!$  end do
!!$  deallocate(sparse_mat_sort)
!!$
!!$  ! COMPUTE d_vec and d_vec_exp
!!$  write(0,*) 'computing D and D^-.5' 
!!$  last_index=1
!!$  do it=2,total_sparse
!!$     if (sparse_mat(it,1)/=sparse_mat(it-1,1)) then
!!$        d_vec(nint(sparse_mat(it-1,1)))=sum(sparse_mat(last_index:it-1,3))
!!$        d_vec_exp(nint(sparse_mat(it-1,1)))=d_vec(nint(sparse_mat(it-1,1)))**-.5
!!$        last_index=it
!!$     end if
!!$  end do
!!$  d_vec(nint(sparse_mat(total_sparse,1)))=sum(sparse_mat(last_index:total_sparse,3))
!!$  d_vec_exp(nint(sparse_mat(total_sparse,1)))=d_vec(nint(sparse_mat(total_sparse,1)))**-.5
!!$
!!$  ! COMPUTE D-W
!!$  write(0,*) 'D-W'
!!$  allocate(DminusW(total_sparse,3))
!!$  DminusW(1:,1:2)=sparse_mat(1:,1:2)
!!$  DminusW(1:,3)=-1*sparse_mat(1:,3)
!!$  do sparse_index=1,total_sparse
!!$     if (sparse_mat(sparse_index,1)==sparse_mat(sparse_index,2))then
!!$        DminusW(sparse_index,1:2)=sparse_mat(sparse_index,1:2)
!!$        DminusW(sparse_index,3)=d_vec(nint(sparse_mat(sparse_index,2)))-sparse_mat(sparse_index,3)
!!$     end if
!!$  end do
!!$
!!$
!!$  ! COMPUTE (D-W)*D^.5
!!$  allocate(DminusWD(total_sparse,3))
!!$  do sparse_index=1,total_sparse
!!$     DminusWD(sparse_index,1:2)=DminusW(sparse_index,1:2)
!!$     DminusWD(sparse_index,3)=DminusW(sparse_index,3)*d_vec_exp(nint(DminusWD(sparse_index,2)))
!!$  end do
!!$  deallocate(DminusW)
!!$
!!$  ! COMPUTE D^.5*(D-W)*D^.5
!!$  write(0,*) 'D^-.5(D-W)D^-.5'
!!$  allocate(DDminusWD(total_sparse,3))
!!$  do sparse_index=1,total_sparse
!!$     DDminusWD(sparse_index,1:2)=DminusWD(sparse_index,1:2)
!!$     DDminusWD(sparse_index,3)=DminusWD(sparse_index,3)*&
!!$          d_vec_exp(nint(DminusWD(sparse_index,1)))
!!$  end do
!!$  deallocate(DminusWD)

  ! RESHAPE TO 1D
  allocate(sparse_mat_1d(sparse_mat_index1*3))
  do it=1, sparse_mat_index1
     sparse_mat_1d(1+(it-1)*3:3+(it-1)*3)=sparse_mat_node1(it,1:3)
  end do
  deallocate(sparse_mat_node1)

  ! RITE OUT THE SPARSE MATRIX
  write(0,*) 'writing out data'
  call srite("out",sparse_mat_1d,4*sparse_mat_index1*3)
  call to_history( "n1",3 );call to_history( "n2",  sparse_mat_index1 );  call to_history( "n3", 1 )
  call to_history( "d1", 1.);          call to_history( "d2", 1.);  call to_history( "d3", 1.)
  call to_history( "o1", 0.);          call to_history( "o2", 0.);  call to_history( "o3", 0.)
  call to_history("esize",4);
!!$
  ! RITE TO THE HISTORY FILE THE SIZE OF THE IMAGE WITHIN THE MASK AND OTHER PARAMETERS
!!$  call to_history("nt",nt); call to_history("nx",nx); call to_history("ny",ny)
!!$  call to_history("ot",ot); call to_history("ox",ox);  call to_history("oy",oy); 
!!$  call to_history("dt",dt); call to_history("dx",dx); call to_history("dy",dy); 
!!$  call to_history("non_zero_mask",wt_mat_sz);
!!$  call to_history("ncv_val",ncv_val);
!!$  deallocate(DDminusWD)

!!$  call to_history("n1",wt_mat_sz,"look_up"); call to_history("n2",3,"look_up") 
!!$  call to_history("n3",1.,"look_up")
!!$  call to_history("d1",1.,"look_up"); call to_history("d2",1,"look_up")
!!$  call to_history("d3",1.,"look_up")
!!$  call to_history("o1",0.,"look_up"); call to_history("o2",0.,"look_up")
!!$  call to_history("o3",0.,"look_up")
!!$  call to_history("esize",4,"look_up")
!!$  call sep_write(look_up_tab,"look_up")
!!$  deallocate(look_up_tab)

!!$  call to_history("n1",wt_mat_sz,"d_vec_exp"); call to_history("n2",1,"d_vec_exp") 
!!$  call to_history("n3",1.,"d_vec_exp")
!!$  call to_history("d1",1.,"d_vec_exp"); call to_history("d2",1,"d_vec_exp")
!!$  call to_history("d3",1.,"d_vec_exp")
!!$  call to_history("o1",0.,"d_vec_exp"); call to_history("o2",0.,"d_vec_exp")
!!$  call to_history("o3",0.,"d_vec_exp")
!!$  call to_history("esize",4,"d_vec_exp")
!!$  call sep_write(d_vec_exp,"d_vec_exp")
!!$  deallocate(d_vec_exp)
  call sep_end_prog()
end program Psegment_main3d_python

