program Psegment_main
  ! Main program for parallel segmentation

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod
  use sample_mod
  use psegment_mod

  implicit none

  integer				::nt, nx, ny, wt_mat_sz
  integer				::it,ix,ir,iq,iz,max_dist,dense_dist
  integer                               ::irow,row1,col1,row2,col2,val_cnt,n_new_val,rand_jump_int
  integer                               ::box_size,big_box_size,fill
  integer                               ::row2_raw,col2_raw,delta_row2,delta_col2
  integer                               ::row1_grid,col1_grid,row2_grid,col2_grid
  integer                               ::irow_mat,icol_mat,sample_num,nodes
  integer                               ::drow,row1_back,col1_back,row2_back,col2_back
  integer                               ::sparse_mat_index,col_in_row,sparse_index
  integer                               ::box_x,box_t,stat1,dcol,index_new
  integer                               ::total_sparse,row_count,smpl_cnt
  integer                               ::newsize,ncv_val,mem_alloc
  integer                               ::ignore_wrapping, sparse_mat_index1, sparse_mat_index2
  integer                               ::ub_n1,lb_n1,max_wt_num
  integer,allocatable, dimension(:,:)               ::sample_template,sample_template2
  real                                  ::maxdat,mindat,rangedat,amp_thresh,zero_tol
  real                                  ::rand_jump,dist,iz_rl, wt,pi_var,sample_scale
  real                                  ::row1_grid_rl,col1_grid_rl,row2_grid_rl,col2_grid_rl
  real                                  ::subsam_increment,dt,dx,ot,ox,attr_coef
  real                                  ::dy,oy
  real,dimension(:),allocatable		::dd,norm_d_1d
  real,dimension(:),allocatable		::topbnd,botbnd
  real,dimension(:),allocatable	        ::val_list,box_grid_1d,d_vec,d_vec_exp
 real,dimension(:),allocatable	        ::sparse_mat_1d
  real, pointer, dimension(:,:)	        ::d, norm_d,xy,sparse_mat_node1,sparse_mat_node2
  real, pointer, dimension(:,:)	        ::DminusW,DminusWD,DDminusWD
  real, dimension(:,:),allocatable      ::box_grid,box_grid_col,box_grid_row
  real, dimension(:,:),allocatable      ::look_up_tab,look_up_image
  real, dimension(:,:),allocatable      ::sparse_mat_sort
  real, dimension(:,:),allocatable      ::box_grid_bnds,mask_in
  real, dimension(:,:),allocatable      ::sparse_mat2,tester,upper_bnd,lower_bnd,upper_bnd_tracker,lower_bnd_tracker 
  real, dimension(:,:),allocatable      ::sparse_mat
  real, dimension(:,:),allocatable      ::first_attribute
  integer                               ::  first_index,last_index

  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)
  call sep_begin_prog()

  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);

  call from_history("d1",dt); call from_history("d2",dx);call from_history("d3",dy)
  call from_history("o1",ot); call from_history("o2",ox); call from_history("o3",oy)

  call from_param("max_dist",max_dist,21)
  call from_param("dense_dist",dense_dist,20)
  call from_param("amp_thresh",amp_thresh,.93)
  call from_param("zero_tol",zero_tol,.0001)
  call from_param("ncv_val",ncv_val,20)
  call from_param("mem_alloc",mem_alloc,175000000)
  call from_param("sample_scale",sample_scale,4.)
  call from_param("subsam_increment",subsam_increment,1.)
  call from_param("ignore_wrapping",ignore_wrapping,0)
  call from_param("attr_coef",attr_coef,100000.)

  ub_n1=0 ; lb_n1=0
  if (exist_file("upper_bnd_vec")) call from_aux("upper_bnd_vec","n1",ub_n1) ! UPPER BOUNDARY N1
  if (exist_file("lower_bnd_vec")) call from_aux("lower_bnd_vec","n1",lb_n1) ! LOWER BOUNDARY N1



  write(0,*) 'ub_n1',ub_n1,'lb_n1',lb_n1

  ! ALLOCATE INPUT DATA AND MASK
  allocate(d(nt,nx),mask_in(nt,nx),norm_d(nt,nx),norm_d_1d(nt*nx),upper_bnd(nt,nx),upper_bnd_tracker(ub_n1,6),lower_bnd(nt,nx),lower_bnd_tracker(lb_n1,6),first_attribute(nt,nx))

  ! READ INPUT DATA
  call sep_read(d)

  ! INVERT AND NORMALIZE THE DATA
  d=d*-1.
  maxdat=maxval(d)
  mindat=minval(d)
  rangedat=maxdat-mindat
  norm_d=(d/rangedat-mindat/rangedat)
  deallocate(d)
  norm_d_1d=reshape(norm_d,(/nt*nx/))

  ! READ IN INPUT MASK
  mask_in=1. ;upper_bnd=1.;lower_bnd=1. ;first_attribute=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx) 

  ! READ IN UPPER AND LOWER BOUNDARIES:   t, x , norm_t , norm x
  if (exist_file("upper_bnd_vec")) call sreed("upper_bnd_vec", upper_bnd_tracker,4*ub_n1*6)
  if (exist_file("lower_bnd_vec")) call sreed("lower_bnd_vec", lower_bnd_tracker,4*lb_n1*6)

  if (exist_file("upper_bnd")) call sreed("upper_bnd", upper_bnd,4*nt*nx)
  if (exist_file("lower_bnd")) call sreed("lower_bnd", lower_bnd,4*nt*nx)


  if (exist_file("first_attribute")) call sreed("first_attribute", first_attribute,4*nt*nx)

!!$  ! COUNT NONZERO VALUES IN MASK
  !wt_mat_sz=0
  wt_mat_sz=0

  do it=1,nt
     do ix=1,nx
        if (real(it)/subsam_increment-floor(real(it)/subsam_increment)<0.01.and.real(ix)/subsam_increment-floor(real(ix)/subsam_increment)<0.01.and.mask_in(it,ix)==1.) then
           wt_mat_sz=wt_mat_sz+1
        end if
     end do
  end do

!!$  ! MAKE A LOOK UP TABLE TO TRANSFORM DATA TO WEIGHT
  allocate(look_up_tab(wt_mat_sz,3))


  ! MAKE A LOOK UP TABLE TO TRANSFORM DATA TO WEIGHT
  allocate(look_up_image(nt,nx))
  ir=0
  look_up_image=0.
  do ix=1,nx
     !   row_count=0
     do it=1,nt
        if  (real(it)/subsam_increment-floor(real(it)/subsam_increment)<0.01.and.real(ix)/subsam_increment-floor(real(ix)/subsam_increment)<0.01.and.mask_in(it,ix)==1.) then
           ir=ir+1
           !        row_count=row_count+1
           look_up_tab(ir,1)=ir  ! wt row (or column as they are the same)
           look_up_tab(ir,2)=it !row_count  ! data row
           look_up_tab(ir,3)=ix  ! data column
           look_up_image(it,ix)=ir

        end if
     end do
  end do

  write(0,*) 'weight_mat_sz',wt_mat_sz






!!$  do it=1,ir
!!$     write(0,*) look_up_tab(it,1:)
!!$  end do



  ! ALLOCATE SPARSE MATRIX ...MAKE AS BIG AS ALLOWABLE
  allocate(sparse_mat_node1(3,3),sparse_mat_node2(3,3))! 175000000

  ! ALLOCATE NEW POINT TRACKER AND GRID
  !box_size=dense_dist*2+1
  !big_box_size=max_dist*2+1
  !fill=max_dist-dense_dist
  pi_var=acos(-1.)
  max_wt_num=(max_dist*2+1)**2 !max number of weights for each node
  write(0,*) 'max number of random samples',nint(sample_scale*(3.*pi_var*real(max_dist))) 

  allocate(d_vec(wt_mat_sz),d_vec_exp(wt_mat_sz))
 

  ! LOOP OVER EACH ROW OF THE WEIGHT MATRIX
  sparse_mat_index=0 ! index of sparse matrix
  col_in_row=0       ! keep track of number of column in each row

  call from_param("first_index",first_index,1)
  call from_param("last_index",last_index,wt_mat_sz)

  sparse_mat_index1=0
write(0,*) 'first node',sparse_mat_index1
call find_weight_mat(first_index,last_index,nx,nt,mem_alloc/2,sample_scale,wt_mat_sz,max_dist,max_wt_num,amp_thresh,zero_tol,norm_d,norm_d_1d,sparse_mat_node1,sparse_mat_index1,col_in_row,look_up_image,look_up_tab,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)
  ! RESHAPE TO 1D
  allocate(sparse_mat_1d(sparse_mat_index1*3))
  do it=1, sparse_mat_index1
     sparse_mat_1d(1+(it-1)*3:3+(it-1)*3)=sparse_mat_node1(it,1:3)
  end do
  deallocate(sparse_mat_node1)

write(0,*) "OUT WHE",sparse_mat_index1
  call to_history("n1",3)
  call to_history("n2",sparse_mat_index1)
  call srite("out" , sparse_mat_1d,4*3*sparse_mat_index1)

 ! RITE TO THE HISTORY FILE THE SIZE OF THE IMAGE WITHIN THE MASK AND OTHER PARAMETERS
  call to_history("nt",nt); call to_history("nx",nx); call to_history("ny",ny)
  call to_history("ot",ot); call to_history("ox",ox); call to_history("oy",oy); 
  call to_history("dt",dt); call to_history("dx",dx); ; call to_history("dy",dy); 
  call to_history("non_zero_mask",wt_mat_sz);
  call to_history("ncv_val",ncv_val);

  call sep_end_prog()
end program
