module paint_mod3d_2
!!! pass the function calc_cut an image, eigenvector, a cut threshold, and a weight matrix 
!!! and it will return the normalized cut value 
  use lint2
  use sep
  use warp_mod
  use lint
  use sorting_mod

contains
  real function calc_cut(eig_vec,cut_val,wt_mat)
    real,  dimension(:)	                                :: eig_vec,eig_vec_split
    real,  dimension(:,:)	                                :: wt_mat
    real							::cut_val,cutsum,assoc_A,assoc_B 
    integer							:: ix,iy,eig_sz,cnter,cnter_2
!!$
!!$write(0,*) 'cut_val', cut_val
!!$write(0,*) 'eig_vec',maxval(eig_vec),minval(eig_vec)
!!$write(0,*) eig_vec

    allocate(eig_vec_split(size(eig_vec)))
    eig_vec_split=0.
    eig_sz=size(eig_vec)
    !  write(0,*) 'eig_vec', eig_vec
    cnter=0
    cnter_2=0
    do ix=1,eig_sz
       if (eig_vec(ix)>=cut_val) then
          eig_vec_split(ix)=1  !%group A
          cnter=cnter+1 
       else
          eig_vec_split(ix)=0  !% group B
          cnter_2=cnter_2+1
       end if
    end do
    write(0,*) 'number of nodes in group A',cnter
    write(0,*) 'number of nodes in group B',cnter_2
    cutsum=0;
    !  %calculate cut, numerator
    !  %for each column in wt_mat in group A, sum all the rows in group B
    do iy=1,eig_sz
       if (eig_vec_split(iy)==1) then ! % is in group A?
          do ix=1,eig_sz
             if (eig_vec_split(ix)==0) then !%is the row in group B?
                cutsum=cutsum+wt_mat(ix,iy)
             end if
          end do
       end if
    end do

    assoc_A=0;
    assoc_B=0;
    !       %calculate assocations for group A and B.  basically, calculate all of the
    !      %connections for all nodes in group A.
    do iy=1,eig_sz
       if (eig_vec_split(iy)==1)  then !%is in group A? if so sum the columns
          assoc_A=assoc_A+sum(wt_mat(:,iy))   !% the -1 is for the diagonal....UNCERTAIN
       else  !% implies the column is in group B
          assoc_B=assoc_B+sum(wt_mat(:,iy))
       end if
    end do

    calc_cut= cutsum/assoc_A+cutsum/assoc_B
    deallocate(eig_vec_split) 
  end function calc_cut


  real function calc_cut_sparse(eig_vec,cut_val,sparse_mat)
    real,  dimension(:)	                                :: eig_vec,eig_vec_split
    real,  dimension(:,:)	                                :: sparse_mat
    real							::cut_val,cutsum,assoc_A,assoc_B 
    integer							:: ix,iy,eig_sz,cnter,cnter_2,sparse_sz
!!$
!!$write(0,*) 'cut_val', cut_val
!!$write(0,*) 'eig_vec',maxval(eig_vec),minval(eig_vec)
!!$write(0,*) eig_vec

    allocate(eig_vec_split(size(eig_vec)))
    eig_vec_split=0.
    eig_sz=size(eig_vec)
    sparse_sz=size(sparse_mat(1:,1))
    !  write(0,*) 'eig_vec', eig_vec
    cnter=0
    cnter_2=0
    do ix=1,eig_sz
       if (eig_vec(ix)>=cut_val) then
          eig_vec_split(ix)=1  !%group A
          cnter=cnter+1 
       else
          eig_vec_split(ix)=0  !% group B
          cnter_2=cnter_2+1
       end if
    end do
    write(0,*) 'number of nodes in group A',cnter
    write(0,*) 'number of nodes in group B',cnter_2
    cutsum=0;
    !  %calculate cut, numerator
    !  %for each column in wt_mat in group A, sum all the rows in group B
    do ix=1,sparse_sz
       if (eig_vec_split (nint(sparse_mat(ix,2)))==1) then ! is this column in group A?
          if (eig_vec_split (nint(sparse_mat(ix,1)))==0) then ! is its row is group B?
             cutsum=cutsum+sparse_mat(ix,3)
          end if
       end if
    end do

    assoc_A=0;
    assoc_B=0;
    !       %calculate assocations for group A and B.  basically, calculate all of the
    !      %connections for all nodes in group A.
    do ix=1, sparse_sz
       !if (sparse_mat(ix,2)>=sparse_mat(ix,1))then  ! consider only upper triangle matrix 
       if (eig_vec_split(nint(sparse_mat(ix,2))==1)) then !is this column value in group A? 
          assoc_A=assoc_A+sparse_mat(ix,3)
       else  ! then it is in group B
          assoc_B=assoc_B+sparse_mat(ix,3)
       end if
       !end if
    end do

    !write(0,*) 'assoc_A',assoc_A
    !write(0,*) 'assoc_B',assoc_B


    deallocate(eig_vec_split)
    write(0,*) 'cutsum', cutsum

    calc_cut_sparse= (cutsum*assoc_A)/(.000001+assoc_A**2)+(cutsum*assoc_B)/(.000001*assoc_B**2)
  end function calc_cut_sparse



  real function calc_cut_sparse2(eig_vec,cut_val,sparse_mat)
    real,  dimension(:)	                                :: eig_vec,eig_vec_split
    real,  dimension(:,:)	                                :: sparse_mat
    real							::cut_val,cutsum,assoc_A,assoc_B 
    integer							:: ix,iy,eig_sz,cnter,cnter_2,sparse_sz
!!$
!!$write(0,*) 'cut_val', cut_val
!!$write(0,*) 'eig_vec',maxval(eig_vec),minval(eig_vec)
!!$write(0,*) eig_vec

    allocate(eig_vec_split(size(eig_vec)))
    eig_vec_split=0.
    eig_sz=size(eig_vec)
    sparse_sz=size(sparse_mat(1:,1))
    !  write(0,*) 'eig_vec', eig_vec
    cnter=0
    cnter_2=0
    do ix=1,eig_sz
       if (eig_vec(ix)>=cut_val) then
          eig_vec_split(ix)=1  !%group A
          cnter=cnter+1 
       else
          eig_vec_split(ix)=0  !% group B
          cnter_2=cnter_2+1
       end if
    end do
    write(0,*) 'number of nodes in group A',cnter
    write(0,*) 'number of nodes in group B',cnter_2
    cutsum=0;
    !  %calculate cut, numerator
    !  %for each column in wt_mat in group A, sum all the rows in group B
    do ix=1,sparse_sz
       if (eig_vec_split (nint(sparse_mat(ix,2)))==1) then ! is this column in group A?
          if (eig_vec_split (nint(sparse_mat(ix,1)))==0) then ! is its row is group B?
             cutsum=cutsum+sparse_mat(ix,3)
          end if
       end if
    end do

    assoc_A=0;
    assoc_B=0;
    !       %calculate assocations for group A and B.  basically, calculate all of the
    !      %connections for all nodes in group A.
    do ix=1, sparse_sz
       if (eig_vec_split(nint(sparse_mat(ix,2))==1)) then !is this column value in group A? 
          assoc_A=assoc_A+sparse_mat(ix,3)
       else  ! then it is in group B
          assoc_B=assoc_B+sparse_mat(ix,3)
       end if
    end do

    !write(0,*) 'assoc_A',assoc_A
    !write(0,*) 'assoc_B',assoc_B


    deallocate(eig_vec_split)

    !  calc_cut_sparse= (cutsum*assoc_A)/(.000001+assoc_A**2)+(cutsum*assoc_B)/(.000001*assoc_B**2)
    calc_cut_sparse2 = cutsum !(cutsum*assoc_A)/(.000001+assoc_A**2)+(cutsum*assoc_B)/(.000001*assoc_B**2)
  end function calc_cut_sparse2

  subroutine make_simple_model(model)
    real,dimension(:,:)   :: model
    real                  ::radius,shift
    integer               ::ix,iy,n1,n2
    n1=size(model(1:,1))
    n2=size(model(1,1:))
    write(0,*) n1,n2
    model=1.
    radius=n2/3
    do iy=1,radius
       shift=max(min(sqrt(radius**2.-(iy)**2.),n2-1),1.)
       write(0,*) real(n2/2),shift,nint(real(shift))
       model(iy,nint(real(shift)):nint(real(shift))+1)=0.2

    end do
    !model(nint(n1/2.)-10:nint(n1/2.)+10,1:)=1.
    !model(15:20,3*n2/4:1+3*n2/4)=0.2
    !model(15,3*n2/4:)=0.2
    !stop
  end subroutine make_simple_model


  subroutine make_cube(model)
    real,dimension(:,:,:)   :: model
    real                  ::shift
    integer               ::ix,iy,n1,n2,n3
    n1=size(model(1:,1,1))
    n2=size(model(1,1:,1))
    n3=size(model(1,1,1:))
    write(0,*) n1,n2,n3
    model=1.

    do iy=1,n3/2
       do ix=n2/2,n2
          model(nint(real(n1)/2.),ix,iy)=0.2
       end do
       model(nint(real(n1)/2.):,nint(real(n2)/2.),iy)=.2
       !model(nint(n1/2)-10:nint(n1/2)+10,1:)=1.
       !model(15:20,3*n2/4:1+3*n2/4)=0.2
       !model(15,3*n2/4:)=0.2
       !stop
    end do
    model(nint(real(n1)/2.):,nint(real(n2)/2.):,n3/2)=.2

!!$model=1.
!!$model(:,n2/2:n2/2+1,:)=.2

  end subroutine make_cube



!!$  
!!$    subroutine make_weight(norm_d,sparse_mat)
!!$      real,dimension(:,:)::norm_d,sparse_mat
!!$      integer :: matlen,icol,irow,inonzero,nt,nx
!!$      real :: phiI,phiX,icol1_rl,irow1_rl,icol2_rl,irow2_rl,max_dist,dist,dist_exp
!!$      nt=size(norm_d(1:,1))
!!$      nx=size(norm_d(1,1:))
!!$      phiI=.1
!!$      phiX=4.
!!$      max_dist=7.
!!$      inonzero=1
!!$
!!$   !   allocate(sparse_mat(1,3))
!!$      do icol=1,nx*nt
!!$         do irow=1,nx*nt
!!$            icol_rl=icol
!!$            irow_rl=irow
!!$            row1=floor((icol_rl-1.)/nx)+1
!!$            col1=icol_rl-(row1-1)*nx;
!!$
!!$            row2=floor((irow_rl-1.)/nx)+1
!!$            col2=irow_rl-(row2-1)*nx
!!$            row1_rl=row1
!!$            col1_rl=col1
!!$            row2_rl=row2
!!$            col2_rl=col2
!!$
!!$
!!$            dist=sqrt((row1_rl-row2_rl)**2+(col1_rl-col2_rl)**2)
!!$            if (dist>max_dist) then !was 7 ! was 5.
!!$               !     dist_exp=0.
!!$            else
!!$               dist_exp=exp(-dist/(phiX**2))
!!$               !      end if
!!$               !     W_mat(icol,irow)=exp(-(norm_d(row1,col1)-norm_d(row2,col2))**2/(phiI**2))*dist_exp
!!$
!!$               sparse_mat(inonzero,1)=irow
!!$               sparse_mat(inonzero,2)=icol
!!$               sparse_mat(inonzero,3)=exp(-(norm_d(row1,col1)-norm_d(row2,col2))**2/(phiI**2))*dist_exp
!!$               inonzero=inonzero+1
!!$
!!$               allocate(sparse_mat2(inonzero-1,3))
!!$               sparse_mat2=sparse_mat
!!$               deallocate(sparse_mat)
!!$               allocate(sparse_mat(inonzero,3))
!!$               sparse_mat(1:inonzero-1,1:)=sparse_mat2
!!$               deallocate(sparse_mat2)
!!$
!!$            end if
!!$         end do
!!$      end do
!!$    end subroutine make_weight

  subroutine make_sparse(mat,sparse_mat)
    !    real,dimension(:,:)   :: model
    real, dimension(:,:)::mat,sparse_mat  !!!2d array::  nnonzero X 3
    integer               ::irow,icol,nrow,ncol,inonzero,nnonzero,nWeight
    nnonzero=size(sparse_mat(1:,1))
    nWeight=size(mat(1:,1))
    !   nrow=size(mat(1,1:))
    inonzero=1
    do irow=1,nWeight
       do icol=1,nWeight
          if (mat(irow,icol)/=0) then
             sparse_mat(inonzero,1)=irow
             sparse_mat(inonzero,2)=icol
             sparse_mat(inonzero,3)=mat(irow,icol)
             inonzero=inonzero+1
          end if
       end do
    end do


  end subroutine make_sparse

  subroutine sparse_mat_mult(mat,vec,mat_vec,nt,nx,ny)
    integer               ::irow,icol,nrow,ncol,inonzero,nnonzero,nt,nx,ny
    real, dimension(:,:)::mat  !!!2d array::  nnonzero X 3
    real,dimension(:)::vec(nt*nx*ny),mat_vec(nt*nx*ny)

    nnonzero=size(mat(1:,1))
    mat_vec=0.
    do inonzero=1,nnonzero
       irow=mat(inonzero,1)
       icol=mat(inonzero,2)
       mat_vec(irow)=mat_vec(irow)+mat(inonzero,3)*vec(icol)
    end do
    !     mat_vec=mat_vec*25
  end subroutine sparse_mat_mult

  subroutine sparse_mat_mult2(mat,vec,mat_vec,mat_size)
    integer               ::irow,icol,nrow,ncol,inonzero,nnonzero,mat_size
    real, dimension(:,:)::mat  !!!2d array::  nnonzero X 3
    real,dimension(:)::vec(mat_size),mat_vec(mat_size)

    nnonzero=size(mat(1:,1))
    mat_vec=0.
    do inonzero=1,nnonzero
       irow=mat(inonzero,1)
       icol=mat(inonzero,2)
       mat_vec(irow)=mat_vec(irow)+mat(inonzero,3)*vec(icol)
    end do
    !     mat_vec=mat_vec*25
  end subroutine sparse_mat_mult2

!!$  subroutine weight_to_data(nx,icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat) 
!!$    !this converts weight matrix indicies into the 2 data matrix nodes they correspond to
!!$    !nx is the width of the data matrix
!!$    integer               ::icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat,nx
!!$    real                  ::icol_rl,irow_rl
!!$    icol_rl=icol_wt
!!$    irow_rl=irow_wt
!!$    irow1_dat=floor((icol_rl-1.)/real(nx))+1
!!$    icol1_dat=icol_rl-(irow1_dat-1)*real(nx);
!!$
!!$    irow2_dat=floor((irow_rl-1.)/real(nx))+1
!!$    icol2_dat=irow_rl-(irow2_dat-1)*real(nx)
!!$  end subroutine weight_to_data
!!$  subroutine weight_to_data_3D(nt,nx,icol_wt,irow_wt,icolx1_dat,icoly1_dat,irow1_dat,icolx2_dat,icoly2_dat,irow2_dat) 
!!$    !this converts weight matrix indicies into the 3 data matrix nodes they correspond to
!!$    !nx is the width of the data cube,nt is the height of the cube
!!$    integer               ::icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat,nx,nt
!!$    real                  ::icol_rl,irow_rl
!!$    icol_rl=icol_wt
!!$    irow_rl=irow_wt
!!$
!!$    icoly1_dat   =   floor((icol_rl-1.)/(real(nt*nx)))+1                     ! plane 
!!$    irow1_dat    =   floor((icol_rl-(icoly1_dat-1)*real(nx*nt)-1)/nx)+1    ! row
!!$    icolx1_dat   =   icol_rl-(icoly1_dat-1)*real(nx*nt)-(irow1_dat-1)*real(nx)  ! colx
!!$
!!$    icoly2_dat   =   floor((irow_rl-1.)/real(nt*nx))+1                     ! plane
!!$    irow2_dat    =   floor((irow_rl-(icoly2_dat-1)*real(nx*nt)-1)/real(nx))+1    ! row 
!!$    icolx2_dat   =   irow_rl-(icoly2_dat-1)*real(nx*nt)-(irow2_dat-1)*real(nx)! ! colx
!!$
!!$
!!$  end subroutine weight_to_data_3D

  subroutine data_to_weight_3D(nt,nx,icol_wt,irow_wt,icolx1_dat,icoly1_dat,irow1_dat,icolx2_dat,icoly2_dat,irow2_dat) 
    !this converts 3 data nodes into the indicies of the weight matrix
    integer               ::icol_wt,irow_wt,icolx1_dat,icoly1_dat,irow1_dat,icolx2_dat,icoly2_dat,irow2_dat,nx,nt

    icol_wt=(icoly1_dat-1)*real(nt*nx) + (irow1_dat-1)*real(nx)  + icolx1_dat
    irow_wt=(icoly2_dat-1)*real(nt*nx) + (irow2_dat-1)*real(nx)  + icolx2_dat


  end subroutine data_to_weight_3D

  subroutine data_to_weight(nx,icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat) 
    !this converts 2 data nodes into the indicies of the weight matrix
    integer               ::icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat,nx



    icol_wt=(irow1_dat-1)*real(nx)+icol1_dat
    irow_wt=(irow2_dat-1)*real(nx)+icol2_dat

  end subroutine data_to_weight

  subroutine create_template3d(sample_template,smpl_cnt,max_dist,subsam_increment)

    integer                        ::cnt,onion_num,smpl_cnt,onion,max_dist
    integer                        ::grid_index,center_index,num_stage
    integer                        ::ix,iy,it,istage,subsam_increment
    integer,dimension(:,:)           ::sample_template
    real,dimension(:,:)              ::stage_par

    num_stage=2
    allocate(stage_par(num_stage,3))
    stage_par(1,1)=1.*real(subsam_increment) !min distance of first stage
    stage_par(1,2)=4.*real(subsam_increment) !max distance of first stage
    stage_par(1,3)=1.*real(subsam_increment) !sampling of first stage
    stage_par(2,1)=5.*real(subsam_increment)!5. !min distance of second stage
    stage_par(2,2)=8.*real(subsam_increment)!8 10. !max distance of second stage
    stage_par(2,3)=2.*real(subsam_increment) !sampling of second stage
!!$    stage_par(3,1)=11.*real(subsam_increment) !min distance of stage
!!$    stage_par(3,2)=30.*real(subsam_increment) !max distance of  stage
!!$    stage_par(3,3)=20.*real(subsam_increment) !sampling of stage

    smpl_cnt=0
    grid_index=0
    center_index=4*max_dist**3+6*max_dist**2+3*max_dist+1
    ! LOOP OVER ALL POSSIBLE POSITIONS AND KEEP PNTS THAT SATISFY THE PARAMETERS
    loopover_y: do iy=-max_dist,max_dist
       loopover_x: do ix=-max_dist,max_dist
          loopover_t: do it=-max_dist,max_dist
             grid_index=grid_index+1
             uppertriagle:  if (grid_index>center_index) then
                loopover_stage: do istage=1,num_stage

                   if( max(abs(ix),abs(it),abs(iy))>=stage_par(istage,1).and.max(abs(ix),abs(it),&
                   abs(iy))<=stage_par(istage,2)) then  ! if within pars,, keep it

                      if (abs(real(it)/stage_par(istage,3))-floor(abs(real(it)/stage_par(istage,3)))<.0001.and.&
                      abs(real(ix)/stage_par(istage,3))-floor(abs(real(ix)/stage_par(istage,3)))<.0001 .and.&
                      abs(real(iy)/stage_par(istage,3))-floor(abs(real(iy)/stage_par(istage,3)))<.0001) then
                         smpl_cnt=smpl_cnt+1
                         sample_template(smpl_cnt,1)=it;sample_template(smpl_cnt,2)=ix
                         sample_template(smpl_cnt,3)=iy
                      end if
                   end if
                end do loopover_stage
             end if uppertriagle

          end do loopover_t
       end do loopover_x
    end do loopover_y

    deallocate(stage_par)

  end subroutine create_template3d



  subroutine make_grid3d(nx,ny,nt,max_dist,row1,colx1,coly1,box_grid,box_grid_row,box_grid_colx,box_grid_coly,box_grid_bnds,norm_d,mask_in,outer_bnd,outer_bnd_tracker,outer_bnd_sum,inner_bnd,inner_bnd_tracker,inner_bnd_sum,irow)   

    integer                             :: box_x,box_y,box_t,big_box_size,it,ix,iy
    integer                             :: nx,ny,nt,max_dist,row1,colx1,coly1,rand_jump_int
    integer                             ::row2_raw,col2x_raw,col2y_raw,delta_row2,delta_col2
    integer                             ::row2,col2x,col2y,too_far,dumbtest,found1
    integer                             ::n_row,n_colx,n_coly,outer_shft1,outer_bnd_sum,inner_shft1
    integer                             ::inner_bnd_sum,step,n_row2,n_col2x,n_col2y,irow
    real                                ::rand_jump,vec_length,norm_length
    real                                ::drow,dcolx,dcoly,norm_dist1,xt_dist,yt_dist
    real,dimension(:)			::norm_at_bnd,vec_at_new_bnd,norm_at_new_bnd,row2_2bnd
    real,dimension(:)                   ::xt_basis,xt_basis_2,yt_basis,yt_basis_2
    real,dimension(:,:)                   ::inner_bnd_tracker,outer_bnd_tracker  
    real, dimension(:,:,:)              ::box_grid,box_grid_colx,box_grid_coly,box_grid_row
    real, dimension(:,:,:)              ::box_grid_bnds,norm_d,mask_in
    real, dimension(:,:,:,:)            ::inner_bnd,outer_bnd

    big_box_size=max_dist*2+1

!!$    ! IF EVEN, JUMP A CERTAIN DISTANCE, IF ODD JUMP ANOTHER
!!$    if (real(irow)/2.-floor(real(irow)/2.)>.001) then
!!$       outer_shft1=outer_bnd_sum/2
!!$       inner_shft1=inner_bnd_sum/2
!!$
!!$    else 
!!$       outer_shft1=outer_bnd_sum/4
!!$       inner_shft1=inner_bnd_sum/4
!!$    end if
    ! IF EVEN, JUMP A CERTAIN DISTANCE, IF ODD JUMP ANOTHER
    if (real(irow)/4.-floor(real(irow)/4.)>.001) then
       outer_shft1=outer_bnd_sum/2
       inner_shft1=inner_bnd_sum/2
    else if (real(irow+1)/4.-floor(real(irow+1)/4.)>.001) then
       outer_shft1=outer_bnd_sum/3
       inner_shft1=inner_bnd_sum/3
    else  if (real(irow+2)/4.-floor(real(irow+2)/4.)>.001) then
       outer_shft1=outer_bnd_sum/4
       inner_shft1=inner_bnd_sum/4
    else
       outer_shft1=outer_bnd_sum/5
       inner_shft1=inner_bnd_sum/5
    end if

    allocate(norm_at_bnd(3),vec_at_new_bnd(3),norm_at_new_bnd(3),row2_2bnd(3))
    allocate(xt_basis(3),xt_basis_2(3),yt_basis(3),yt_basis_2(3))   
    ! AROUND EACH POINT IN THE IMAGE, CONTRUCT A GRID TO SAMPLE FROM row1,col1 to row2,col2
    ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
    call random_number(rand_jump)
    outer_shft1=rand_jump*real(outer_bnd_sum-1)+1   
    inner_shft1=rand_jump*real(inner_bnd_sum-1)+1



    loop_box_y1: do box_y=1,big_box_size ! box_y is the column indicator
       loop_box_x1: do box_x=1,big_box_size ! box_x is the column indicator
          loop_box_t1: do box_t=1,big_box_size ! box_t is the row indicator
             row2_raw=row1+(box_t-1)-max_dist 
             col2x_raw=colx1+(box_x-1)-max_dist
             col2y_raw=coly1+(box_y-1)-max_dist
             too_far=0
             ! MAKE SURE THE NEW POINT IS IN THE DATA CUBE
             within_bnds:  if (row2_raw>=1.and.row2_raw<=nt.and.col2x_raw>=1.and.col2x_raw<=nx&
             .and.col2y_raw>=1.and.col2y_raw<=ny) then

                ! IF POINT IS OUT OF MASK
                out_of_mask: if (mask_in(row2_raw,col2x_raw,col2y_raw)/=1.) then

!!$write(0,*) row2_raw,col2x_raw,col2y_raw
!!$write(0,*) row1,colx1,coly1

                   ! ! .25 MEANS INSIDE THE SALT .75 MEANS OUTSIDE THE SALT
                   ! if (mask_in(row2_raw,col2x_raw,col2y_raw)==.75) then

                   !FIND CLOSE BOUNDARY POINT BY SEARCH A 3 BY 3 BY 3 CUBE
                   drow=real(row1)-real(row2_raw)
                   dcolx=real(colx1)-real(col2x_raw)
                   dcoly=real(coly1)-real(col2y_raw)
                   vec_length=(drow**2+dcolx**2+dcoly**2)**.5
                   ! normalize
                   drow = drow/vec_length
                   dcolx=dcolx/vec_length
                   dcoly=dcoly/vec_length
!!$write(0,*) 'vec_length',vec_length,ceiling(vec_length)

                   !       write(0,*) drow,dcolx,dcoly,((drow**2+dcolx**2+dcoly**2)**.5)
found1=0
                   step_to_base: do step=0,ceiling(vec_length)
                      look_bnd: do it=-1,1
                         do ix=-1,1
                            do iy=-1,1

!!$                               write(0,*) drow,dcolx,dcoly
!!$                               write(0,*) row2_raw,col2x_raw,col2y_raw
!!$                               write(0,*) row1,colx1,coly1
!!$                               stop

                               ! SEARCH FOR A BOUNDARY BETWEEN BASE POINT AND NEW POINT
                               n_row=row2_raw+nint(real(step)*drow)+it
                               n_colx=col2x_raw+nint(real(step)*dcolx)+ix
                               n_coly=col2y_raw+nint(real(step)*dcoly)+iy        
!!$write(0,*) n_row,n_colx,n_coly
!!$write(0,*) 'step',step
!!$if (step==1) stop
                               with_in_bnds2:  if (n_row>=1.and.n_row<=nt.and.n_colx>=1.and.n_colx<=nx&
                               .and.n_coly>=1.and.n_coly<=ny) then
!!$  write(0,*) 'within bounds'
!!$write(0,*) n_row,n_colx,n_coly
!!$write(0,*) 'outer_bnd',maxval(outer_bnd),maxval(outer_bnd(1:,1:,1,2)),maxval(outer_bnd(1:,1:,1,3)),maxval(outer_bnd(1:,1:,1,4))
!!$stop

                                  ! IF LOOKING FOR OUTER BOUNDARY
                                  if (mask_in(row2_raw,col2x_raw,col2y_raw)==.75) then
!!$write(0,*) 'found outer bnd'

                                     if (outer_bnd(n_row,n_colx,n_coly,4)==1.) then
!!$write(0,*) 'found outer bnd'
!!$stop
                                        ! TAKE NORM AT CLOSEST BOUNDARY
                                        norm_length=(outer_bnd(n_row,n_colx,n_coly,1)**2+outer_bnd(n_row,n_colx,n_coly,2)**2+outer_bnd(n_row,n_colx,n_coly,3)**2)   ! temporary, renormalizing the norm 
                                        norm_at_bnd(1:3)=outer_bnd(n_row,n_colx,n_coly,1:3)/norm_length
                                        if (norm_length==0.) norm_at_bnd(1:3)=(/1,0,0/)
                                        ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                                        ! if (nint(outer_bnd(n_row,n_colx,n_coly,5))+outer_shft1<outer_bnd_sum) then
                                        ! vec_at_new_bnd(1:3)=outer_bnd_tracker(nint(outer_bnd(n_row,n_colx,n_coly,5))+outer_shft1,5:7)        
                                        ! norm_at_new_bnd(1:3)=outer_bnd_tracker(nint(outer_bnd(n_row,n_colx,n_coly,5))+outer_shft1,1:3)
                                        vec_at_new_bnd(1:3)=outer_bnd_tracker(outer_shft1,5:7) 
                                        norm_length=(outer_bnd_tracker(outer_shft1,1)**2+outer_bnd_tracker(outer_shft1,2)**2+outer_bnd_tracker(outer_shft1,3)**2)          ! temporary, renormalizing the norm

                                        norm_at_new_bnd(1:3)=outer_bnd_tracker(outer_shft1,1:3)/norm_length
                                        if (norm_length==0.) norm_at_new_bnd(1:3)=(/1,0,0/)

!!$                                        else
!!$                                           vec_at_new_bnd(1:3)=outer_bnd_tracker(1,5:7)                               
!!$                                           norm_at_new_bnd(1:3)=outer_bnd_tracker(1,1:3)
!!$
!!$                                           too_far=1
!!$                                        end if
                                        ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                                        row2_2bnd(1)=row2_raw-n_row
                                        row2_2bnd(2)=col2x_raw-n_colx
                                        row2_2bnd(3)=col2y_raw-n_coly
 found1=1
                                       exit step_to_base
                                     end if
                                  elseif (mask_in(row2_raw,col2x_raw,col2y_raw)==.25) then

!!$write(0,*) 'found inner bnd'
!!$stop

                                     if (inner_bnd(n_row,n_colx,n_coly,4)==1.) then
!!$write(0,*) 'found inner bnd'
!!$stop
                                        ! TAKE NORM AT CLOSEST BOUNDARY
                                        norm_length=(inner_bnd(n_row,n_colx,n_coly,1)**2+inner_bnd(n_row,n_colx,n_coly,2)**2+inner_bnd(n_row,n_colx,n_coly,3)**2)   ! temporary, renormalizing the norm 
                                        norm_at_bnd(1:3)=inner_bnd(n_row,n_colx,n_coly,1:3)/norm_length
                                        if (norm_length==0.) norm_at_bnd(1:3)=(/1,0,0/)
                                        ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
!!$                                        if (nint(inner_bnd(n_row,n_colx,n_coly,5))+inner_shft1<inner_bnd_sum) then
!!$                                           vec_at_new_bnd(1:3)=inner_bnd_tracker(nint(inner_bnd(n_row,n_colx,n_coly,5))+inner_shft1,5:7)
!!$                                           norm_at_new_bnd(1:3)=inner_bnd_tracker(nint(inner_bnd(n_row,n_colx,n_coly,5))+inner_shft1,1:3)
                                        vec_at_new_bnd(1:3)=inner_bnd_tracker(inner_shft1,5:7)  
                                        norm_length=(inner_bnd_tracker(inner_shft1,1)**2+inner_bnd_tracker(inner_shft1,2)**2+inner_bnd_tracker(inner_shft1,3)**2)   ! temporary, renormalizing the norm 
                                        norm_at_new_bnd(1:3)=inner_bnd_tracker(inner_shft1,1:3)/norm_length
                                        if (norm_length==0.) norm_at_new_bnd(1:3)=(/1,0,0/)
!!$    else
!!$                                           vec_at_new_bnd(1:3)=inner_bnd_tracker(1,5:7)                               
!!$                                           norm_at_new_bnd(1:3)=inner_bnd_tracker(1,1:3)
!!$
!!$                                           too_far=1
!!$                                        end if


                                        ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                                        row2_2bnd(1)=row2_raw-n_row
                                        row2_2bnd(2)=col2x_raw-n_colx
                                        row2_2bnd(3)=col2y_raw-n_coly
found1=1
                                        exit step_to_base
                                     end if
                                  end if
                               end if with_in_bnds2
                            end do
                         end do
                      end do look_bnd
                   end do step_to_base
!!$                   write(0,*) norm_at_bnd
if (found1==0) write(0,*) 'didnt find bound' 
                   ! COMPUTE BASIS VECTORS AT THE FIRST BOUND
                   xt_basis(3)=0.  ! set y component to 0 to keep in xt plane
                   xt_basis(2)=1.  ! x=1
                   xt_basis(1)=(-norm_at_bnd(2)*norm_at_bnd(1))/(norm_at_bnd(1)*norm_at_bnd(1)+.00001)
                   xt_basis(1:3)=xt_basis(1:3)/(xt_basis(1)**2+1)**.5

                   yt_basis(3)=1.  ! set y component to 0 to keep in xt plane
                   yt_basis(2)=0.  ! x=1
                   yt_basis(1)=(-norm_at_bnd(3)*norm_at_bnd(1))/(norm_at_bnd(1)*norm_at_bnd(1)+.00001)
                   yt_basis(1:3)=yt_basis(1:3)/(yt_basis(1)**2+1)**.5
!!$ write(0,*) 'xt_basis',xt_basis
!!$ write(0,*) 'yt_basis',yt_basis


                   ! PROJECT THE PNT ONTO THE BASIS VECTORS BY TAKING DOT PRODUCTS
                   norm_dist1=-1.*dot_product(row2_2bnd,norm_at_bnd) ! -1 to switch the direction
                   xt_dist   =1.*dot_product(row2_2bnd,xt_basis)
                   yt_dist   =1.*dot_product(row2_2bnd,yt_basis)
!!$write(0,*) row2_2bnd
!!$write(0,*) 'norm_dist1',norm_dist1
!!$write(0,*) 'xt_dist',xt_dist
!!$write(0,*) 'yt_dist',yt_dist

                   ! COMPUTE BASIS VECTORS AT THE SHIFTED BOUND
                   xt_basis_2(3)=0. 
                   xt_basis_2(2)=1. 
                   xt_basis_2(1)=(-norm_at_new_bnd(2)*norm_at_new_bnd(1))/(norm_at_new_bnd(1)*norm_at_new_bnd(1)+.00001)
                   xt_basis_2(1:3)=xt_basis_2(1:3)/(xt_basis_2(1)**2+1)**.5

                   yt_basis_2(3)=1. !1. 
                   yt_basis_2(2)=0. 
                   yt_basis_2(1)=(-norm_at_new_bnd(3)*norm_at_new_bnd(1))/(norm_at_new_bnd(1)*norm_at_new_bnd(1)+.00001)
                   yt_basis_2(1:3)=yt_basis_2(1:3)/(yt_basis_2(1)**2+1)**.5
!!$write(0,*) 'new norm',norm_at_new_bnd
!!$ write(0,*) 'xt_basis',xt_basis_2
!!$ write(0,*) 'yt_basis',yt_basis_2

                   dumb_test: do dumbtest=1,3
                      ! DEFINE NEW VECTOR BY SUMMING THE NEW SCALED BASIS VECTORS
                      row2 =norm_at_new_bnd(1)*norm_dist1+xt_basis_2(1)*xt_dist+yt_basis_2(1)*yt_dist+vec_at_new_bnd(1)
                      col2x=norm_at_new_bnd(2)*norm_dist1+xt_basis_2(2)*xt_dist+yt_basis_2(2)*yt_dist+vec_at_new_bnd(2)
                      col2y=norm_at_new_bnd(3)*norm_dist1+xt_basis_2(3)*xt_dist+yt_basis_2(3)*yt_dist+vec_at_new_bnd(3)
                      if (row2<-1000000.or.col2x<-1000000.or.col2y<-1000000) then
                         write(0,*) 'nulls'
                         write(0,*) 'distances', norm_dist1,xt_dist
                         write(0,*) 'row2_2bnd',row2_2bnd
                         write(0,*) 'norm_at_bnd',norm_at_bnd
   write(0,*) 'norm_at_new_bnd',norm_at_new_bnd
   write(0,*) 'row2_raw',row2_raw,'col2x_raw',col2x_raw,'col2y_raw',col2y_raw
write(0,*) 'row1',row1,colx1,coly1
write(0,*)'outer_bnd', outer_bnd(66:76,1:10,1,4)
   write(0,*) 'n',n_row,n_colx,n_coly
                         write(0,*) 'row2',row2,'col2x',col2x,'col2y',col2y
write(0,*) 'step',step,ceiling(vec_length)
                         stop
                      end if
                      if (row2<1.or.row2>nt.or.col2x<1.or.col2x>nx&
                      .or.col2y<1.or.col2y>ny.or.mask_in(row2,col2x,col2y)/=1) then
                         if (dumbtest==1) xt_dist=-1.*xt_dist
                         if (dumbtest==2) norm_dist1=-1.*norm_dist1
                         if (dumbtest==3) xt_dist=-1.*xt_dist
                      else
                         exit dumb_test
                      end if
                   end do dumb_test

!!$write(0,*) 'new vec',vec_at_new_bnd
!!$write(0,*) 'row2',row2
!!$write(0,*) 'col2x',col2x
!!$write(0,*) 'col2y',col2y
!!$stop
                   if  (row2<1.or.row2>nt.or.col2x<1.or.col2x>nx&
                   .or.col2y<1.or.col2y>ny.or.mask_in(row2,col2x,col2y)/=1.or.too_far==1) then
                      !                 write(0,*) 'toofar' ,too_far ,row2,col2x,col2y
                      box_grid_bnds(box_t,box_x,box_y)=1
                      row2=1;col2x=1;col2y=1

                   end if
                else ! if in mask
                   row2=row2_raw
                   col2x=col2x_raw
                   col2y=col2y_raw
                end if out_of_mask


             else ! if outside of bounds,ignore it
                box_grid_bnds(box_t,box_x,box_y)=1
                row2=1;col2x=1;col2y=1
             end if within_bnds
             box_grid(box_t,box_x,box_y)=norm_d(row2,col2x,col2y) ! save value
             box_grid_row(box_t,box_x,box_y)=row2 ! save row
             box_grid_colx(box_t,box_x,box_y)=col2x ! save column x
             box_grid_coly(box_t,box_x,box_y)=col2y ! save column x
             if (box_grid_bnds(box_t,box_x,box_y)==1) box_grid(box_t,box_x,box_y)=0. ! if ignored, set value to zero

          end do loop_box_t1
       end do loop_box_x1
    end do loop_box_y1

    deallocate(norm_at_bnd,vec_at_new_bnd,norm_at_new_bnd)
    deallocate(xt_basis,xt_basis_2,yt_basis,yt_basis_2,row2_2bnd)  
  end subroutine make_grid3d


  subroutine make_grid2(nx,nt,max_dist,row1,col1,row2,col2,topbnd,botbnd,box_grid,box_grid_row,box_grid_col,box_grid_bnds,norm_d)   

    integer                             :: box_x,box_t,big_box_size
    integer                             :: nx,nt,max_dist,row1,col1,rand_jump_int
    integer                             ::row2_raw,col2_raw,delta_row2,delta_col2
    integer                             ::row2,col2,it,top_vert_shft,bot_vert_shft
    real                                ::rand_jump
    real,dimension(:)			::topbnd,botbnd,topbnd_base, topbnd_new
    real,dimension(:)			::botbnd_base, botbnd_new,topdiff,botdiff
    real, dimension(:,:)                ::box_grid,box_grid_col,box_grid_row
    real, dimension(:,:)                ::box_grid_bnds,norm_d


    big_box_size=max_dist*2+1
    ! AROUND EACH POINT IN THE IMAGE, CONTRUCT A GRID TO SAMPLE FROM row1,col1 to row2,col2
    ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
    call random_number(rand_jump)
    rand_jump=rand_jump*real(nx-1)+1.
    rand_jump_int=nint(rand_jump)

    ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
    ! COMPUTE DATA-PRESERVING VERTICAL SHIFT  !
    ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
    allocate(topbnd_base(big_box_size),topbnd_new(big_box_size),botbnd_base(big_box_size),botbnd_new(big_box_size))
    allocate(topdiff(big_box_size),botdiff(big_box_size))
    ! 1)EXTRACT VALUES WITHIN GRID DIMENSIONS ALONG BOUNDARY AT BASE POINT AND NEW POINT
    do it=1,big_box_size
       if ((col1+(it-1)-max_dist)>=1.and. (col1+(it-1)-max_dist)<=nx) then
          topbnd_base(it)=topbnd(col1+(it-1)-max_dist)-topbnd(col1)
          botbnd_base(it)=botbnd(col1+(it-1)-max_dist)-botbnd(col1)
       else
          topbnd_base(it)=-999.25 ! flag if out of bounds
          botbnd_base(it)=-999.25 
       end if
       ! 2)TIME REVERSE NEW BOUNDARY LISTS
       if ((rand_jump_int+(it-1)-max_dist)>=1.and. (rand_jump_int+(it-1)-max_dist)<=nx) then
          topbnd_new(big_box_size-(it-1))=topbnd(rand_jump_int+(it-1)-max_dist)-topbnd(rand_jump_int)
          botbnd_new(big_box_size-(it-1))=botbnd(rand_jump_int+(it-1)-max_dist)-botbnd(rand_jump_int)
       else
          topbnd_new(big_box_size-(it-1))=-999.25 ! flag if out of bounds
          botbnd_new(big_box_size-(it-1))=-999.25 ! flag if out of bounds
       end if
    enddo

    ! 3)SUM THEM
    do it=1,big_box_size
       if (topbnd_base(it)/=-999.25.and.topbnd_new(it)/=-999.25) then
          topdiff(it)=topbnd_base(it)+topbnd_new(it)
       else
          topdiff(it)=0.  ! ignore is flagged
       end if
       if (botbnd_base(it)/=-999.25.and.botbnd_new(it)/=-999.25) then
          botdiff(it)=botbnd_base(it)+botbnd_new(it)
       else
          botdiff(it)=0.
       end if
    end do

    ! 4)TAKE MAX AS VERTICAL SHIFT
    top_vert_shft=nint(max(maxval(topdiff),0.))
    bot_vert_shft=nint(max(maxval(botdiff),0.))
!!$write(0,*) 'top_vert_shift',top_vert_shft
!!$write(0,*) 'bot_vert_shift',bot_vert_shft
    ! NOW LOOP OVER GRID, EXTRACTING VALUES FROM THEIR APPROPRIATE PLACE
    loop_box_x1: do box_x=1,big_box_size ! box_x is the column indicator
       loop_box_t1: do box_t=1,big_box_size ! box_t is the row indicator
          row2_raw=row1+(box_t-1)-max_dist 
          col2_raw=col1+(box_x-1)-max_dist
          delta_col2=col2_raw-col1

          ! IF NEW COL IS OUT OF BOUNDS
          if (col2_raw<1.or.col2_raw>nx) then ! if out of bounds, ignore
             box_grid_bnds(box_t,box_x)=1.
             col2=1 ! just do set it to something...will be ignored anyway
          else
             col2=col2_raw
          end if

          ! IF NEW ROW IS ABOVE THE MASK
          if (row2_raw<topbnd(col2)) then  ! if above mask, jump random shift
             delta_row2=topbnd(col2)-row2_raw-1
             row2=topbnd(rand_jump_int)+delta_row2-top_vert_shft
             col2=rand_jump_int-delta_col2    
             if (col2>nx.or.col2<1.or.row2<1.or.row2>nt) then
                box_grid_bnds(box_t,box_x)=1.
                row2=1;col2=1 ! just do set it to something...will be ignored anyway
             end if
             if (row2>=botbnd(col2)) then   !if it reaches the other side then ignore it
                box_grid_bnds(box_t,box_x)=1.
             end if
             ! TEMPORARY  IGNORE ALL WRAPPING
             !   box_grid_bnds(box_t,box_x)=1.

             ! IF NEW ROW IS BELOW THE MASK
          else if (row2_raw>botbnd(col2)) then ! if below mask, jump random shift
             delta_row2=row2_raw-botbnd(col2)-1       
             row2=botbnd(rand_jump_int)-delta_row2+bot_vert_shft
             col2=rand_jump_int-delta_col2        
             if (col2>nx.or.col2<1.or.row2<1.or.row2>nt) then
                box_grid_bnds(box_t,box_x)=1.
                row2=1;col2=1 ! just do set it to something...will be ignored anyway
             end if
             if (row2<=topbnd(col2))then  !if it reaches the other side then ignore it
                box_grid_bnds(box_t,box_x)=1.
             end if
             ! TEMPORARY  IGNORE ALL WRAPPING
             !  box_grid_bnds(box_t,box_x)=1.

          else
             row2=row2_raw  ! if totally contained, then just set it to a value
          end if

          if (row2>topbnd(col2).and.row2<botbnd(col2)) then
             box_grid(box_t,box_x)=norm_d(row2,col2) ! save value
          else 
             box_grid(box_t,box_x)=1. ! if it lies outside of mask, set equal to 1.
             box_grid_bnds(box_t,box_x)=1.
          end if

          box_grid_row(box_t,box_x)=row2 ! save row
          box_grid_col(box_t,box_x)=col2 ! save column
          if (box_grid_bnds(box_t,box_x)==1) box_grid(box_t,box_x)=1. ! if ignored, set value to zero
       end do loop_box_t1
    end do loop_box_x1

  end subroutine make_grid2




  subroutine calc_wt(nx,nt,mem_alloc,dense_dist,max_dist,amp_thresh,zero_tol,row1,col1,box_grid_1d,box_grid,box_grid_row,box_grid_col,box_grid_bnds,sparse_mat,sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d)
    integer                        ::mem_alloc,dense_dist,row1,col1,row2,col2
    integer                        ::box_x,box_t,nx,nt,iz
    integer                        ::row2_grid,col2_grid,val_cnt
    integer                        ::row1_grid,col1_grid
    integer                        ::irow_mat,icol_mat,sample_num
    integer                        ::big_box_size,box_size,nodes,sparse_mat_index
    integer                        ::drow,dcol,row2_back,col2_back,row1_back,col1_back
    integer                        ::col_in_row,max_dist,stat1
    real                           ::row1_grid_rl,col1_grid_rl,row2_grid_rl,col2_grid_rl
    real                           ::dist,amp_thresh,zero_tol,wt,iz_rl
    real,dimension(:)	           ::val_list,box_grid_1d,dd
    real, pointer, dimension(:,:)  ::sparse_mat,xy,norm_d
    real, dimension(:,:)           ::look_up_tab,box_grid,box_grid_col,box_grid_row
    real, dimension(:,:)           ::box_grid_bnds

    box_size=dense_dist*2+1
    big_box_size=max_dist*2+1
    ! LOOP OVER GRID CALCULATING WEIGHTS FOR EACH POINT
    row1_grid=max_dist+1 ! set grid base point  
    col1_grid=max_dist+1
    row1_grid_rl=row1_grid
    col1_grid_rl=col1_grid

    loop_box_x2: do box_x=1,box_size
       loop_box_t2: do box_t=1,box_size
          row2_grid=row1_grid-dense_dist+(box_t-1)
          col2_grid=col1_grid-dense_dist+(box_x-1)
          row2_grid_rl=row2_grid
          col2_grid_rl=col2_grid

          bnds: if (box_grid_bnds(row2_grid,col2_grid)==0.) then ! make sure the new point should not be ignored
             row2=box_grid_row(row2_grid,col2_grid) ! get the image indices for the new point
             col2=box_grid_col(row2_grid,col2_grid)
             ! LOOK UP WEIGHT MATRIX INDEX.  THE ROW(irow_mat) CORRESPONDS TO THE BASE POINT(row1,col1), 
             ! THE COL(icol_mat) CORRESPONDS TO THE NEW POINT(row2,col2)
             call look_up_wt(look_up_tab,row1,col1,irow_mat)
             call look_up_wt(look_up_tab,row2,col2,icol_mat)
!!$              write(0,*) 'row1',row1
!!$              write(0,*) 'col1',col1
!!$              write(0,*) 'row2',row2
!!$              write(0,*) 'col2',col2
!!$              write(0,*) 'irow_mat',irow_mat
!!$              write(0,*) 'icol_mat',icol_mat
             ! MEASURE THE DISTANCE BETWEEN POINTS IN THE GRID
             dist=sqrt((row1_grid_rl-row2_grid_rl)**2+(col1_grid_rl-col2_grid_rl)**2)

             ! MAKE SURE THE DISTANCE IS LESS THAN INPUT DISTANCE THRESHOLD
             within_circle: if (dist<=real(dense_dist).and.dist>=1)then

                ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
                isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
                   val_cnt=val_cnt+1 
                   val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list
                   sample_num=dist ! round down the distance(dist) to get the number of samples between points
                   if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
                   nodes=sample_num+2 ! total number of nodes including end points

                   ! ALLOCATE xy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
                   ! AND dd TO BE THE ARRAY OF POINTS SAMPLED 
                   allocate(xy(sample_num,2),dd(nodes))
                   xy=0.;dd=0.

                   ! ASSIGN XY PAIRS TO EACH SAMPLE
                   do iz=1,sample_num
                      iz_rl=iz
                      xy(iz,1)=((row2_grid_rl-row1_grid_rl)/dist)*iz_rl+row1_grid_rl
                      xy(iz,2)=((col2_grid_rl-col1_grid_rl)/dist)*iz_rl+col1_grid_rl
                   end do

                   ! INITIALIZE BILINEAR INTERPOLATOR
                   call lint2_init(big_box_size,big_box_size,1.,1.,1.,1.,xy)

                   ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
                   stat1=lint2_lop(.false.,.false.,box_grid_1d,dd(2:nodes-1))
                   dd(1)=box_grid(row1_grid,col1_grid) ! assign end points
                   dd(nodes)=box_grid(row2_grid,col2_grid)

                   ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
                   not_2_nodes1: if(nodes/=2) then
                      if (minval(dd(2:nodes-1))<=dd(1).and.minval(dd(2:nodes-1))<=dd(nodes)&
                      .and.minval(dd(2:nodes-1))<amp_thresh) then
                         wt=0.
                      else
                         wt=1.
                      end if

                      ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
                   else
                      wt=1.
                      drow=row1-row2
                      dcol=col1-col2
                      row2_back=row2-drow
                      col2_back=col2-dcol

                      row1_back=row1+drow
                      col1_back=col1+dcol

                      if (row2_back>=1.and.row2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
                         if (norm_d(row2_back,col2_back)>norm_d(row2,col2).and.&
                         norm_d(row1,col1)>norm_d(row2,col2).and.norm_d(row2,col2)<amp_thresh) then
                            if (row2<=row1.and.col2<=col1) then ! break only along north-east
                               wt=0.
                            end if
                         end if
                      end if

                      if (row1_back>=1.and.row1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
                         if (norm_d(row1_back,col1_back)>norm_d(row1,col1).and.&
                         norm_d(row2,col2)>norm_d(row1,col1).and.norm_d(row1,col1)<amp_thresh) then
                            if (row1<=row2.and.col1<=col2) then ! break only along north-east
                               wt=0.
                            end if
                         end if
                      end if
                   end if not_2_nodes1

                   deallocate(dd)
                   if (size(xy)>0) deallocate(xy)


                   ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
                   if (wt>zero_tol)then
                      sparse_mat_index=sparse_mat_index+1
                      if (sparse_mat_index>=mem_alloc) then
                         write(0,*) 'did not allocate enough memory'
                         stop
                      end if
                      col_in_row=col_in_row+1  ! a row has been added to this column
                      if (icol_mat>=irow_mat) then
                         sparse_mat(sparse_mat_index,1)=irow_mat
                         sparse_mat(sparse_mat_index,2)=icol_mat
                         sparse_mat(sparse_mat_index,3)=wt
                      else
                         sparse_mat(sparse_mat_index,1)=icol_mat
                         sparse_mat(sparse_mat_index,2)=irow_mat
                         sparse_mat(sparse_mat_index,3)=wt
                      end if
                   end if
                end if isnew
             end if within_circle
          end if bnds
       end do loop_box_t2
    end do loop_box_x2

  end subroutine calc_wt

  subroutine calc_wt_rand(nx,nt,mem_alloc,sample_scale,dense_dist,max_dist,amp_thresh,zero_tol,row1,col1,box_grid_1d,box_grid,box_grid_row,box_grid_col,box_grid_bnds,sparse_mat,sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d)
    integer                        ::mem_alloc,dense_dist,row1,col1,row2,col2
    integer                        ::box_x,box_t,nx,nt,iz,srch
    integer                        ::row2_grid,col2_grid,val_cnt
    integer                        ::row1_grid,col1_grid,n_sam,sample_scale
    integer                        ::irow_mat,icol_mat,sample_num
    integer                        ::big_box_size,box_size,nodes,sparse_mat_index
    integer                        ::drow,dcol,row2_back,col2_back,row1_back,col1_back
    integer                        ::col_in_row,max_dist,stat1
    integer                        ::x_shift_int,y_shift_int
    real                           ::row1_grid_rl,col1_grid_rl,row2_grid_rl,col2_grid_rl
    real                           ::dist,amp_thresh,zero_tol,wt,iz_rl
    real                           ::rand_dir,rand_dist,fill,pi_var
    real                           ::x_shift,y_shift
    real,dimension(:)	           ::val_list,box_grid_1d,dd
    real, pointer, dimension(:,:)  ::sparse_mat,xy,norm_d
    real, dimension(:,:)           ::look_up_tab,box_grid,box_grid_col,box_grid_row
    real, dimension(:,:)           ::box_grid_bnds


    pi_var=acos(-1.)
    box_size=dense_dist*2+1
    big_box_size=max_dist*2+1
    fill=max_dist-dense_dist
    n_sam=sample_scale*nint(3.*pi_var*real(fill)) 
    !   write(0,*) 'number of random samples', n_sam

    ! LOOP OVER GRID CALCULATING WEIGHTS FOR EACH POINT
    row1_grid=max_dist+1 ! set grid base point  
    col1_grid=max_dist+1
    row1_grid_rl=row1_grid
    col1_grid_rl=col1_grid

    loop_n_times: do srch=1,n_sam
       ! DRAW RAND DIRECTION
       call random_number (rand_dir)
       rand_dir=rand_dir*2.*pi_var ! assign angle

       ! DRAW RAND DISTANCE
       call random_number(rand_dist)
       rand_dist=rand_dist*fill+dense_dist
!!$write(0,*) 'rand_dir',rand_dir
!!$write(0,*) 'rand_dist',rand_dist
       ! CALCULATE SHIFTS
       x_shift=rand_dist*cos(rand_dir)
       y_shift=rand_dist*sin(rand_dir)
       x_shift_int=nint(x_shift)
       y_shift_int=nint(y_shift)
!!$write(0,*) 'x_shift_int',x_shift_int
!!$write(0,*) 'y_shift_int',y_shift_int
       ! CALCULATE NEW POINT
       row2_grid=row1_grid+y_shift_int
       col2_grid=col1_grid+x_shift_int
       row2_grid_rl=real(row2_grid)
       col2_grid_rl=real(col2_grid)

       bnds2: if (box_grid_bnds(row2_grid,col2_grid)==0.) then
!!$
!!$       loop_box_x2: do box_x=1,box_size
!!$          loop_box_t2: do box_t=1,box_size
!!$             row2_grid=row1_grid-dense_dist+(box_t-1)
!!$             col2_grid=col1_grid-dense_dist+(box_x-1)
!!$             row2_grid_rl=row2_grid
!!$             col2_grid_rl=col2_grid
!!$
!!$             bnds: if (box_grid_bnds(row2_grid,col2_grid)==0.) then ! make sure the new point should not be ignored
          row2=box_grid_row(row2_grid,col2_grid) ! get the image indices for the new point
          col2=box_grid_col(row2_grid,col2_grid)
          ! LOOK UP WEIGHT MATRIX INDEX.  THE ROW(irow_mat) CORRESPONDS TO THE BASE POINT(row1,col1), 
          ! THE COL(icol_mat) CORRESPONDS TO THE NEW POINT(row2,col2)
          call look_up_wt(look_up_tab,row1,col1,irow_mat)
          call look_up_wt(look_up_tab,row2,col2,icol_mat)
!!$              write(0,*) 'row1',row1
!!$              write(0,*) 'col1',col1
!!$              write(0,*) 'row2',row2
!!$              write(0,*) 'col2',col2
!!$              write(0,*) 'irow_mat',irow_mat
!!$              write(0,*) 'icol_mat',icol_mat
          ! MEASURE THE DISTANCE BETWEEN POINTS IN THE GRID
          dist=sqrt((row1_grid_rl-row2_grid_rl)**2+(col1_grid_rl-col2_grid_rl)**2)

          ! MAKE SURE THE DISTANCE IS LESS THAN INPUT DISTANCE THRESHOLD
          within_circle: if (dist<=real(max_dist).and.dist>=dense_dist)then

             ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
             isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
                val_cnt=val_cnt+1 
                val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list
                sample_num=dist ! round down the distance(dist) to get the number of samples between points
                if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
                nodes=sample_num+2 ! total number of nodes including end points

                ! ALLOCATE xy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
                ! AND dd TO BE THE ARRAY OF POINTS SAMPLED 
                allocate(xy(sample_num,2),dd(nodes))
                xy=0.;dd=0.

                ! ASSIGN XY PAIRS TO EACH SAMPLE
                do iz=1,sample_num
                   iz_rl=iz
                   xy(iz,1)=((row2_grid_rl-row1_grid_rl)/dist)*iz_rl+row1_grid_rl
                   xy(iz,2)=((col2_grid_rl-col1_grid_rl)/dist)*iz_rl+col1_grid_rl
                end do

                ! INITIALIZE BILINEAR INTERPOLATOR
                call lint2_init(big_box_size,big_box_size,1.,1.,1.,1.,xy)

                ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
                stat1=lint2_lop(.false.,.false.,box_grid_1d,dd(2:nodes-1))
                dd(1)=box_grid(row1_grid,col1_grid) ! assign end points
                dd(nodes)=box_grid(row2_grid,col2_grid)

                ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
                not_2_nodes1: if(nodes/=2) then
                   if (minval(dd(2:nodes-1))<=dd(1).and.minval(dd(2:nodes-1))<=dd(nodes)&
                   .and.minval(dd(2:nodes-1))<amp_thresh) then
                      wt=0.
                   else
                      wt=1.
                   end if

                   ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
                else
                   wt=1.
                   drow=row1-row2
                   dcol=col1-col2
                   row2_back=row2-drow
                   col2_back=col2-dcol

                   row1_back=row1+drow
                   col1_back=col1+dcol

                   if (row2_back>=1.and.row2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
                      if (norm_d(row2_back,col2_back)>norm_d(row2,col2).and.&
                      norm_d(row1,col1)>norm_d(row2,col2).and.norm_d(row2,col2)<amp_thresh) then
                         if (row2<=row1.and.col2<=col1) then ! break only along north-east
                            wt=0.
                         end if
                      end if
                   end if

                   if (row1_back>=1.and.row1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
                      if (norm_d(row1_back,col1_back)>norm_d(row1,col1).and.&
                      norm_d(row2,col2)>norm_d(row1,col1).and.norm_d(row1,col1)<amp_thresh) then
                         if (row1<=row2.and.col1<=col2) then ! break only along north-east
                            wt=0.
                         end if
                      end if
                   end if
                end if not_2_nodes1

                deallocate(dd)
                if (size(xy)>0) deallocate(xy)


                ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
                if (wt>zero_tol)then
                   sparse_mat_index=sparse_mat_index+1
                   if (sparse_mat_index>=mem_alloc) then
                      write(0,*) 'did not allocate enough memory'
                      stop
                   end if
                   col_in_row=col_in_row+1  ! a row has been added to this column
                   if (icol_mat>=irow_mat) then
                      sparse_mat(sparse_mat_index,1)=irow_mat
                      sparse_mat(sparse_mat_index,2)=icol_mat
                      sparse_mat(sparse_mat_index,3)=wt
                   else
                      sparse_mat(sparse_mat_index,1)=icol_mat
                      sparse_mat(sparse_mat_index,2)=irow_mat
                      sparse_mat(sparse_mat_index,3)=wt
                   end if
                end if
             end if isnew
          end if within_circle
       end if bnds2
    end do loop_n_times

  end subroutine calc_wt_rand

  subroutine calc_wt_rand3d(nx,ny,nt,mem_alloc,sample_scale,dense_dist,max_dist,amp_thresh,zero_tol,&
  row1,col1x,col1y,box_grid_1d,box_grid,box_grid_row,box_grid_colx,box_grid_coly,box_grid_bnds,sparse_mat,&
  sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d,total_sparse_big)
    integer                        ::mem_alloc,dense_dist,row1,col1x,col1y,row2,col2x,col2y
    integer                        ::box_x,box_t,nx,ny,nt,iz,srch
    integer                        ::row2_grid,col2x_grid,col2y_grid,val_cnt
    integer                        ::row1_grid,col1x_grid,col1y_grid,n_sam,sample_scale
    integer                        ::irow_mat,icol_mat,sample_num
    integer                        ::big_box_size,box_size,nodes,sparse_mat_index
    integer                        ::drow,dcolx,dcoly,row2_back,col2x_back,col2y_back
    integer                        ::row1_back,col1x_back,col1y_back
    integer                        ::col_in_row,max_dist,stat1,total_sparse_big
    integer                        ::rand_shft_x_int,rand_shft_y_int,rand_shft_t_int
    integer,pointer,dimension(:)   ::n_lint

    real                           ::row1_grid_rl,col1x_grid_rl,col1y_grid_rl,row2_grid_rl,col2x_grid_rl,col2y_grid_rl
    real                           ::dist,amp_thresh,zero_tol,wt,iz_rl
    real                           ::rand_shft_x,rand_shft_y,rand_shft_t,rand_dist,fill,pi_var
    real                           ::x_shift,y_shift
    real, pointer, dimension(:)    :: d_lint,o_lint
    real,dimension(:)	           ::val_list,box_grid_1d,dd
    real, pointer, dimension(:,:)  ::sparse_mat,xy_coor
    real, dimension(:,:)           ::look_up_tab
    real, dimension(:,:,:)         ::box_grid,box_grid_colx,box_grid_coly,box_grid_row
    real, dimension(:,:,:)         ::box_grid_bnds,norm_d


    pi_var=acos(-1.)
    box_size=dense_dist*2+1
    big_box_size=max_dist*2+1
    fill=max_dist-dense_dist
    !    n_sam=sample_scale*nint(3.*pi_var*real(fill)) 
    n_sam=sample_scale*nint(4.*pi_var*real(fill)**2) 
    !  n_sam=60
    !   write(0,*) 'number of random samples', n_sam

    ! LOOP OVER GRID CALCULATING WEIGHTS FOR EACH POINT
    row1_grid=max_dist+1 ! set grid base point  
    col1x_grid=max_dist+1
    col1y_grid=max_dist+1
    row1_grid_rl=row1_grid
    col1x_grid_rl=col1x_grid
    col1y_grid_rl=col1y_grid

    loop_n_times: do srch=1,n_sam
       ! DRAW RAND SHIFT IN EACH DIRECTION
       call random_number (rand_shft_x)
       rand_shft_x=rand_shft_x*(big_box_size-1)-max_dist
       !rand_shft_x=rand_shft_x*(max_dist-1)+1
       call random_number (rand_shft_y)
       rand_shft_y=rand_shft_y*(big_box_size-1)-max_dist
       !rand_shft_y=rand_shft_y*(max_dist-1)+1
       call random_number (rand_shft_t)
       rand_shft_t=rand_shft_t*(big_box_size-1)-max_dist
       !rand_shft_t=rand_shft_t*(max_dist-1)+1

       ! CALCULATE SHIFTS
       rand_shft_x_int=nint(rand_shft_x)
       rand_shft_y_int=nint(rand_shft_y)
       rand_shft_t_int=nint(rand_shft_t)
!!$write(0,*) 'x_shift_int',x_shift_int
!!$write(0,*) 'y_shift_int',y_shift_int
       ! CALCULATE NEW POINT
       row2_grid=row1_grid+rand_shft_t_int
       col2x_grid=col1x_grid+rand_shft_x_int
       col2y_grid=col1y_grid+rand_shft_y_int

       row2_grid_rl=real(row2_grid)
       col2x_grid_rl=real(col2x_grid)
       col2y_grid_rl=real(col2y_grid)

       bnds2: if (box_grid_bnds(row2_grid,col2x_grid,col2y_grid)==0.) then
!!$
!!$       loop_box_x2: do box_x=1,box_size
!!$          loop_box_t2: do box_t=1,box_size
!!$             row2_grid=row1_grid-dense_dist+(box_t-1)
!!$             col2_grid=col1_grid-dense_dist+(box_x-1)
!!$             row2_grid_rl=row2_grid
!!$             col2_grid_rl=col2_grid
!!$
!!$             bnds: if (box_grid_bnds(row2_grid,col2_grid)==0.) then ! make sure the new point should not be ignored
          row2=box_grid_row(row2_grid,col2x_grid,col2y_grid) ! get the image indices for the new point
          col2x=box_grid_colx(row2_grid,col2x_grid,col2y_grid)
          col2y=box_grid_coly(row2_grid,col2x_grid,col2y_grid)
          ! LOOK UP WEIGHT MATRIX INDEX.  THE ROW(irow_mat) CORRESPONDS TO THE BASE POINT(row1,col1), 
          ! THE COL(icol_mat) CORRESPONDS TO THE NEW POINT(row2,col2)
          call look_up_wt3d(look_up_tab,row1,col1x,col1y,irow_mat)
          call look_up_wt3d(look_up_tab,row2,col2x,col2y,icol_mat)
          upper_triangle: if (irow_mat<icol_mat) then
!!$write(0,*) 'problem'
!!$stop
!!$end if
!!$              write(0,*) 'row1',row1
!!$              write(0,*) 'col1',col1
!!$              write(0,*) 'row2',row2
!!$              write(0,*) 'col2',col2
!!$              write(0,*) 'irow_mat',irow_mat
!!$              write(0,*) 'icol_mat',icol_mat
             ! MEASURE THE DISTANCE BETWEEN POINTS IN THE GRID
             dist=sqrt((row1_grid_rl-row2_grid_rl)**2+(col1x_grid_rl-col2x_grid_rl)**2+(col1y_grid_rl-col2y_grid_rl)**2)

             ! MAKE SURE THE DISTANCE IS LESS THAN INPUT DISTANCE THRESHOLD
             within_circle: if (dist<=real(max_dist)) then !.and.dist>=dense_dist)then

                ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
                isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
                   val_cnt=val_cnt+1 
                   val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list
                   sample_num=dist ! round down the distance(dist) to get the number of samples between points
                   if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
                   nodes=sample_num+2 ! total number of nodes including end points

                   ! ALLOCATE xy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
                   ! AND dd TO BE THE ARRAY OF POINTS SAMPLED 
                   allocate(xy_coor(sample_num,3),dd(nodes),n_lint(3),d_lint(3),o_lint(3))
                   xy_coor=0.;dd=0. ; n_lint=(/big_box_size,big_box_size,big_box_size/) ; o_lint=0. ; d_lint=1.

                   ! ASSIGN XYT PAIRS TO EACH SAMPLE
                   do iz=1,sample_num
                      iz_rl=iz
                      xy_coor(iz,1)=((row2_grid_rl-row1_grid_rl)/dist)*iz_rl+row1_grid_rl
                      xy_coor(iz,2)=((col2x_grid_rl-col1x_grid_rl)/dist)*iz_rl+col1x_grid_rl
                      xy_coor(iz,3)=((col2y_grid_rl-col1y_grid_rl)/dist)*iz_rl+col1y_grid_rl
                      !  write(0,*) 'xy_coor',xy_coor
                   end do

                   ! INITIALIZE BILINEAR INTERPOLATOR
                   call lint_init(n_lint,o_lint,d_lint,xy_coor)

                   ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
                   stat1=lint_lop(.false.,.false.,box_grid_1d,dd(2:nodes-1))
                   dd(1)=box_grid(row1_grid,col1x_grid,col1y_grid) ! assign end points
                   dd(nodes)=box_grid(row2_grid,col2x_grid,col2y_grid)

                   ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
                   not_2_nodes1: if(nodes/=2) then
                      if (minval(dd(2:nodes-1))<=dd(1).and.minval(dd(2:nodes-1))<=dd(nodes)&
                      .and.minval(dd(2:nodes-1))<amp_thresh) then
                         wt=0.
                      else
                         wt=1.
                      end if

                      ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
                   else
                      wt=1.
                      drow=row1-row2
                      dcolx=col1x-col2x
                      dcoly=col1y-col2y
                      row2_back=row2-drow
                      col2x_back=col2x-dcolx
                      col2y_back=col2y-dcoly

                      row1_back=row1+drow
                      col1x_back=col1x+dcolx
                      col1y_back=col1y+dcoly

                      ! BREAK ONLY ON THE UPPER,SOUTH,WEST SIDE
                      if (row2_back>=1.and.row2_back<=nt.and.col2x_back>=1.and.col2x_back<=nx.and.&
                      col2y_back>=1.and.col2y_back<=ny) then
                         if (norm_d(row2_back,col2x_back,col2y_back)>norm_d(row2,col2x,col2y).and.&
                         norm_d(row1,col1x,col1y)>norm_d(row2,col2x,col2y).and.norm_d(row2,col2x,col2y)<amp_thresh) then
                            if (row2<=row1.and.col2x<=col1x.and.col2y<=col1y) then ! break only along USW side
                               wt=0.
                            end if
                         end if
                      end if
                      if (row1_back>=1.and.row1_back<=nt.and.col1x_back>=1.and.col1x_back<=nx.and.&
                      col1y_back>=1.and.col1y_back<=ny) then
                         if (norm_d(row1_back,col1x_back,col1y_back)>norm_d(row1,col1x,col1y).and.&
                         norm_d(row2,col2x,col2y)>norm_d(row1,col1x,col1y).and.norm_d(row1,col1x,col1y)<amp_thresh) then
                            if (row1<=row2.and.col1x<=col2x.and.col1y<=col2y) then ! break only along USW side
                               wt=0.
                            end if
                         end if
                      end if

                   end if not_2_nodes1

                   deallocate(dd)
                   if (size(xy_coor)>0) deallocate(xy_coor)


                   ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
                   if (wt>zero_tol)then
                      !                      write(0,*) 'mem_alloc',mem_alloc
                      if (icol_mat>irow_mat) then
                         sparse_mat_index=sparse_mat_index+1
                         if (sparse_mat_index>mem_alloc) then
                            write(0,*) 'reached memory limit riting out a chunk from calc_wt_rand3d'
                            call write_data(sparse_mat,sparse_mat_index,total_sparse_big,mem_alloc)    
                         end if
                         col_in_row=col_in_row+1  ! a row has been added to this column

                         sparse_mat(sparse_mat_index,1)=irow_mat
                         sparse_mat(sparse_mat_index,2)=icol_mat
                         sparse_mat(sparse_mat_index,3)=wt
                      elseif (icol_mat<irow_mat) then
                         sparse_mat_index=sparse_mat_index+1
                         if (sparse_mat_index>mem_alloc) then
                            write(0,*) 'reached memory limit riting out a chunk from calc_wt_rand3d'

                            call write_data(sparse_mat,sparse_mat_index,total_sparse_big,mem_alloc)  
                         end if
                         col_in_row=col_in_row+1  ! a row has been added to this column


                         sparse_mat(sparse_mat_index,1)=icol_mat
                         sparse_mat(sparse_mat_index,2)=irow_mat
                         sparse_mat(sparse_mat_index,3)=wt
                      end if
                   end if
                end if isnew
             end if within_circle
          end if upper_triangle
       end if bnds2
    end do loop_n_times

  end subroutine calc_wt_rand3d

  subroutine calc_wt_template3d(sample_template,nx,ny,nt,mem_alloc,sample_scale,dense_dist,max_dist,amp_thresh&
  ,zero_tol,row1,col1x,col1y,box_grid_1d,box_grid,box_grid_row,box_grid_colx,box_grid_coly,box_grid_bnds,&
  sparse_mat, sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d,total_sparse_big)
    integer                        ::mem_alloc,dense_dist,row1,col1x,col1y,row2,col2x,col2y
    integer                        ::box_x,box_t,nx,ny,nt,iz,srch
    integer                        ::row2_grid,col2x_grid,col2y_grid,val_cnt
    integer                        ::row1_grid,col1x_grid,col1y_grid,n_sam,sample_scale
    integer                        ::irow_mat,icol_mat,sample_num
    integer                        ::big_box_size,box_size,nodes,sparse_mat_index
    integer                        ::drow,dcolx,dcoly,row2_back,col2x_back,col2y_back
    integer                        ::row1_back,col1x_back,col1y_back
    integer                        ::col_in_row,max_dist,stat1,total_sparse_big
    integer                        ::rand_shft_x_int,rand_shft_y_int,rand_shft_t_int
    integer                        ::smp_pnt
    integer,pointer,dimension(:)   ::n_lint
    integer,dimension(:,:)         ::sample_template
    real                           ::row1_grid_rl,col1x_grid_rl,col1y_grid_rl,row2_grid_rl,col2x_grid_rl,col2y_grid_rl
    real                           ::dist,amp_thresh,zero_tol,wt,iz_rl
    real                           ::rand_shft_x,rand_shft_y,rand_shft_t,rand_dist,fill,pi_var
    real                           ::x_shift,y_shift,pnt2_back_amplitude,pnt1_back_amplitude
    real, pointer, dimension(:)    :: d_lint,o_lint
    real,dimension(:)	           ::val_list,box_grid_1d,dd
    real, pointer, dimension(:,:)  ::sparse_mat,xy_coor
    real, dimension(:,:)           ::look_up_tab
    real, dimension(:,:,:)         ::box_grid,box_grid_colx,box_grid_coly,box_grid_row
    real, dimension(:,:,:)         ::box_grid_bnds,norm_d


    pi_var=acos(-1.)
    box_size=dense_dist*2+1
    big_box_size=max_dist*2+1
    fill=max_dist-dense_dist
    !    n_sam=sample_scale*nint(3.*pi_var*real(fill)) 
    n_sam=sample_scale*nint(4.*pi_var*real(fill)**2) 
    !  n_sam=60
    !   write(0,*) 'number of random samples', n_sam

    ! LOOP OVER GRID CALCULATING WEIGHTS FOR EACH POINT
    row1_grid=max_dist+1 ! set grid base point  
    col1x_grid=max_dist+1
    col1y_grid=max_dist+1

    row1_grid_rl=row1_grid
    col1x_grid_rl=col1x_grid
    col1y_grid_rl=col1y_grid

    template:    do smp_pnt=1,size(sample_template(1:,1))
       row2_grid=row1_grid+sample_template(smp_pnt,1)
       col2x_grid=col1x_grid+sample_template(smp_pnt,2)
       col2y_grid=col1y_grid+sample_template(smp_pnt,3)

       row2_grid_rl=real(row2_grid)
       col2x_grid_rl=real(col2x_grid)
       col2y_grid_rl=real(col2y_grid)

       bnds2: if (box_grid_bnds(row2_grid,col2x_grid,col2y_grid)==0.) then
!!$
!!$       loop_box_x2: do box_x=1,box_size
!!$          loop_box_t2: do box_t=1,box_size
!!$             row2_grid=row1_grid-dense_dist+(box_t-1)
!!$             col2_grid=col1_grid-dense_dist+(box_x-1)
!!$             row2_grid_rl=row2_grid
!!$             col2_grid_rl=col2_grid
!!$
!!$             bnds: if (box_grid_bnds(row2_grid,col2_grid)==0.) then ! make sure the new point should not be ignored
          row2=box_grid_row(row2_grid,col2x_grid,col2y_grid) ! get the image indices for the new point
          col2x=box_grid_colx(row2_grid,col2x_grid,col2y_grid)
          col2y=box_grid_coly(row2_grid,col2x_grid,col2y_grid)
          ! LOOK UP WEIGHT MATRIX INDEX.  THE ROW(irow_mat) CORRESPONDS TO THE BASE POINT(row1,col1), 
          ! THE COL(icol_mat) CORRESPONDS TO THE NEW POINT(row2,col2)
          call look_up_wt3d(look_up_tab,row1,col1x,col1y,irow_mat)
          call look_up_wt3d(look_up_tab,row2,col2x,col2y,icol_mat)
          !     upper_triangle: if (irow_mat<icol_mat) then
!!$write(0,*) 'problem'
!!$stop
!!$end if
!!$              write(0,*) 'row1',row1
!!$              write(0,*) 'col1',col1
!!$              write(0,*) 'row2',row2
!!$              write(0,*) 'col2',col2
!!$              write(0,*) 'irow_mat',irow_mat
!!$              write(0,*) 'icol_mat',icol_mat
          ! MEASURE THE DISTANCE BETWEEN POINTS IN THE GRID
          dist=sqrt((row1_grid_rl-row2_grid_rl)**2+(col1x_grid_rl-col2x_grid_rl)**2+(col1y_grid_rl-col2y_grid_rl)**2)

          ! MAKE SURE THE DISTANCE IS LESS THAN INPUT DISTANCE THRESHOLD
          !          within_circle: if (dist<=real(max_dist)) then !.and.dist>=dense_dist)then

          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
          !        isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
          !           val_cnt=val_cnt+1 
          !           val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list
          sample_num=dist ! round down the distance(dist) to get the number of samples between points
          if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
          nodes=sample_num+2 ! total number of nodes including end points

          ! ALLOCATE xy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
          ! AND dd TO BE THE ARRAY OF POINTS SAMPLED 
          allocate(xy_coor(sample_num,3),dd(nodes),n_lint(3),d_lint(3),o_lint(3))
          xy_coor=0.;dd=0. ; n_lint=(/big_box_size,big_box_size,big_box_size/) ; o_lint=1. ; d_lint=1.

          ! ASSIGN XYT PAIRS TO EACH SAMPLE
          do iz=1,sample_num
             iz_rl=iz
             xy_coor(iz,1)=((row2_grid_rl-row1_grid_rl)/dist)*iz_rl+row1_grid_rl
             xy_coor(iz,2)=((col2x_grid_rl-col1x_grid_rl)/dist)*iz_rl+col1x_grid_rl
             xy_coor(iz,3)=((col2y_grid_rl-col1y_grid_rl)/dist)*iz_rl+col1y_grid_rl
             !  write(0,*) 'xy_coor',xy_coor
          end do

          ! INITIALIZE BILINEAR INTERPOLATOR
          call lint_init(n_lint,o_lint,d_lint,xy_coor)

          ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
          stat1=lint_lop(.false.,.false.,box_grid_1d,dd(2:nodes-1))
!!$  if(irow_mat==1.and.icol_mat==14)then
!!$  call lint_test_init(n_lint,o_lint,d_lint,xy_coor)
!!$          stat1=lint_test_lop(.false.,.false.,box_grid_1d,dd(2:nodes-1))
!!$write(0,*) 'b',box_grid(row1_grid,col1x_grid,col1y_grid+1)
!!$write(0,*) 'b',box_grid_1d(17:18)
!!$stop
!!$end if
          dd(1)=box_grid(row1_grid,col1x_grid,col1y_grid) ! assign end points
          dd(nodes)=box_grid(row2_grid,col2x_grid,col2y_grid)

          ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
          not_2_nodes1: if(nodes/=2) then
             if (minval(dd(2:nodes-1))<=dd(1).and.minval(dd(2:nodes-1))<=dd(nodes)&
             .and.minval(dd(2:nodes-1))<amp_thresh) then

                wt=0.
             else if (dd(1)<dd(nodes).and.dd(1)<amp_thresh) then ! if pnt1 is a mininum

                drow=row1-row2
                dcolx=col1x-col2x
                dcoly=col1y-col2y
                row1_back=row1+drow
                col1x_back=col1x+dcolx
                col1y_back=col1y+dcoly

                if (row1_back>=1.and.row1_back<=nt.and.col1x_back>=1.and.col1x_back<=nx.and.&
                col1y_back>=1.and.col1y_back<=ny) then
                   pnt1_back_amplitude=norm_d(row1_back,col1x_back,col1y_back)
                else
                   pnt1_back_amplitude=1. ! set the amplitude to 1 if it goes off the image
                end if
                if (pnt1_back_amplitude>norm_d(row1,col1x,col1y).and.&
                norm_d(row2,col2x,col2y)>norm_d(row1,col1x,col1y).and.norm_d(row1,col1x,col1y)<amp_thresh) then
                   !           if (row1<=row2.and.col1x<=col2x.and.col1y<=col2y) then ! break only along USW side
                  ! if (row1<=row2.and.col1x<=col2x) then ! break only along USW side
                      !      if (row1<row2) then ! break only along S side
                      wt=0.
                  ! else
                  !    wt=1.
                      !      end if
                  ! end if

                else if (dd(nodes)<dd(1).and.dd(nodes)<amp_thresh) then

                   drow=row1-row2
                   dcolx=col1x-col2x
                   dcoly=col1y-col2y
                   row2_back=row2-drow
                   col2x_back=col2x-dcolx
                   col2y_back=col2y-dcoly
                   ! BREAK ONLY ON THE UPPER,SOUTH,WEST SIDE
                   if (row2_back>=1.and.row2_back<=nt.and.col2x_back>=1.and.col2x_back<=nx.and.&
                   col2y_back>=1.and.col2y_back<=ny) then
                      pnt2_back_amplitude=norm_d(row2_back,col2x_back,col2y_back)
                   else
                      pnt2_back_amplitude=1. ! set the amplitude to 1 if it goes off the image
                   end if
                   if ( pnt2_back_amplitude>norm_d(row2,col2x,col2y).and.&
                   norm_d(row1,col1x,col1y)>norm_d(row2,col2x,col2y).and.norm_d(row2,col2x,col2y)<amp_thresh) then
                      !       if (row2<=row1.and.col2x<=col1x.and.col2y<=col1y) then ! break only along USW side
                      !     if (row2<row1) then ! break only along South side
                     ! if (row2<=row1.and.col2x<=col1x) then ! break only along USW side
                         wt=0.
                     ! else
                     !    wt=1.
                     ! end if
                   end if
                end if
             else
                wt=1.
             end if


             ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
          else
             wt=1.
             drow=row1-row2
             dcolx=col1x-col2x
             dcoly=col1y-col2y
             row2_back=row2-drow
             col2x_back=col2x-dcolx
             col2y_back=col2y-dcoly

             row1_back=row1+drow
             col1x_back=col1x+dcolx
             col1y_back=col1y+dcoly

             ! BREAK ONLY ON THE UPPER,SOUTH,WEST SIDE
             if (row2_back>=1.and.row2_back<=nt.and.col2x_back>=1.and.col2x_back<=nx.and.&
             col2y_back>=1.and.col2y_back<=ny) then
                pnt2_back_amplitude=norm_d(row2_back,col2x_back,col2y_back)
             else
                pnt2_back_amplitude=1. ! set the amplitude to 1 if it goes off the image
             end if
             if ( pnt2_back_amplitude>norm_d(row2,col2x,col2y).and.&
             norm_d(row1,col1x,col1y)>norm_d(row2,col2x,col2y).and.norm_d(row2,col2x,col2y)<amp_thresh) then
                !       if (row2<=row1.and.col2x<=col1x.and.col2y<=col1y) then ! break only along USW side
                ! if (row2<row1) then ! break only along South side
                !   if (row2<=row1.or.col2x<=col1x) then ! break only along South side
                wt=0.
                !             end if
             end if
             !  end if not_2_nodes1
             if (row1_back>=1.and.row1_back<=nt.and.col1x_back>=1.and.col1x_back<=nx.and.&
             col1y_back>=1.and.col1y_back<=ny) then
                pnt1_back_amplitude=norm_d(row1_back,col1x_back,col1y_back)
             else
                pnt1_back_amplitude=1. ! set the amplitude to 1 if it goes off the image
             end if


             if (pnt1_back_amplitude>norm_d(row1,col1x,col1y).and.&
             norm_d(row2,col2x,col2y)>norm_d(row1,col1x,col1y).and.norm_d(row1,col1x,col1y)<amp_thresh) then
                !           if (row1<=row2.and.col1x<=col2x.and.col1y<=col2y) then ! break only along USW side
                ! if (row1<row2) then ! break only along S side
                ! if (row1<=row2.or.col1x<=col2x)then
                wt=0.
                !               end if
             end if
!!$             if(irow_mat==2.and.icol_mat==15)then
!!$                write(0,*) pnt1_back_amplitude,pnt2_back_amplitude
!!$                stop
!!$             end if

          end if not_2_nodes1
!!$          if(irow_mat==2.and.icol_mat==15)then
!!$             write(0,*) pnt1_back_amplitude,pnt2_back_amplitude,'not2nodes'
!!$             stop
!!$          end if
          deallocate(dd,n_lint,d_lint,o_lint,xy_coor)
          !   if (size(xy_coor)>0) deallocate(xy_coor)


          ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
          if (wt>zero_tol)then
             !                      write(0,*) 'mem_alloc',mem_alloc
             if (icol_mat>irow_mat) then
                sparse_mat_index=sparse_mat_index+1
                if (sparse_mat_index>mem_alloc) then
                   write(0,*) 'reached memory limit riting out a chunk from calc_wt_rand3d'
                   call write_data(sparse_mat,sparse_mat_index,total_sparse_big,mem_alloc)    
                end if
                col_in_row=col_in_row+1  ! a row has been added to this column

                sparse_mat(sparse_mat_index,1)=irow_mat
                sparse_mat(sparse_mat_index,2)=icol_mat
                sparse_mat(sparse_mat_index,3)=wt
             elseif (icol_mat<irow_mat) then
!!$                write(0,*) 'icol_mat<irow_mat'
!!$                stop
                sparse_mat_index=sparse_mat_index+1
                if (sparse_mat_index>mem_alloc) then
                   write(0,*) 'reached memory limit riting out a chunk from calc_wt_rand3d'

                   call write_data(sparse_mat,sparse_mat_index,total_sparse_big,mem_alloc)  
                end if
                col_in_row=col_in_row+1  ! a row has been added to this column


                sparse_mat(sparse_mat_index,1)=icol_mat
                sparse_mat(sparse_mat_index,2)=irow_mat
                sparse_mat(sparse_mat_index,3)=wt
             end if
          end if
          ! end if isnew
          !       end if within_circle
          !       end if upper_triangle
       end if bnds2
    end do template

  end subroutine calc_wt_template3d

  subroutine write_data(sparse_mat,sparse_mat_index,total_sparse_big,mem_alloc)
    integer                        :: total_sparse,sparse_mat_index,it,index_new
    integer                        ::total_sparse_big,mem_alloc,last_index,sparse_index
    real,pointer, dimension(:)     :: sparse_mat_1d
    real, pointer, dimension(:,:)  ::sparse_mat,sparse_mat2
    real, dimension(:,:)                  ::sparse_mat_sort

    ! TRIM THE EXTRA OFF sparse_mat
    write(0,*) 'total_sparse before trim',sparse_mat_index
    total_sparse=sparse_mat_index-1

    write(0,*) 'total_sparse after trim',total_sparse
    allocate(sparse_mat2(total_sparse,3))
    sparse_mat2=sparse_mat(1:total_sparse,1:3)
    deallocate(sparse_mat)
    allocate(sparse_mat(total_sparse,3))
    sparse_mat=sparse_mat2
    deallocate(sparse_mat2)
!!$    do it=1,total_sparse
!!$       write(0,*) sparse_mat(it,1:)
!!$    enddo

    ! SORT THE SPARSE MATRIX
    !   write(0,*) 'sorting'
    allocate(sparse_mat_sort(3,total_sparse))
    do it=1,3
       sparse_mat_sort(it,1:)=sparse_mat(1:,it)
    end do
    call quick_sort(sparse_mat_sort,1,3,total_sparse)

    last_index=1
    do it=2,total_sparse
       if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
          call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
          last_index=it
       end if
    end do
    do it=1,3
       sparse_mat(1:,it)=sparse_mat_sort(it,1:)
    end do
    deallocate(sparse_mat_sort)
!!$    write(0,*) 'sorted'
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo
    write(0,*) 'total_sparse',total_sparse
    ! REMOVE REPEATING VALUES
    allocate(sparse_mat2(total_sparse,3))
    index_new=1
    sparse_mat2=0.
    sparse_mat2(1,1:)=sparse_mat(1,1:)
    do sparse_index=2,total_sparse
       if (sparse_mat(sparse_index,1)/=sparse_mat(sparse_index-1,1).or.sparse_mat(sparse_index,2)/=sparse_mat(sparse_index-1,2)) then
          index_new=index_new+1
          sparse_mat2(index_new,1:)=sparse_mat(sparse_index,1:)
       end if
    end do
    !   write(0,*) 'removed repeaters'
    deallocate(sparse_mat)
    !   write(0,*) 'total_sparse_before repeater removal', total_sparse
    total_sparse=index_new
    !   write(0,*) 'total_sparse_after repeater removal', total_sparse
    allocate(sparse_mat(total_sparse,3))
    sparse_mat=sparse_mat2(1:total_sparse,1:)
    deallocate(sparse_mat2)

    ! RESHAPE TO 1D
    allocate(sparse_mat_1d(total_sparse*3))
    do it=1, total_sparse
       sparse_mat_1d(1+(it-1)*3:3+(it-1)*3)=sparse_mat(it,1:3)
    end do
    deallocate(sparse_mat)

    ! RITE OUT FILE AND THEN LOOP
    ! call srite("out",sparse_mat,4*total_sparse*3)
    call sep_write(sparse_mat_1d)
    deallocate(sparse_mat_1d)
    allocate(sparse_mat(mem_alloc,3))
    sparse_mat_index=1
    total_sparse_big=total_sparse_big+total_sparse

  end subroutine write_data

end module paint_mod3d_2
