module pick_mod


contains
  integer function isbound(data,mask,it,nt,ix,nx,non_mask_indicator)
    !returns a 1 if point is on the boundary, A BOUND HAS ONE OF ITS EIGHT SIDES TOUCHING OUTSIDE OF THE BOUNDARY

    real,  dimension(:,:,:)	                                :: data,mask
    integer							:: ix,it,nt,nx,non_mask_indicator

    if (data(it,ix,1)==1.and.mask(it,ix,1)==1..and.&
    (data(max(1,it-1),ix,1)==non_mask_indicator.or.data(min(nt,it+1),ix,1)==non_mask_indicator.or.&
    data(it,max(1,ix-1),1)==non_mask_indicator.or.data(it,min(nx,ix+1),1)==non_mask_indicator &
    !       data(max(1,it-1),ix-1)==non_mask_indicator.or.data(min(nt,it+1),ix+1)==non_mask_indicator.or.&
    !     data(min(nt,it+1),max(1,ix-1))==non_mask_indicator.or.data(max(1,it-1),min(nx,ix+1))==non_mask_indicator&        
       )) then 
       isbound=1
    else
       isbound=0
    end if

  end function isbound
  integer function isbound3d(data,mask,it,nt,ix,nx,iy,ny,non_mask_indicator)
    !returns a 1 if point is on the boundary, A BOUND HAS ONE OF ITS EIGHT SIDES TOUCHING OUTSIDE OF THE BOUNDARY

    real,  dimension(:,:,:)	                                :: data,mask
    integer							:: ix,it,nt,nx,non_mask_indicator
    integer							:: ixq,iyq,itq
    loop_around_box:  do itq=-1,1
       do ixq=-1,1
          do iyq=-1,1
             if (data(it,ix,iy)==1.and.mask(it,ix,iy)==1..and.&
                  data(min(max(1,it+itq),nt),min(max(1,ix+ixq),nx),min(max(1,iy+iyq),ny))/=1.  &
                  ) then 
                isbound3d=1
                if     (data(min(max(1,it+itq),nt),min(max(1,ix+ixq),nx),min(max(1,iy+iyq),ny))==0.) then
                   non_mask_indicator=1 ! INNERBOUND
                elseif (data(min(max(1,it+itq),nt),min(max(1,ix+ixq),nx),min(max(1,iy+iyq),ny))==2.) then
                   non_mask_indicator=2 ! OUTERBOUND
                else
                   write(0,*) 'error isbound3d'
                   non_mask_indicator=0             
                   stop
                end if
                exit loop_around_box
             else
                isbound3d=0
             end if
          end do
       end do
    end do loop_around_box


  end function isbound3d
  
!!$  subroutine scan_neighborhd(data,mask,it,nt,ix,nx,iy,ny,non_mask_indicator,search_distances,iline_vec1,iline_vec2,xline_vec1,xline_vec2)
!!$    ! SEARCH 2D CIRCLES FOR NEARBY BOUNDS TO GET INLINE AND XLINE VECTORS
!!$    real,  dimension(:,:,:)	                                :: data,mask
!!$    integer							:: ix,it,nt,nx,non_mask_indicator
!!$    integer							:: ixq,iyq,itq,step_nums,istep,step_sz
!!$    integer, dimension(:)                                       ::search_distances
!!$
!!$! FIND CLOSEST POINTS AND FIT A PLANE TO IT
!!$    step_nums=size(search_distances)
!!$
!!$    do istep=1,step_nums
!!$       step_sz=step_nums(istep)
!!$
!!$
!!$
!!$     end subroutine scan_neighborhd
end module pick_mod









