module psegment3d_mod

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod
  use sample_mod_3d

contains 
  subroutine find_weight_mat3d(first_row,last_row,nt,nx,ny,mem_alloc,sample_scale,wt_mat_sz,max_dist,max_wt_num,amp_thresh,zero_tol,norm_d,norm_d_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,look_up_tab,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)
    ! Calculates W for a sparse matrix for specified rows   Jesse Lomask 9/22/04
    implicit none

    integer				::nt, nx, ny,first_row,last_row
    integer				::it,ix,ir,iq,iz,max_dist,dense_dist,max_wt_num
    integer                               ::irow,row1,col1,row2,col2,val_cnt,n_new_val,rand_jump_int
    integer                               ::box_size,big_box_size,fill
    integer                               ::row2_raw,col2_raw,delta_row2,delta_col2
    integer                               ::row1_grid,col1_grid,row2_grid,col2_grid
    integer                               ::irow_mat,icol_mat,sample_num,nodes
    integer                               ::drow,row1_back,col1_back,row2_back,col2_back
    integer                               ::sparse_mat_index,col_in_row,sparse_index
    integer                               ::box_x,box_t,stat1,dcol,index_new
    integer                               ::total_sparse,row_count,last_index,smpl_cnt
    integer                               ::newsize,ncv_val,mem_alloc
    integer                               ::ignore_wrapping, wt_mat_sz
    integer                               ::ub_n1,lb_n1,col1x,col1y
    integer,allocatable, dimension(:,:)               ::sample_template,sample_template2
    real                                  ::maxdat,mindat,rangedat,amp_thresh,zero_tol
    real                                  ::rand_jump,dist,iz_rl, wt,pi_var,sample_scale
    real                                  ::row1_grid_rl,col1_grid_rl,row2_grid_rl,col2_grid_rl
    real                                  ::subsam_increment,dt,dx,ot,ox,attr_coef
    real,dimension(:)              	::norm_d_1d
    real,dimension(:),allocatable	  ::val_list
    real, pointer, dimension(:,:,:)	        ::d, norm_d
    real, pointer, dimension(:,:)	        ::sparse_mat,xy
    real, pointer, dimension(:,:)	        ::DminusW,DminusWD,DDminusWD
    real, dimension(:,:,:)                  ::look_up_image
    real, dimension(:,:),allocatable      ::look_up_tab
    real, dimension(:,:),allocatable      ::sparse_mat_sort
    real, dimension(:,:),allocatable      ::sparse_mat2,tester
    real, dimension(:,:,:)                ::upper_bnd,lower_bnd
    real, dimension(:,:)                  ::upper_bnd_tracker,lower_bnd_tracker
    real, dimension(:,:,:)                  ::mask_in
    real, dimension(:,:,:)                  ::first_attribute

    write(0,*) 'non_zero_mask',wt_mat_sz
    write(0,*) 'mem_alloc',mem_alloc


    ! ALLOCATE SPARSE MATRIX ...MAKE AS BIG AS ALLOWABLE
    deallocate(sparse_mat)
    allocate(sparse_mat(mem_alloc,3))! 175000000

    ! ALLOCATE NEW POINT TRACKER AND GRID

    pi_var=acos(-1.)

    write(0,*) 'max number of random samples',nint(sample_scale*(3.*pi_var*real(max_dist))) 
    allocate(val_list(max_wt_num))


    write(0,*) 'first row',first_row,'last row',last_row


    ! LOOP OVER EACH ROW OF THE WEIGHT MATRIX
    sparse_mat_index=0 ! index of sparse matrix
    col_in_row=0       ! keep track of number of column in each row

    loop_over_rows:   do irow=first_row,last_row

       ! EACH ROW IN THE WEIGHT MATRIX CORRESPONDS TO A POINT IN THE INPUT IMAGE 
       ! HERE WE LOOK UP THE INDEXES OF THAT ROW
       row1 =look_up_tab(irow,2)  !assign row
       col1x=look_up_tab(irow,3); !assign col
       col1y=look_up_tab(irow,4); !assign col
       !   call look_up_wt(look_up_tab,row1,col1,irow_mat)

       ! INITIALIZE NEW POINT TRACKING PARAMETERS
       val_list=0. 
       val_cnt=0

       !write(0,*) 'about to enter subroutine'
       ! write(0,*) 'in'
       call sample_model3d(nt,nx,ny,mem_alloc,sample_scale,max_dist,amp_thresh,zero_tol,row1,col1x,col1y,norm_d,norm_d_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,val_list,val_cnt,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)
       !write(0,*) 'exited subroutine'
       !write(0,*) 'out'





       sparse_mat_index=sparse_mat_index+1
       if (sparse_mat_index>=mem_alloc) then
          write(0,*) 'did not allocate enough memory'
          stop
       end if

       col_in_row=col_in_row+1 ! a column has been added to this row
       sparse_mat(sparse_mat_index,1)=irow
       sparse_mat(sparse_mat_index,2)=irow
       sparse_mat(sparse_mat_index,3)=1.
       !   end if isnew2
       col_in_row=0
       if (real(irow)/100.-floor(real(irow)/100.)<0.001) then
          write(0,*) 'finished row',irow,'of ',wt_mat_sz
       end if
    end do loop_over_rows



    ! TRIM THE EXTRA OFF sparse_mat
    write(0,*) 'total_sparse before trim',sparse_mat_index
    total_sparse=sparse_mat_index
    write(0,*) 'here1a',total_sparse
    write(0,*) 'total_sparse after trim',total_sparse
    !  deallocate(sparse_mat2)
    allocate(sparse_mat2(total_sparse,3))
    !  allocate(sparse_mat2(2,2))
    allocate(tester(2,2))

    sparse_mat2=sparse_mat(1:total_sparse,1:3)

    deallocate(sparse_mat,val_list)

    allocate(sparse_mat(total_sparse,3))

    sparse_mat=sparse_mat2

    deallocate(sparse_mat2)
!!$
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

    ! SORT THE SPARSE MATRIX
    write(0,*) 'sorting'
    allocate(sparse_mat_sort(3,total_sparse))
    do it=1,3
       sparse_mat_sort(it,1:)=sparse_mat(1:,it)
    end do
    call quick_sort(sparse_mat_sort,1,3,total_sparse)
    !write(0,*) 'max/min', maxval(sparse_mat_sort(2,1:)), minval(sparse_mat_sort(2,1:))
    !write(0,*) 'max/min', maxval(sparse_mat_sort(1,1:)), minval(sparse_mat_sort(1,1:))
    !write(0,*) 'max/min', maxval(sparse_mat_sort(3,1:)), minval(sparse_mat_sort(3,1:))

    last_index=1
    do it=2,total_sparse
       if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
          call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
          last_index=it
       end if
    end do
    do it=1,3
       sparse_mat(1:,it)=sparse_mat_sort(it,1:)
    end do
    deallocate(sparse_mat_sort)
    write(0,*) 'sorted'
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

!!$  ! REMOVE REPEATING VALUES
    allocate(sparse_mat2(total_sparse,3))
    index_new=1
    sparse_mat2=0.
    sparse_mat2(1,1:)=sparse_mat(1,1:)
    do sparse_index=2,total_sparse
       if (sparse_mat(sparse_index,1)/=sparse_mat(sparse_index-1,1).or.sparse_mat(sparse_index,2)/=sparse_mat(sparse_index-1,2)) then
          index_new=index_new+1
          sparse_mat2(index_new,1:)=sparse_mat(sparse_index,1:)
       end if
    end do
    write(0,*) 'removed repeaters'
    deallocate(sparse_mat)
    write(0,*) 'total_sparse_before repeater removal', total_sparse
    total_sparse=index_new
    write(0,*) 'total_sparse_after repeater removal', total_sparse
    allocate(sparse_mat(total_sparse,3))
    sparse_mat=sparse_mat2(1:total_sparse,1:)
    deallocate(sparse_mat2)

!!$    ! MAKE SYMMETRIC  (unnessesary, to be removed later)
!!$    write(0,*) 'make symmetric'
!!$    index_new=0
!!$    newsize=2*total_sparse-(maxval(sparse_mat(1:,1)))
!!$    newsize=2*total_sparse-(last_row-first_row)
!!$    write(0,*) 'newsize',newsize, maxval(sparse_mat(1:,1)),total_sparse
!!$    allocate(sparse_mat2(newsize,3))
!!$    do it=1,total_sparse
!!$       if (sparse_mat(it,1)==sparse_mat(it,2)) then
!!$          index_new=index_new+1
!!$          sparse_mat2(index_new,1:)=sparse_mat(it,1:)
!!$       else
!!$          index_new=index_new+1
!!$          sparse_mat2(index_new,1:)=sparse_mat(it,1:)
!!$          index_new=index_new+1
!!$          sparse_mat2(index_new,1)=sparse_mat(it,2)
!!$          sparse_mat2(index_new,2)=sparse_mat(it,1)
!!$          sparse_mat2(index_new,3)=sparse_mat(it,3)
!!$       end if
!!$    end do
!!$    deallocate(sparse_mat)
!!$    total_sparse=index_new  !newsize
!!$    allocate(sparse_mat(total_sparse,3))
!!$    sparse_mat=sparse_mat2
!!$    deallocate(sparse_mat2)


    sparse_mat_index=total_sparse

  end subroutine find_weight_mat3d

  subroutine find_weight_mat3d_sub(first_row,last_row,nt,nx,ny,j1,j2,j3,mem_alloc,sample_scale,wt_mat_sz,max_dist,max_wt_num,amp_thresh,zero_tol,norm_d,norm_d_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,look_up_tab,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)
    ! Calculates W for a sparse matrix for specified rows   Jesse Lomask 9/22/04
    implicit none

    integer				::nt, nx, ny,first_row,last_row
    integer				::it,ix,ir,iq,iz,max_dist,dense_dist,max_wt_num
    integer                               ::irow,row1,col1,row2,col2,val_cnt,n_new_val,rand_jump_int
    integer                               ::box_size,big_box_size,fill
    integer                               ::row2_raw,col2_raw,delta_row2,delta_col2
    integer                               ::row1_grid,col1_grid,row2_grid,col2_grid
    integer                               ::irow_mat,icol_mat,sample_num,nodes
    integer                               ::drow,row1_back,col1_back,row2_back,col2_back
    integer                               ::sparse_mat_index,col_in_row,sparse_index
    integer                               ::box_x,box_t,stat1,dcol,index_new
    integer                               ::total_sparse,row_count,last_index,smpl_cnt
    integer                               ::newsize,ncv_val,mem_alloc,j1,j2,j3
    integer                               ::ignore_wrapping, wt_mat_sz
    integer                               ::ub_n1,lb_n1,col1x,col1y
    integer,allocatable, dimension(:,:)               ::sample_template,sample_template2
    real                                  ::maxdat,mindat,rangedat,amp_thresh,zero_tol
    real                                  ::rand_jump,dist,iz_rl, wt,pi_var,sample_scale
    real                                  ::row1_grid_rl,col1_grid_rl,row2_grid_rl,col2_grid_rl
    real                                  ::subsam_increment,dt,dx,ot,ox,attr_coef
    real,dimension(:)              	::norm_d_1d
    real,dimension(:),allocatable	  ::val_list
    real, pointer, dimension(:,:,:)	        ::d, norm_d
    real, pointer, dimension(:,:)	        ::sparse_mat,xy
    real, pointer, dimension(:,:)	        ::DminusW,DminusWD,DDminusWD
    real, dimension(:,:,:)                  ::look_up_image
    real, dimension(:,:),allocatable      ::look_up_tab
    real, dimension(:,:),allocatable      ::sparse_mat_sort
    real, dimension(:,:),allocatable      ::sparse_mat2,tester
    real, dimension(:,:,:)                ::upper_bnd,lower_bnd
    real, dimension(:,:)                  ::upper_bnd_tracker,lower_bnd_tracker
    real, dimension(:,:,:)                  ::mask_in
    real, dimension(:,:,:)                  ::first_attribute

    write(0,*) 'non_zero_mask',wt_mat_sz
    write(0,*) 'mem_alloc',mem_alloc


    ! ALLOCATE SPARSE MATRIX ...MAKE AS BIG AS ALLOWABLE
    deallocate(sparse_mat)
    allocate(sparse_mat(mem_alloc,3))! 175000000

    ! ALLOCATE NEW POINT TRACKER AND GRID

    pi_var=acos(-1.)

    write(0,*) 'max number of random samples',nint(sample_scale*(3.*pi_var*real(max_dist))) 
    allocate(val_list(max_wt_num))


    write(0,*) 'first row',first_row,'last row',last_row


    ! LOOP OVER EACH ROW OF THE WEIGHT MATRIX
    sparse_mat_index=0 ! index of sparse matrix
    col_in_row=0       ! keep track of number of column in each row

    loop_over_rows:   do irow=first_row,last_row

       ! EACH ROW IN THE WEIGHT MATRIX CORRESPONDS TO A POINT IN THE INPUT IMAGE 
       ! HERE WE LOOK UP THE INDEXES OF THAT ROW
       row1 =look_up_tab(irow,2)  !assign row
       col1x=look_up_tab(irow,3); !assign col
       col1y=look_up_tab(irow,4); !assign col
       !   call look_up_wt(look_up_tab,row1,col1,irow_mat)

       ! INITIALIZE NEW POINT TRACKING PARAMETERS
       val_list=0. 
       val_cnt=0

       !write(0,*) 'about to enter subroutine'
       ! write(0,*) 'in'
       call sample_model3d_sub(nt,nx,ny,j1,j2,j3,mem_alloc,sample_scale,max_dist,amp_thresh,zero_tol,row1,col1x,col1y,norm_d,norm_d_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,val_list,val_cnt,mask_in,upper_bnd,upper_bnd_tracker,lower_bnd,lower_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)
       !write(0,*) 'exited subroutine'
       !write(0,*) 'out'





       sparse_mat_index=sparse_mat_index+1
       if (sparse_mat_index>=mem_alloc) then
          write(0,*) 'did not allocate enough memory'
          stop
       end if

       col_in_row=col_in_row+1 ! a column has been added to this row
       sparse_mat(sparse_mat_index,1)=irow
       sparse_mat(sparse_mat_index,2)=irow
       sparse_mat(sparse_mat_index,3)=1.
       !   end if isnew2
       col_in_row=0
       if (real(irow)/100.-floor(real(irow)/100.)<0.001) then
          write(0,*) 'finished row',irow,'of ',wt_mat_sz
       end if
    end do loop_over_rows



    ! TRIM THE EXTRA OFF sparse_mat
    write(0,*) 'total_sparse before trim',sparse_mat_index
    total_sparse=sparse_mat_index
    write(0,*) 'here1a',total_sparse
    write(0,*) 'total_sparse after trim',total_sparse
    !  deallocate(sparse_mat2)
    allocate(sparse_mat2(total_sparse,3))
    !  allocate(sparse_mat2(2,2))
    allocate(tester(2,2))

    sparse_mat2=sparse_mat(1:total_sparse,1:3)

    deallocate(sparse_mat,val_list)

    allocate(sparse_mat(total_sparse,3))

    sparse_mat=sparse_mat2

    deallocate(sparse_mat2)
!!$
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

    ! SORT THE SPARSE MATRIX
    write(0,*) 'sorting'
    allocate(sparse_mat_sort(3,total_sparse))
    do it=1,3
       sparse_mat_sort(it,1:)=sparse_mat(1:,it)
    end do
    call quick_sort(sparse_mat_sort,1,3,total_sparse)
    !write(0,*) 'max/min', maxval(sparse_mat_sort(2,1:)), minval(sparse_mat_sort(2,1:))
    !write(0,*) 'max/min', maxval(sparse_mat_sort(1,1:)), minval(sparse_mat_sort(1,1:))
    !write(0,*) 'max/min', maxval(sparse_mat_sort(3,1:)), minval(sparse_mat_sort(3,1:))

    last_index=1
    do it=2,total_sparse
       if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
          call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
          last_index=it
       end if
    end do
    do it=1,3
       sparse_mat(1:,it)=sparse_mat_sort(it,1:)
    end do
    deallocate(sparse_mat_sort)
    write(0,*) 'sorted'
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

!!$  ! REMOVE REPEATING VALUES
    allocate(sparse_mat2(total_sparse,3))
    index_new=1
    sparse_mat2=0.
    sparse_mat2(1,1:)=sparse_mat(1,1:)
    do sparse_index=2,total_sparse
       if (sparse_mat(sparse_index,1)/=sparse_mat(sparse_index-1,1).or.sparse_mat(sparse_index,2)/=sparse_mat(sparse_index-1,2)) then
          index_new=index_new+1
          sparse_mat2(index_new,1:)=sparse_mat(sparse_index,1:)
       end if
    end do
    write(0,*) 'removed repeaters'
    deallocate(sparse_mat)
    write(0,*) 'total_sparse_before repeater removal', total_sparse
    total_sparse=index_new
    write(0,*) 'total_sparse_after repeater removal', total_sparse
    allocate(sparse_mat(total_sparse,3))
    sparse_mat=sparse_mat2(1:total_sparse,1:)
    deallocate(sparse_mat2)

!!$    ! MAKE SYMMETRIC  (unnessesary, to be removed later)
!!$    write(0,*) 'make symmetric'
!!$    index_new=0
!!$    newsize=2*total_sparse-(maxval(sparse_mat(1:,1)))
!!$    newsize=2*total_sparse-(last_row-first_row)
!!$    write(0,*) 'newsize',newsize, maxval(sparse_mat(1:,1)),total_sparse
!!$    allocate(sparse_mat2(newsize,3))
!!$    do it=1,total_sparse
!!$       if (sparse_mat(it,1)==sparse_mat(it,2)) then
!!$          index_new=index_new+1
!!$          sparse_mat2(index_new,1:)=sparse_mat(it,1:)
!!$       else
!!$          index_new=index_new+1
!!$          sparse_mat2(index_new,1:)=sparse_mat(it,1:)
!!$          index_new=index_new+1
!!$          sparse_mat2(index_new,1)=sparse_mat(it,2)
!!$          sparse_mat2(index_new,2)=sparse_mat(it,1)
!!$          sparse_mat2(index_new,3)=sparse_mat(it,3)
!!$       end if
!!$    end do
!!$    deallocate(sparse_mat)
!!$    total_sparse=index_new  !newsize
!!$    allocate(sparse_mat(total_sparse,3))
!!$    sparse_mat=sparse_mat2
!!$    deallocate(sparse_mat2)


    sparse_mat_index=total_sparse

  end subroutine find_weight_mat3d_sub

end module psegment3d_mod

