module sample_mod
!!! 
  use lint2
  use warp_mod
  use paint_mod

contains


  subroutine sample_model(nx,nt,mem_alloc,sample_scale,max_dist,amp_thresh,zero_tol,row1,col1,full_image,full_image_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,val_list,val_cnt,mask_in,outer_bnd,outer_bnd_tracker,inner_bnd,inner_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)


    real,dimension(:)	                ::val_list
    integer                             ::val_cnt,sample_num,iz
    integer                             ::sparse_mat_index,mem_alloc,irow_mat,icol_mat
    integer                             ::x_shift_int,y_shift_int,nodes,path_row,path_col 
    real,dimension(:)                 	::full_image_1d
    real, pointer, dimension(:,:)       ::sparse_mat,path_xy,new_path_xy
    real,dimension(:),allocatable	::path_dd
    real, dimension(:,:)                ::look_up_image,first_attribute
    real                                ::row1_rl,row2_rl,col1_rl,col2_rl,iz_rl,sample_scale
    real                                ::x_shift,y_shift,rand_dir,rand_dist,dist,pi_var,dist2,amp_thresh
    real                                ::attr_coef

    integer                             ::it,ix,iy,boundary_index,iq
    integer                             :: nx,ny,nt,max_dist,row1,col1,rand_jump_int
    integer                             ::row2_raw,col2x_raw,delta_row2,delta_col2
    integer                             ::row2,col2,too_far,dumbtest,found1
    integer                             ::col_in_row
    integer                             ::n_row,n_col,outer_shft1,outer_bnd_sum,inner_shft1
    integer                             ::inner_bnd_sum,step,n_row2,n_col2x,n_col2y,irow
    integer                             ::outer_bnd_n1, inner_bnd_n1,ignore_wrapping
    real                                ::rand_jump,vec_length,norm_length
    real                                ::drow,dcolx,dcoly,norm_dist1,xt_dist,yt_dist 
    real,dimension(:),allocatable	::norm_at_bnd,vec_at_new_bnd,norm_at_new_bnd,row2_2bnd
    real,dimension(:),allocatable       ::xt_basis,xt_basis_2,yt_basis,yt_basis_2
    real,dimension(:),allocatable       ::basis_at_bnd,basis_at_new_bnd
    real,dimension(:,:)                 ::full_image
    real,dimension(:,:)                 ::inner_bnd_tracker,outer_bnd_tracker  
    real, dimension(:,:)                ::mask_in
    real, dimension(:,:)                ::inner_bnd,outer_bnd



    ! write(0,*) 'into subroutine'
    pi_var=acos(-1.)

    row1_rl=real(row1)
    col1_rl=real(col1)

    ! call look_up_wt(look_up_tab,row1,col1,irow_mat)

    outer_bnd_n1=size(outer_bnd_tracker(1:,1))
    inner_bnd_n1=size(inner_bnd_tracker(1:,1))



    ! RENORMALIZE BASIS VECTORS
    do iq=1,outer_bnd_n1
       outer_bnd_tracker(iq,3:4)=outer_bnd_tracker(iq,3:4)/((outer_bnd_tracker(iq,3)**2+outer_bnd_tracker(iq,4)**2)**.5)
       outer_bnd_tracker(iq,5:6)=outer_bnd_tracker(iq,5:6)/((outer_bnd_tracker(iq,5)**2+outer_bnd_tracker(iq,6)**2)**.5)  
    end do
    do iq=1,inner_bnd_n1
       inner_bnd_tracker(iq,3:4)=inner_bnd_tracker(iq,3:4)/((inner_bnd_tracker(iq,3)**2+inner_bnd_tracker(iq,4)**2)**.5)
       inner_bnd_tracker(iq,5:6)=inner_bnd_tracker(iq,5:6)/((inner_bnd_tracker(iq,5)**2+inner_bnd_tracker(iq,6)**2)**.5)  
    end do

    allocate(norm_at_bnd(2),vec_at_new_bnd(2),norm_at_new_bnd(2),row2_2bnd(2))
    allocate(xt_basis(2),xt_basis_2(2),yt_basis(2),yt_basis_2(2))
    allocate(basis_at_bnd(4),basis_at_new_bnd(4)) 





    ! DRAW RANDOM BOUNDARY SHIFTS
    ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
!!$    call random_number(rand_jump)
!!$    outer_shft1=nint(rand_jump*real(outer_bnd_n1-1)+1)   
!!$    inner_shft1=nint(rand_jump*real(inner_bnd_n1-1)+1)





    ! CALCULATE NUMBER OF SAMPLES
    n_sam=nint(sample_scale*(3.*pi_var*real(max_dist))) 

    loop_n_times: do srch=1,n_sam

       ! DRAW RANDOM NUMBERS  ==> DISTANCE, AZIMUTH
       ! DRAW RAND DIRECTION
       call random_number (rand_dir)
       rand_dir=rand_dir*2.*pi_var ! assign angle
       ! DRAW RAND DISTANCE
       call random_number(rand_dist)
       rand_dist=(max_dist-1)*rand_dist+1


       ! DRAW RANDOM BOUNDARY SHIFTS
       ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
       call random_number(rand_jump)
       outer_shft1=nint(rand_jump*real(outer_bnd_n1-1)+1)   
       inner_shft1=nint(rand_jump*real(inner_bnd_n1-1)+1)


       ! CALCULATE SHIFTS
       x_shift=rand_dist*cos(rand_dir)
       y_shift=rand_dist*sin(rand_dir)
       x_shift_int=nint(x_shift)
       y_shift_int=nint(y_shift)

       ! CALCULATE NEW POINT
       row2=row1+y_shift_int
       col2=col1+x_shift_int
       row2_rl=real(row2)
       col2_rl=real(col2)




       dist=sqrt((row1_rl-row2_rl)**2+(col1_rl-col2_rl)**2)

       ! MAKE SURE THE NEW POINT IS IN THE DATA CUBE
       !    within_bnds:  if (row2>=1.and.row2<=nt.and.col2>=1.and.col2<=nx ) then


       !          write(0,*) 'here1'
       !   call look_up_wt(look_up_tab,row2,col2,icol_mat)    
       !         write(0,*) 'here2'

!!$          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
!!$          isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
!!$             val_cnt=val_cnt+1 
!!$             val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list


       ! START STEPPING TOWARDS THE NEW POINT, KEEPING TRACK OF X,Y'S FOR BILINEAR INTERPOLATION AND ALSO CHECK TO SEE IF A BOUNDARY IS CROSSED

       sample_num=dist ! round down the distance(dist) to get the number of samples between points
       if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
       nodes=sample_num+2 ! total number of nodes including end points


       allocate(path_xy(nodes,2))
       path_xy(1,1)=row1_rl; path_xy(1,2)=col1_rl

       n_row=row1  ! ASSIGN LOCATIONS FOR BOUNDARY EXTRACTION
       n_col=col1

       !         write(0,*) 'nodes at beginning',nodes
       ! ASSIGN XY PAIRS TO EACH SAMPLE
       fillpath: do iz=2,nodes
          iz_rl=real(iz)
          !       path_xy(iz,1)=((row2_rl-row1_rl)/dist)*(iz_rl-1)+row1_rl
          !       path_xy(iz,2)=((col2_rl-col1_rl)/dist)*(iz_rl-1)+col1_rl
          path_xy(iz,1)=((row2_rl-row1_rl)/(nodes-1))*(iz_rl-1.)+row1_rl
          path_xy(iz,2)=((col2_rl-col1_rl)/(nodes-1))*(iz_rl-1.)+col1_rl

          path_row=nint(path_xy(iz,1)) ; path_col=nint(path_xy(iz,2))
          within_bnds:  if (path_row>=1.and.path_row<=nt.and.path_col>=1.and.path_col<=nx ) then

!!$if (iz==nodes) then !.and.(path_xy(iz,1)/=row2_rl.or.path_xy(iz,2)/=col2_rl)) then
!!$write(0,*) path_xy(iz,1),row2_rl,path_row
!!$write(0,*) path_xy(iz,2),col2_rl,path_col
!!$!stop
!!$end if


             !write(0,*) path_row,path_col

             ! CHECK TO SEE IF BOUNDARY IS CROSSED
             ! IF CROSSES OUTER BOUNDARY
             out_of_mask: if (mask_in(path_row,path_col)==0.) then
                !               write(0,*) 'mask==1'
                if (ignore_wrapping==1.) then
                   sample_num=iz-2
                   row2=n_row ;col2=n_col
                   cycle loop_n_times ! exit fillpath !
                end if


                ! GRAB NEAREST BOUNDARY POINT
                if (outer_bnd(n_row,n_col)/=0) then
                   boundary_index=nint(outer_bnd(n_row,n_col))
                elseif(outer_bnd(n_row+1,n_col)/=0.and.n_row+1<=nt) then
                   !     write(0,*) 'looping for boundary'
                   boundary_index=nint(outer_bnd(n_row+1,n_col))
                elseif(outer_bnd(n_row-1,n_col)/=0.and.n_row-1>=1) then
                   !     write(0,*) 'looping for boundary'
                   boundary_index=nint(outer_bnd(n_row-1,n_col))
                elseif(outer_bnd(n_row,n_col+1)/=0.and.n_col+1<=nx) then
                   !    write(0,*) 'looping for boundary'
                   boundary_index=nint(outer_bnd(n_row,n_col+1))
                elseif(outer_bnd(n_row,n_col-1)/=0.and.n_col-1>=1) then
                   !    write(0,*) 'looping for boundary'
                   boundary_index=nint(outer_bnd(n_row,n_col-1))
                else
                   write(0,*) 'did not find boundary'
                   stop
                end if

                if (boundary_index<1.or.boundary_index>outer_bnd_n1) then
                   write(0,*) 'boundary_index is strange',boundary_index
                   stop
                end if

                ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                vec_at_new_bnd(1:2)=outer_bnd_tracker(outer_shft1,1:2) 
                row2_new_bnd=outer_bnd_tracker(outer_shft1,1) ! NEW BOUNDARY POINT
                col2_new_bnd=outer_bnd_tracker(outer_shft1,2) ! NEW BOUNDARY POINT
                row2_new_bnd_rl=real(row2_new_bnd) ; col2_new_bnd_rl=real(col2_new_bnd)

                basis_at_bnd=outer_bnd_tracker(boundary_index,3:6)
                basis_at_new_bnd=outer_bnd_tracker(outer_shft1,3:6)

                ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                row2_2bnd(1)=row2-n_row
                row2_2bnd(2)=col2-n_col

                found1=1

                ! PROJECT ONTO BASIS AS FIRST POINT
                xt_dist   =1*dot_product(row2_2bnd,basis_at_bnd(1:2))
                norm_dist1=1.*dot_product(row2_2bnd,basis_at_bnd(3:4))

                ! PROJECT ON NEW BASIS VECTORS TO GET NEW POINT
                row2_new =nint(vec_at_new_bnd(1)-basis_at_new_bnd(3)*norm_dist1-basis_at_new_bnd(1)*xt_dist)
                col2_new=nint(vec_at_new_bnd(2)-basis_at_new_bnd(4)*norm_dist1-basis_at_new_bnd(2)*xt_dist)
                row2_new_rl=real(row2_new) ; col2_new_rl=real(col2_new)

                ! MAKE SURE NEW POINT IS WITHIN MASK


                ! STEP FROM POINT AT NEW BOUND TO NEW POINT TO COMPLETE PATH VECTOR
                dist2=(xt_dist**2+norm_dist1**2)**.5 
                sample_num2=dist2
                if (dist2-sample_num2<=.5) sample_num2=sample_num2-1 ! drop the last sample if it is too close to the end
                nodes2=sample_num2+2 ! total number of nodes including end poi
                path_xy(iz,1)=row2_new_bnd_rl              
                path_xy(iz,2)=col2_new_bnd_rl
                path_row=nint(path_xy(iz,1)) ; path_col=nint(path_xy(iz,2))
                !           write(0,*) nint(path_xy(iz,1)),nint(path_xy(iz,2))


                iz2_rl=0.
                do iz_2=iz+1,nodes
                   iz2_rl=iz2_rl+1.
                   path_xy(iz_2,1)=((row2_new_rl-row2_new_bnd_rl)/dist2)*iz2_rl+row2_new_bnd_rl
                   path_xy(iz_2,2)=((col2_new_rl-col2_new_bnd_rl)/dist2)*iz2_rl+col2_new_bnd_rl
                   !  path_xy(iz_2,1)=((row2_new_rl-row2_new_bnd_rl)/nodes-iz-1)*iz2_rl+row2_new_bnd_rl
                   ! path_xy(iz_2,2)=((col2_new_rl-col2_new_bnd_rl)/(nodes-iz-1)*iz2_rl+col2_new_bnd_rl

                   !                   write(0,*) nint(path_xy(iz_2,1)),nint(path_xy(iz_2,2))
                   ! IF WE CROSS OUT OF MASK THEN STOP HERE AND GRAB ANOTHER POINT
                   path_row=nint(path_xy(iz_2,1)) ; path_col=nint(path_xy(iz_2,2))
                   !                   write(0,*) 'hello1' ,path_row,path_col ,iz,iz_2,col2_new_bnd_rl,col2_new_rl
                   !                   write(0,*) 'path',path_xy(1:,2)

                   ! IF NEW POINT IS OUTSIDE OF FIGURE BOUNDS, REJECT IT
                   if (path_row<1.or.path_row>nt.or.path_col<1.or.path_col>nx) then
                      !                      write(0,*) 'hello1reject',iz_2-1
                      sample_num=iz_2-2
                      row2=nint(path_xy(iz_2-1,1)) ;col2=nint(path_xy(iz_2-1,2))
                      ! cycle loop_n_times
                      exit fillpath   
                      ! IF NEW POINT IS OUTSIDE OF MASK, REJECT IT
                   else if (mask_in(path_row,path_col)/=1.) then
                      sample_num=iz_2-2
                      row2=nint(path_xy(iz_2-1,1)) ;col2=nint(path_xy(iz_2-1,2))
                      ! cycle loop_n_times
                      exit fillpath
                   endif

                end do
                row2=path_row ;col2=path_col
                !                write(0,*) 'hello2'  ,row2,col2
                if (mask_in(row2,col2)/=1.) then
                   sample_num=sample_num-1
                   row2=nint(path_xy(sample_num-1,1)) ;col2=nint(path_xy(sample_num-1,2))

                endif



                !                write(0,*) row2,col2
                exit fillpath
                ! IF CROSSES INNER BOUNDARY
                !                write(0,*) 'hello3'  
             else if (mask_in(path_row,path_col)==2.) then
                !                write(0,*) 'mask==2'
                if (ignore_wrapping==1.) then
                   sample_num=iz-2
                   row2=n_row ;col2=n_col
                   cycle loop_n_times ! exit fillpath  !
                end if


                ! GRAB NEAREST BOUNDARY POINT
                if (inner_bnd(n_row,n_col)/=0) then
                   boundary_index=nint(inner_bnd(n_row,n_col))
                elseif(inner_bnd(n_row+1,n_col)/=0.and.n_row+1<=nt) then
                   !   write(0,*) 'looping for boundary'
                   boundary_index=nint(inner_bnd(n_row+1,n_col))
                elseif(inner_bnd(n_row-1,n_col)/=0.and.n_row-1>=1) then
                   !   write(0,*) 'looping for boundary'
                   boundary_index=nint(inner_bnd(n_row-1,n_col))
                elseif(inner_bnd(n_row,n_col+1)/=0.and.n_col+1<=nx) then
                   !   write(0,*) 'looping for boundary'
                   boundary_index=nint(inner_bnd(n_row,n_col+1))
                elseif(inner_bnd(n_row,n_col-1)/=0.and.n_col-1>=1) then
                   !   write(0,*) 'looping for boundary'
                   boundary_index=nint(inner_bnd(n_row,n_col-1))
                else
                   write(0,*) 'did not find boundary'
                   stop
                end if
                !                write(0,*) 'boundary index',boundary_index,n_row,n_col,dist
                if (boundary_index<1.or.boundary_index>inner_bnd_n1) then
                   write(0,*) 'boundary_index is strange',boundary_index
                   stop
                end if

                ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                vec_at_new_bnd(1:2)=inner_bnd_tracker(inner_shft1,1:2) 
                row2_new_bnd=inner_bnd_tracker(inner_shft1,1) ! NEW BOUNDARY POINT
                col2_new_bnd=inner_bnd_tracker(inner_shft1,2) ! NEW BOUNDARY POINT
                row2_new_bnd_rl=real(row2_new_bnd) ; col2_new_bnd_rl=real(col2_new_bnd)

                !                write(0,*) 'vec_at_new_bnd',vec_at_new_bnd,inner_shft1
                basis_at_bnd=inner_bnd_tracker(boundary_index,3:6)
                basis_at_new_bnd=inner_bnd_tracker(inner_shft1,3:6)
                !               write(0,*) 'basis_at_bnd',basis_at_bnd,dot_product(basis_at_bnd(1:2),basis_at_bnd(3:4))
                !               write(0,*) 'basis_at_new_bnd',basis_at_new_bnd,dot_product(basis_at_new_bnd(1:2),basis_at_new_bnd(3:4))
                ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                row2_2bnd(1)=row2-n_row
                row2_2bnd(2)=col2-n_col
                found1=1

                ! PROJECT ONTO BASIS AS FIRST POINT
                xt_dist   =1*dot_product(row2_2bnd,basis_at_bnd(1:2))
                norm_dist1=1.*dot_product(row2_2bnd,basis_at_bnd(3:4))

                ! PROJECT ON NEW BASIS VECTORS TO GET NEW POINT
                row2_new =nint(vec_at_new_bnd(1)-basis_at_new_bnd(3)*norm_dist1-basis_at_new_bnd(1)*xt_dist)
                col2_new=nint(vec_at_new_bnd(2)-basis_at_new_bnd(4)*norm_dist1-basis_at_new_bnd(2)*xt_dist)
                row2_new_rl=real(row2_new) ; col2_new_rl=real(col2_new)

                ! STEP FROM POINT AT NEW BOUND TO NEW POINT TO COMPLETE PATH VECTOR
                dist2=(xt_dist**2+norm_dist1**2)**.5 

                !              write(0,*) 'dist2',dist2
                !sample_num2=dist
                !if (dist2-sample_num2<=.5) sample_num2=sample_num2-1 ! drop the last sample if it is too close to the end
                !nodes2=sample_num2+2 ! total number of nodes including end poi
                path_xy(iz,1)=row2_new_bnd_rl                 
                path_xy(iz,2)=col2_new_bnd_rl

                !             write(0,*) nint(path_xy(iz,1)),nint(path_xy(iz,2))

                iz2_rl=0.
                do iz_2=iz+1,nodes
                   iz2_rl=iz2_rl+1.
                   path_xy(iz_2,1)=((row2_new_rl-row2_new_bnd_rl)/dist2)*iz2_rl+row2_new_bnd_rl
                   path_xy(iz_2,2)=((col2_new_rl-col2_new_bnd_rl)/dist2)*iz2_rl+col2_new_bnd_rl

                   ! path_xy(iz_2,1)=((row2_new_rl-row2_new_bnd_rl)/dist2)*r+row2_new_bnd_rl
                   ! path_xy(iz_2,2)=((col2_new_rl-col2_new_bnd_rl)/dist2)*iz2_rl+col2_new_bnd_rl

                   !                   write(0,*) nint(path_xy(iz_2,1)),nint(path_xy(iz_2,2))
                   ! IF WE CROSS OUT OF MASK THEN STOP HERE AND GRAB ANOTHER POINT
                   path_row=nint(path_xy(iz_2,1)) ; path_col=nint(path_xy(iz_2,2))
                   !                   write(0,*) 'hello4'  

                   ! IF NEW POINT IS OUTSIDE OF FIGURE BOUNDS, REJECT IT
                   if (path_row<1.or.path_row>nt.or.path_col<1.or.path_col>nx) then
                      sample_num=iz_2-2
                      row2=nint(path_xy(iz_2-1,1)) ;col2=nint(path_xy(iz_2-1,2))
                      ! cycle loop_n_times
                      exit fillpath   
                      ! IF NEW POINT IS OUTSIDE OF MASK, REJECT IT
                   else if (mask_in(path_row,path_col)/=1.) then
                      sample_num=iz_2-2
                      row2=nint(path_xy(iz_2-1,1)) ;col2=nint(path_xy(iz_2-1,2))
                      ! cycle loop_n_times
                      exit fillpath
                   endif
                end do

                row2=row2_new ; col2=col2_new
                !                write(0,*) 'hello5',row2,col2,dist,dist2
                !write(0,*) 'sample_num',sample_num
                if (row2<1.or.row2>nt.or.col2<1.or.col2>nx) then
                   sample_num=sample_num-1
                   row2=nint(path_xy(iz-1,1)) ;col2=nint(path_xy(iz-1,2))
                elseif (mask_in(row2,col2)/=1.) then
                   sample_num=sample_num-1
                   row2=nint(path_xy(iz-1,1)) ;col2=nint(path_xy(iz-1,2))
                endif

                exit fillpath
             end if out_of_mask

             n_row=path_row  ! UPDATE LOCATIONS FOR BOUNDARY EXTRACTION
             n_col=path_col
             row2=path_row ; col2=path_col  ! SUSPICIOUS

          else  ! NOT WITHIN BOUNDS
             if (iz==2) cycle loop_n_times
             sample_num=sample_num-1
             row2=nint(path_xy(iz-1,1)) ;col2=nint(path_xy(iz-1,2))
             exit fillpath
          end if within_bnds

       end do fillpath

       !         write(0,*) 'here',sample_num,nodes


       ! ALLOCATE path_xy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
       ! AND path_dd TO BE THE ARRAY OF POINTS SAMPLED 
       nodes=sample_num+2 ! total number of nodes including end points
       !         write(0,*) 'pathxy',path_xy


     ! wt=calc_wt1(nt,nx,path_xy,nodes,full_image_1D,full_image,row1,col1,row2,col2,amp_thresh)
 wt=calc_wt1(nt,nx,path_xy,nodes,full_image_1D,full_image,row1,col1,row2,col2,amp_thresh)
       ! APPLY ATTRIBUTE
     !  wt=wt*(.01+.99*exp(-abs((first_attribute(row1,col1)-first_attribute(row2,col2)))/(attr_coef**2))) 
 ! wt=.4*wt+(.6*abs((first_attribute(row1,col1)-first_attribute(row2,col2)))) 

       ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
       if (wt>zero_tol)then


          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
          !write(0,*) 'lookup weight' 
          !   call look_up_wt(look_up_tab,row2,col2,icol_mat)

          icol_mat=look_up_image(row2,col2)
          isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
             val_cnt=val_cnt+1 
             val_list(val_cnt)=real(icol_mat) ! if new point, add it to the lis

             sparse_mat_index=sparse_mat_index+1
             if (sparse_mat_index>=mem_alloc) then
                write(0,*) 'did not allocate enough memory'
                stop
             end if
             col_in_row=col_in_row+1  ! a row has been added to this column

             !  call look_up_wt(look_up_tab,row1,col1,irow_mat)
             irow_mat=look_up_image(row1,col1)

             !    call look_up_wt(look_up_tab,row2,col2,icol_mat)

             if (icol_mat>=irow_mat) then
                sparse_mat(sparse_mat_index,1)=irow_mat
                sparse_mat(sparse_mat_index,2)=icol_mat
                sparse_mat(sparse_mat_index,3)=wt
             else
                sparse_mat(sparse_mat_index,1)=icol_mat
                sparse_mat(sparse_mat_index,2)=irow_mat
                sparse_mat(sparse_mat_index,3)=wt
             end if


          end if isnew


       end if
       !   end if within_bnds
deallocate(path_xy)
    end do loop_n_times


    !  end if isnew


    deallocate(norm_at_bnd,vec_at_new_bnd,norm_at_new_bnd,row2_2bnd)
    deallocate(xt_basis,xt_basis_2,yt_basis,yt_basis_2)
    deallocate(basis_at_bnd,basis_at_new_bnd) 




  end subroutine sample_model

  real function calc_wt1(nt,nx,path_xy,nodes,full_image_1D,full_image,row1,col1,row2,col2,amp_thresh)
    integer                             :: nx,ny,nt,nodes,row1,col1,row2,col2
    real                                ::amp_thresh,wt
    real, pointer, dimension(:,:)       ::path_xy,new_path_xy
    real,dimension(:)                 	::full_image_1d
    real,dimension(:,:)                 ::full_image
    real,dimension(:),allocatable	::path_dd 
    real                                ::drow,dcol
    integer                             ::row2_back,row1_back,col2_back,col1_back

    allocate(new_path_xy(nodes,2),path_dd(nodes))
    path_dd=0.
    new_path_xy=path_xy(1:nodes,1:)
    !        write(0,*) 'herea'
    ! INITIALIZE BILINEAR INTERPOLATOR
    call lint2_init(nt,nx,1.,1.,1.,1.,new_path_xy) ! o1=1 is the first model sample
    !  call lint2_init(nt,nx,0.,1.,0.,1.,new_path_xy)

    !path_dd(1)=full_image(row1,col1)
    !path_dd(2)=full_image(row2,col2)
    !        write(0,*) row2,col2,row1,col1,sample_num

    ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
    not_2_nodes1: if(nodes/=2) then
       !           write(0,*) 'hereb'


       ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
       stat1=lint2_lop(.false.,.false.,full_image_1d,path_dd)
       path_dd(1)=full_image(row1,col1) ! assign end points
       path_dd(nodes)=full_image(row2,col2)

       if (minval(path_dd(2:nodes-1))<=path_dd(1).and.minval(path_dd(2:nodes-1))<=path_dd(nodes)&
            .and.minval(path_dd(2:nodes-1))<amp_thresh) then
          wt=0.
       else
          wt=1.

          if (path_dd(1)<amp_thresh.and.path_dd(1)<minval((path_dd(2:nodes)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (row2>=row1.and.col2>=col1) then ! break only along north-east
!!$  if (row2>=row1) then ! break only along north-east
                wt=0.
             end if

          end if

          if (path_dd(nodes)<amp_thresh.and.path_dd(nodes)<minval((path_dd(1:nodes-1)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$  if (row2<=row1) then ! break only along north-east
                wt=0.
             end if

          end if




       end if

       ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
    else
       !            write(0,*) 'here2'
       path_dd(1)=full_image(row1,col1) ! assign end points
       path_dd(nodes)=full_image(row2,col2)

       if (nodes/=2) then
          write(0,*) 'weird'
          stop
       endif

       wt=1.
       drow=row1-row2
       dcol=col1-col2
       row2_back=row2-drow
       col2_back=col2-dcol

       row1_back=row1+drow
       col1_back=col1+dcol

       if (row2_back>=1.and.row2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
          if (full_image(row2_back,col2_back)>full_image(row2,col2).and.&
               full_image(row1,col1)>full_image(row2,col2).and.full_image(row2,col2)<amp_thresh) then
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$         if (row2<=row1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       if (row1_back>=1.and.row1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
          if (full_image(row1_back,col1_back)>full_image(row1,col1).and.&
               full_image(row2,col2)>full_image(row1,col1).and.full_image(row1,col1)<amp_thresh) then
             if (row1<=row2.and.col1<=col2) then ! break only along north-east
!!$    if (row1<=row2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (row2_back<1.OR.row2_back>nt.OR.col2_back<1.OR.col2_back>nx) then
          if (full_image(row1,col1)>full_image(row2,col2).and.full_image(row2,col2)<amp_thresh) then
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$   if (row2<=row1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (row1_back<1.or.row1_back>nt.or.col1_back<1.or.col1_back>nx) then
          if (full_image(row2,col2)>full_image(row1,col1).and.full_image(row1,col1)<amp_thresh) then
             if (row1<=row2.and.col1<=col2) then ! break only along north-east
!!$  if (row1<=row2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if



    end if not_2_nodes1
    calc_wt1=wt
    deallocate(path_dd)
    deallocate(new_path_xy)
    ! if (size(path_xy)>0) deallocate(path_xy,new_path_xy)
  end function calc_wt1

 
  real function calc_wt2(nt,nx,path_xy,nodes,full_image_1D,full_image,row1,col1,row2,col2,amp_thresh)
    integer                             :: nx,ny,nt,nodes,row1,col1,row2,col2
    real                                ::amp_thresh,wt
    real, pointer, dimension(:,:)       ::path_xy,new_path_xy
    real,dimension(:)                 	::full_image_1d
    real,dimension(:,:)                 ::full_image
    real,dimension(:),allocatable	::path_dd 
    real                                ::drow,dcol
    integer                             ::row2_back,row1_back,col2_back,col1_back

    allocate(new_path_xy(nodes,2),path_dd(nodes))
    path_dd=0.
    new_path_xy=path_xy(1:nodes,1:)
    !        write(0,*) 'herea'
    ! INITIALIZE BILINEAR INTERPOLATOR
    call lint2_init(nt,nx,1.,1.,1.,1.,new_path_xy) ! o1=1 is the first model sample
    !  call lint2_init(nt,nx,0.,1.,0.,1.,new_path_xy)

    !path_dd(1)=full_image(row1,col1)
    !path_dd(2)=full_image(row2,col2)
    !        write(0,*) row2,col2,row1,col1,sample_num

    ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
    not_2_nodes1: if(nodes/=2) then
       !           write(0,*) 'hereb'


       ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
       stat1=lint2_lop(.false.,.false.,full_image_1d,path_dd)
       path_dd(1)=full_image(row1,col1) ! assign end points
       path_dd(nodes)=full_image(row2,col2)

       if (minval(path_dd(2:nodes-1))<=path_dd(1).and.minval(path_dd(2:nodes-1))<=path_dd(nodes)&
            .and.minval(path_dd(2:nodes-1))<amp_thresh) then
          wt=0.
!wt=minval(path_dd(2:nodes-1))
       else
          wt=1.
!wt=minval(path_dd(2:nodes-1))
!write(0,*) wt
          if (path_dd(1)<amp_thresh.and.path_dd(1)<minval((path_dd(2:nodes)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (row2>=row1.and.col2>=col1) then ! break only along north-east
!!$  if (row2>=row1) then ! break only along north-east
                wt=0.
!wt=minval(path_dd(2:nodes-1))
             end if

          end if

          if (path_dd(nodes)<amp_thresh.and.path_dd(nodes)<minval((path_dd(1:nodes-1)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$  if (row2<=row1) then ! break only along north-east
                wt=0.
! wt=minval(path_dd(2:nodes-1))
            end if

          end if




       end if
!wt=minval(path_dd(2:nodes-1))
       ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
    else
       !            write(0,*) 'here2'
       path_dd(1)=full_image(row1,col1) ! assign end points
       path_dd(nodes)=full_image(row2,col2)

       if (nodes/=2) then
          write(0,*) 'weird'
          stop
       endif

       wt=1.
       drow=row1-row2
       dcol=col1-col2
       row2_back=row2-drow
       col2_back=col2-dcol

       row1_back=row1+drow
       col1_back=col1+dcol

       if (row2_back>=1.and.row2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
          if (full_image(row2_back,col2_back)>full_image(row2,col2).and.&
               full_image(row1,col1)>full_image(row2,col2).and.full_image(row2,col2)<amp_thresh) then
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$         if (row2<=row1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       if (row1_back>=1.and.row1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
          if (full_image(row1_back,col1_back)>full_image(row1,col1).and.&
               full_image(row2,col2)>full_image(row1,col1).and.full_image(row1,col1)<amp_thresh) then
             if (row1<=row2.and.col1<=col2) then ! break only along north-east
!!$    if (row1<=row2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (row2_back<1.OR.row2_back>nt.OR.col2_back<1.OR.col2_back>nx) then
          if (full_image(row1,col1)>full_image(row2,col2).and.full_image(row2,col2)<amp_thresh) then
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$   if (row2<=row1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (row1_back<1.or.row1_back>nt.or.col1_back<1.or.col1_back>nx) then
          if (full_image(row2,col2)>full_image(row1,col1).and.full_image(row1,col1)<amp_thresh) then
             if (row1<=row2.and.col1<=col2) then ! break only along north-east
!!$  if (row1<=row2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if



    end if not_2_nodes1
    calc_wt2=wt
    deallocate(path_dd)
    deallocate(new_path_xy)
    ! if (size(path_xy)>0) deallocate(path_xy,new_path_xy)
  end function calc_wt2




end module sample_mod
